itk::usual MOS {}

namespace eval mos {

   class MOS {

      # constructor and destructor ----------------------------------
      constructor { mc mi menu args } { }
      destructor { }
      proc MMSInit { g_can g_ima menubar control su }

      # private methods ---------------------------------------------
      private method test { }
      private method test_2 { }

      # instrument configuration ------------------------------------
      private method load_instrument { }
      private method part_load_scale { fileId line_org }
      private method part_load_fcoll { fileId line_org }
      private method part_load_array { fileId line_org }
      private method part_load_fcam { fileId line_org }
      private method part_load_foc { fileId line_org }
      private method part_load_grat { fileId line_org }
      private method load_arraysize { }; # size not loaded but calculated
      private method load_grat_filt_disp { }
      private method load_mos_refslit_info { }
      private method load_mos_refslit { }
      private method wave_limit { }

      # load and save slit configuration
      private method load_mos_TPX { filename }
      private method load_mos_adf { filename }
      private method save_mos_TPX { filename }
      private method save_mos_RS274X { filename }
      private method save_mos_PS { filename }

      # handle mask setup
      private method erase { }
      private method update_mask_na { }
      private method update_mask_id { }
      private method update_mask_naid { }
      private method extra_pick { b }
      private method mark { w xs ys }
      private method plot_tcs_label { }
      private method plot_mos_dispersion_label { oriA oriB }
      private method plot_ref_star_area { }
      private method plot_ref_star_frame { }
      private method plot_guide_star_frame { }
      private method plot_guide_star_area { }
      private method shift { w xs ys }
      private method shift_load { w xs ys }
      private method align_mask { w sx sy }
      private method rotate { w x y dir }
      private method mos_create_slit { w sx sy but {on 1} {click 1} }
      private method set_slit { id alp dec px py sldeg }
      private method reset_slits { }
      private method center_slit { }
      private method calc_ctom { }
      private method x_dist { px py g1x g1y g2x g2y }
      private method y_dist { px py g1x g1y g2x g2y }

      # bind mouse keys
      private method bind_frame { }
      private method bind_mos { }

      # format and string handling
      private method DDMMSS2deg { ddmmss }
      private method F2G { value }
      private method ldelete_all { w_list value}
      private method ldelete { list value}
      private method string_exchange { input old new }
      private method string_delete { input value }

      # catalog handling
      private method get_cat { }
      private method get_ec { mode }
      private method get_fits_name { }
      private method catalog { a_c }
      private method select_cat { sc }

      # info display
      private method warn { }
      private method warn_filtgrat { }
      private method big_status_panel { }
      private method open_log { }

      # public methods ------------------------------------------------

      # init and reset mask
      public method init_mask_world2 { }
      public method reset_mask { }
      public method update_and_replot { }
      public method update_mask { }
      public method update_color { }
      public method plot_mask { }
      public method update_scale { }

      # slit handling
      public method wave_config_mask { four }
      public method indi_slit_mos { w sx sy }
      public method delete_slit_mos { w sx sy }
      public method AutoPos_new { }
      public method anoms { }

      # save and store mask
      public method load_TPX { filename }
      public method save_TPX { }

      # project configuration
      public method config_mos { my wilepo }
      public method wave_length { }
      public method edit_ref_targ { c }
      public method edit_guide_star { c }
      public method select_mos_name { }
      public method select_set_dir { }
      public method select_filename { }

      # help and status infos
      public method help { }
      public method show_status { } { big_status_panel }

      #unit conversion
      public method arsc { }

      # error handling
      # static methods
      public proc ACTIVATE {flags_} {SET_FLAGS $flags_ 1}
      public proc DEACTIVATE {flags_} {SET_FLAGS $flags_ 0}
      public proc EXE {where_}
      public proc ERR {string_}
      public proc WARN {string_}
      public proc COMM {string_}
      public proc debg {varname_ index_ ops_ }
      private proc SET_FLAGS {flags_ val_}


      # variables ------------------------------------------------------------
      # common variables
      common inst_counter 0

      # public variables -----------------------------------------------------
      public variable badpixelmap 0
      public variable graytype 0 { if {$mask_initialized} { update_and_replot } else { update_color } }
      public variable rotangle 5; # rot step
      public variable width 200
      public variable height 200
      public variable file_name ""
      public variable calib_passwd ""
      public variable camera CAMBLUE
      public variable filter blue
      public variable grating GRATING1
      public variable modus mods
      public variable label 1
      public variable mos_shape STRAIGHT
      public variable pics 0
      public variable slit_width  0.6
      public variable slit_length 10.0
      public variable colorset Red/Yellow
      public variable int_dir  $env(MMSROOT); # mms install dir
      public variable isf_dir  $env(ISF_DIR); # load MODS.isf
      public variable log_dir  $env(LOG_DIR); # write log files 
      public variable set_dir  $env(SET_DIR); # write setup files 
      public variable prep_dir $env(PREP_DIR);# load fits files 
      public variable instrument $env(INSTR);  # MODS 


      # private variables ---------------------------------------------------------
      private variable F_N mycopy.targ
      private variable l_v
      private variable s_v
      private variable lfId
      private variable CatFileName no_catalog

      private variable m_image
      private variable m_canvas
      private variable m_mb
      private variable canvscale
      private variable EQX
      # boundary errors in slits_lengths  [mm]
      private variable s_slit 4
      # the actual position of the mask in world units
      private variable world_x
      private variable world_y
      # the initial position of the mask in world units
      private variable wx
      private variable wy
      # the cordinates of the MOS mask, a big matrix
      # mos: array/spectral limits, field: focal field
      # ifield: ID-number area
      private variable mos
      private variable field
      private variable guide
      private variable ifield
      # the cordinates of the reference objects 
      private variable ref
      # the grating-OS-filter-dispersion-array 
      private variable A_disp
      private variable good
      # the world coordinates of the 19 positioned slits
      private variable targw
      # absolute angle of the mask in rad with respect to WCS
      private variable abs_ang_rad 0.0
      private variable x_ccd 300
      # the  center of the mask (telescope pointing position on canvas)
      private variable ccx
      private variable ccy
      # initial canvas psoiton of mask = canvas center
      private variable fr_x
      private variable fr_y 
      private variable worldscale 1.7
      private variable oldpos
      private variable op

      private variable speclen 0.0
      private variable specmin 0.0
      private variable specmax 0.0

      private variable det_lmin
      private variable det_lmax
      private variable user_lmin 330.0
      private variable user_lmax 1100.0
      private variable user_lcen 590.0

      private variable XMAX_180
      private variable XMIN_180
      private variable YMAX_180
      private variable YMIN_180
      private variable XMAX_375
      private variable XMIN_375
      private variable YMAX_375
      private variable YMIN_375
      private variable XMIN
      private variable XMAX
      private variable YMIN
      private variable YMAX

      private variable mosreftp
      private variable mosrefsx
      private variable mosrefsy
      private variable mosrefwd
      private variable mosrefle
      private variable mosrefro

      private variable long_number 
      private variable mask
      private variable slit_coll
      private variable nf_refslit
      private variable cam_range
      private variable grat_range
      private variable filt_range
      private variable fwhm_range
      private variable mos_refslit_range
      private variable slit_range
      private variable exposure_counter 1
      private variable trapa gray25; # transparency slit blades
      private variable disp_string
      private variable NOG

      private variable focscale
      private variable arrscale
      private variable fcoll
      private variable fcam
      private variable acam
      private variable dgrat
      private variable igrat
      private variable rgrat

      private variable arrayscale_375; # pixel scale arcsec/pixel
      private variable arrayscale_180

      private variable FIELDSTOP_XMIN
      private variable FIELDSTOP_XMAX
      private variable FIELDSTOP_YMIN
      private variable FIELDSTOP_YMAX
      private variable PIX
      private variable NPIX_X
      private variable NPIX_Y
      private variable warn_flag 0

      # numeric arcsec_to_degree
      private variable atd 2.7777778E-4
      private variable trigo 1
      # numeric canvas_to_mm
      private variable ctom
      # fill colors
      private variable color1 red
      private variable color2 yellow
      # outline colors
      private variable color3 red
      private variable color4 yellow
 
      # bonsai matrix elements for mm-wcs
      private variable bonsai_flag
      # maximum permitted number of mos slits
      # AAG PPRS 10127
      private variable mnomos 200

      private variable lss_ref_ra
      private variable lss_ref_de
      private variable lss_sli_ra
      private variable lss_sli_de
      private variable fits_x_scale
      private variable fits_y_scale
      private variable WP
      private variable man_WP 0.0
      private variable CSO
      private variable CRO
      private variable PAM 0
      private variable tcs_pam 0
      private variable reftarg_zone 0
      private variable guidestar_zone 0

      private variable mask_initialized 0
      private variable mountangle 180
      private variable stop 0
      private variable dith_num 1
      private variable echs_flag 0 
      private variable dire_flag 0 

      private variable new_open_flag 0
      private variable old_open_flag 0

      private variable last_action  ""
      private variable last_save_fn ""
      private variable last_load_fn ""
      private variable sp_mtali 0;  # MOS10ali       only for statuspanel
      private variable sp_nort "";   # NumOfRefTarg   only for statuspanel
      private variable sp_guid "";   # NumOfGuideStars   only for statuspanel
      private variable sp_rsc 0;     # RefSlitCounter only for statuspanel
      private variable sp_mid "";    # MaskId         only for statuspanel
      private variable sp_instrume ""; # underlying fits image
      private variable sp_origin   ""; # underlying fits image

      # Error handling
      # static variables
      private common _ON
        array set _ON "x 0 e 0 w 0 c 0"
      private common _CHARS
        array set _CHARS "e * w ! c #"
      private common _INDENT ""
      private common _LEVEL 1
      private common _PAD "   "
   }
   # End of class LUC

# METHOD BODIES --------------------------------------------------------------------
#----------------------------------------------------------------------------------
   ::itcl::body MOS::constructor { mc mi menu args } {

      global env
      ACTIVATE x
      EXE begin
      set m_canvas $mc; set m_image $mi
      set m_mb $menu ;                     # external menu bar

      set l_v 1.60 ;                       # mms version
      set s_v 2.7.3
      set tcl_precision 18

      # The instrument type (MODS or MODS) and number must be known before the
      # 'load_instrument' method, since we have to load the correct instrument.isf
      # to configure the instrument. We get the type and number from the menu button.
      #
      set instrument [string toupper [lindex [split $menu .] 3] ]
      puts stdout "\nNEW MODE -->SkyCat V$s_v-->  MMS V$l_v for $instrument"

      set log_file $log_dir
      append log_file "/startup.log"
      set lfId [open $log_file w]

      [code $this load_instrument]

      # ------------------------
      eval configure $args
      # ------------------------

      # the following lines are setting the menue entries
      $m_mb.layout.ls invoke 0; # slit type STRAIGHT
      $m_mb.layout.sw invoke 1; # slit width 0.6 arcsec
      $m_mb.layout.sl invoke 4; # slit length 10 arcsec
      $m_mb.layout.fi invoke 0; # filter V
      $m_mb.layout.gr invoke 0; # grating 1
      $m_mb.layout.sh invoke 0; # blue camera
      $m_mb.layout invoke 12;   # labels on
      $m_mb.layout.rs invoke 5; # 5 deg rotation speed
      $m_mb.layout.cs invoke 0; # color scheem yellow/red


      # if reference pixel is outside the image this can happen when using midas:
      # EXTRACT/IMA mask is centered to frame (pixel) center
      #
      # default telecope pointing == mask center == FITS header WCS reference pixel for WCS
      #
      set center 0;                            # reference pixel inside image
      set fr_x [$m_image fits get CRPIX1];     # reference pixel number on x-axis of array
      set fr_y [$m_image fits get CRPIX2]
      # puts "reference  pixel = $fr_x $fr_y"
      if {$fr_x > [$m_image fits get NAXIS1] || $fr_y > [$m_image fits get NAXIS2]} {
         set center 1;                         # reference pixel outside image
         set fr_x [expr $width/2]
         set fr_y [expr $height/2]
         puts stdout "Warning: reference pixel outside frame: $fr_x $fr_y"
      }

      # read the equinox (2000 or 1950) from fits frame, read WCS at reference pixel
      set EQX [$m_image fits get EQUINOX]
      if { $EQX == "" } {
        set EQX [lindex [$m_image wcsset] 8 ]
        puts "Constructor Warning: EQUINOX not defined in fits-header! \n
              EQX from wcsset = $EQX"
      }
      set world_x [$m_image fits get CRVAL1];   # RA of reference pixel
      set world_y [$m_image fits get CRVAL2];   # DEC of reference pixel

      # frameless mode, at least no image is loaded
      if {$world_x=="" || $world_y==""} {
         set wx [lindex [$m_image wcsset] 0]
         set wy [lindex [$m_image wcsset] 1]
         if [catch { $m_image convert coords $wx $wy "wcs $EQX" \
                   world_x world_y "deg $EQX" } result ] {
           info_dialog "No Frame Loaded\n\No Catalog Loaded" .skycat1
           set world_x 100; set world_y 100
         }
      }

      if {$center} {
         puts "FLAG center"
         # reference pixel outside frame, take frame center
         $m_image convert coords $fr_x $fr_y image world_x world_y "deg $EQX"
         puts stdout "Warning: WCS reference pixel outside frame : recenter to     $world_x  $world_y"
      }

      set wx $world_x; set wy $world_y
      # reference pixel only used in the zemax Method 
      set ccx $fr_x;   set ccy $fr_y

      # initial mask scale taken from fits header if fits from MODS itself
      # this has to be modified for MODS/MODS data !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      # for the status panel 
      set sp_instrume [$m_image fits get INSTRUME]
      set sp_origin   [$m_image fits get ORIGIN]

      mos::MOS_SLIT::fc $focscale;                    # copy the current image scale to mos class

      set exposure_counter [get_ec [$this cget -modus] ]
      # set exposure_counter mos;                                # the MMS internal exposure counter will be part of the setup file .mms
      $this configure -file_name [ get_fits_name ];              # the initial projectname is taken from the fits filename
      mos::REF_TARG C_ref_targ $m_canvas $m_image -eqx $EQX;     # create an instance of the reference target class
      mos::GUIDE_STAR C_guide_star $m_canvas $m_image -eqx $EQX;     # create an instance of the reference target class
      mos::MOS_SLIT::label [$this cget -label]
      mos::CONV_MC C_mc -eqx $EQX;                    # create an instance of the coord conversion class
      mos::CONV_WC C_wc -m_image $m_image -eqx $EQX;  # create an instance of the coord conversion class WCS - canvas coords
      [code $this init_mask_world2 ];                 # create a mask at the initial WCS position with default parameters
      [code $this plot_mask];                         # plot the mask on the canvas
      [code $this bind_frame];                        # start the basic bindings : move and rotate the mask
      [code $this update_scale];                      # update canvas scale

      open_log;  # open a  new log file
      load_mos_refslit
      # test

      puts stdout "constructor: mask initialized"
      set last_action "Enter MOS"
      catch {SP update}
      EXE end

   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::destructor { } {

      global imageName
      EXE begin
      erase;                         # delete drawings from the canvas
      puts $lfId ">>> Quit Mode <<"
      close $lfId;                   # close the log file
      delete object C_ref_targ
      delete object C_guide_star
      delete object C_wc
      delete object C_mc

      if {$pics}     {$m_mb.layout invoke 14}
      if {$graytype} {$m_mb.layout invoke 11}

      foreach BUT { 0 1 2} { $m_mb.layout.gr entryconfigure $BUT  -state normal }

      set noms [mos::MOS_SLIT::nos]
      if {$noms>0} {
         for {set i 1} {$i <= $noms} { incr i 1} { delete object C_mos$i }
      }

      set last_action "Quit MOS"
      catch {SP update}
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::MMSInit { g_can g_ima menubar control su } {
      # g_can canvas name
      # g_ima = image name
      # control=0 delete current instance
      #        =1 create the only instance
      # su=0/1 super user privileges
      # menubar widget to dis/en able menubar buttons

      EXE begin

      if {$control & !$inst_counter} {
        global ::my_mask
        mos::MOS my_mask $g_can $g_ima $menubar \
           -instrument [string toupper [lindex [split $menubar .] 3] ]\
           -rotangle 5 \
           -width [$g_ima width] \
           -height [$g_ima height] \
           -label $su \
           -pics 0 \
           -graytype 0 \
           -colorset Red/Yellow
        incr inst_counter 1

      } elseif {!$control & $inst_counter} {
        delete object my_mask
        incr inst_counter -1
      } else {
      }
      EXE end
   }


#------------------------------ INSTRUMENT CONFIGURATION -----------------------------------------------------------------------
#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_instrument { } {
      # Open the instrument summary file, reads available configuration and sets relevant variables
      # Open MODS.isf in the $ISF_DIR directory

      EXE begin
      set debug 0
      if {$debug} {
         puts "Executing load_instrument ..."
         puts stdout "load [$this cget -instrument].isf"
      }
      set myfile "$isf_dir/[$this cget -instrument].isf" 
      set keyval VALUE
      set keyran RANGE

      set filt_range   "";  # filter range
      set grat_range   "";  # grating range (normal dispersion)
      set slit_range   "";  # long slit range
      set cam_range    "";  # camera range

      if {[file exists $myfile] & [file readable $myfile]} {
         set fileId [open $myfile r ]
         puts $lfId "MOS::load_instrument  $fileId"
         # as long as there are lines in the file
         set i 1
         while {[gets $fileId line_org] >= 0} {
              if {[string match #* $line_org]} {
                 # ignore comment lines
              } else {

      # ---------------------------
      # PART-1 load telescope and instrument parameters
      # ---------------------------
                if {[string match *$keyval* $line_org]==1} {
                   switch -glob -- $line_org {
                        *FOCSCALE*  { part_load_scale $fileId $line_org }
                        *FOCFIELD*  { part_load_foc   $fileId $line_org }
                        *PIXEL*     { part_load_array $fileId $line_org }
                        *CAM*       { part_load_fcam  $fileId $line_org }
                        *COLL*      { part_load_fcoll $fileId $line_org }
                        *GRAT*      { part_load_grat  $fileId $line_org }
                   }
                }
      # ---------------------------
      # PART-2 load setup ranges
      # ---------------------------
                if {[string match *$keyran* $line_org]==1} {
                   switch -glob -- $line_org {
                     *FILT*    { set filt_range [lrange [split $line_org \" ] 1 1]
                                 set ls [expr [string length $filt_range] -2]
                                 set filt_range [string range $filt_range 1 $ls]
                                 set filt_range [split $filt_range  " "]
                               }
                     *GRAT*    { set grat_range [lrange [split $line_org \" ] 1 1]
                                 set ls [expr [string length $grat_range] -2]
                                 set grat_range [string range $grat_range 1 $ls]
                                 set grat_range [split $grat_range  " "]
                               }
                     *CAM*     { set cam_range [lrange [split $line_org \" ] 1 1]
                                 set ls [expr [string length $cam_range] -2]
                                 set cam_range [string range $cam_range 1 $ls]
                                 set cam_range [split $cam_range  " "]
                                 if {$debug} { puts "cam_range = $cam_range" }
                               }
                   }
                }
              }
         }

         if {$debug} { puts "load_instrument: file $fileId closed" }
         close $fileId
      } else {
         puts $lfId "Warning:$myfile: does not exist or has no read permission"
         puts stdout "Warning:$myfile: does not exist or has no read permission"
      }

      # ---------------------------
      # PART-3 load dispersion array
      # ---------------------------
      load_grat_filt_disp

      puts $lfId "  filt_range = $filt_range"

      set a [expr [llength $filt_range] -1 ]
      # last filter 'none' has not entries in fwhm and lamcent
      for {set i 0} {$i < $a} {incr i 1} {
         puts $lfId [format "%2d %18s" $i [lindex $filt_range $i] ]
      }

      puts $lfId "  slit_range = $slit_range"
      puts $lfId "   cam_range = $cam_range"

      # configure the menu buttons according for MODS.isf
      set num 0;          # camera
      foreach i $cam_range {
        $m_mb.layout.sh entryconfigure $num -label $i -variable cam -value $i
        incr num 1
      }

      set num 0;            # order separation filter
      foreach i $filt_range {
        $m_mb.layout.fi entryconfigure $num -label $i -variable fi -value $i
        incr num 1
      }

      set num 0;            # grating
      foreach i $grat_range {
        $m_mb.layout.gr entryconfigure $num -label $i -variable gr -value $i
        incr num 1
      }

      # there are num gratings
      set NOG $num

      load_arraysize
      load_mos_refslit_info
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::part_load_scale { fileId line_org } {

      # Written 2007 09 10, R.H.
      # Reads telescope focal scale, keyword 'FOCSCALE'
      EXE begin
      set debug 0
      set line [split $line_org \"]
      set pattern [lrange $line 1 1]
      set focscale $pattern
      if {$debug} {puts "part_load_scale: focsacle = $focscale"}
      EXE end

   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::part_load_fcoll { fileId line_org } {

      # Written 2007 09 10, R.H.
      # Reads collimator focal length, keyword 'COLLFOCUS'
      EXE begin
      set debug 0
      set line [split $line_org \"]
      set pattern [lrange $line 1 1]
      set fcoll $pattern
      if {$debug} {puts "part_load_fcoll: fcoll = $fcoll"}
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::part_load_array { fileId line_org } {
      # Written 2007 09 10, R.H.
      # Reads pixel size in mm, and number of pixels, we assume a square array, keywords 'PIXEL' and 'ARRAYX'
      # get pixel size
      EXE begin
      set debug 0
      set line [split $line_org \"]
      set pattern [lrange $line 1 1]
      set PIX $pattern

      # get pixels in x
      gets $fileId line_org
      set line [split $line_org \"]
      set pattern [lrange $line 0 0]
      if { [string match *ARRAY_X* $pattern] == 1} {
         set NPIX_X [lrange $line 1 1]
      } else {
         puts "part_load_array: NPIX_X undefined !!!!!"
      }

      # get pixels in y
      gets $fileId line_org
      set line [split $line_org \"]
      set pattern [lrange $line 0 0]
      if { [string match *ARRAY_Y* $pattern] == 1} {
         set NPIX_Y [lrange $line 1 1]
      } else {
         puts "part_load_array: NPIX_Y undefined !!!!!"
      }
      if {$debug} { puts "part_load_array: pixel size: $PIX, nx: $NPIX_X, ny: $NPIX_Y" }
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::part_load_fcam { fileId line_org } {

      # Written 2007 09 10, R.H.
      # Reads camera focal lengths, keywords are 'CAM375' and 'CAM180'
      EXE begin
      set debug 0

      set keyf FOCUS
      set keya ANGLE
      set f {0 fcam_180 1 fcam_375}
      set a {0 acam_180 1 acam_375}
      array set fcam $f
      array set acam $a

      # read camera focal lengths
      if {[string match *$keyf* $line_org] == 1} {
          set line [split $line_org \"]
          set line [lindex $line 1]
          lassign $line fcam(0) fcam(1)
      }

      gets $fileId line_org
      if {[string match *$keya* $line_org] == 1} {
         set line [split $line_org \"]
         set line [lindex $line 1]
         lassign $line acam(0) acam(1)
      }

      if {$debug} {
         puts "part_load_fcam: fcam(0) = $fcam(0), fcam(1) = $fcam(1)"
         puts "part_load_fcam: acam(0) = $acam(0), acam(1) = $acam(1)"
      }
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::part_load_grat { fileId line_org } {

      # Written 2008 09 08, R.H.
      # Reads grating parameters
      EXE begin
      set debug 0

      set keyd GRATCONST
      set keyi GRATINCID
      set keyr GRATREFLE
 #     set const {0 d_g1 1 d_g2 2 d_g2}
      set const {0 d_g1 1 d_g2 2 d_g3 3 d_g4}
      set incid {0 i_g1 1 i_g2 2 i_g3 3 i_g4}
      set refle {0 r_g1 1 r_g2 2 r_g3 3 r_g4}
      array set dgrat $const
      array set igrat $incid
      array set rgrat $refle

      # read grating constants
      if {[string match *$keyd* $line_org] == 1} {
          set line [split $line_org \"]
          set line [lindex $line 1]
          lassign $line dgrat(0) dgrat(1) dgrat(2) dgrat(3)
      }

      # read angles of incidence
      gets $fileId line_org
      if {[string match *$keyi* $line_org] == 1} {
         set line [split $line_org \"]
         set line [lindex $line 1]
         lassign $line igrat(0) igrat(1) igrat(2) igrat(3)
      }

      # read reflexion angles
      gets $fileId line_org
      if {[string match *$keyr* $line_org] == 1} {
         set line [split $line_org \"]
         set line [lindex $line 1]
         lassign $line rgrat(0) rgrat(1) rgrat(2) rgrat(3)
      }

      if {$debug} {
         puts "part_load_grat: grating constants (muem): $dgrat(0), $dgrat(1), $dgrat(2) dgrat(3)"
         puts "part_load_grat: angles of incidence (deg): $igrat(0), $igrat(1), $igrat(2) igrat(3)"
         puts "part_load_grat: angles of reflexion (deg): $rgrat(0), $rgrat(1), $rgrat(2) rgrat(3)"
      }
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::part_load_foc { fileId line_org } {
      # Modified 2007 09 12, R.H.
      # SR/HR removed, the focfield is defined by the clear mask area, independent of camera

      # The current line, just read from MODS.isf contains the keyword 'FOCFIELD'.
      # Hence we read the ISF further on and set the focal field ranges
      EXE begin
      set debug 0

      set blank " "
      for {set i 1} {$i < 3} { incr i 1} {
         # read one more lines
         set line [split $line_org \" ]
         set pattern [lrange $line 1 1];            # e.g. -75.0 75.0
         set keyword [lrange $line 0 0];            # e.g. FOCFIELDXRANGE.VALUE
         set keyword [split $keyword \. ];          # e.g. FOCFIELDXRANGE VALUE
         set keyword [lrange $keyword 0 0];         # e.g. FOCFIELDXRANGE
         set keyword [string range $keyword 2 [string length $keyword]]

         if {[string match *$blank* $pattern]==1} {
            set a [string length $pattern]
            incr a -2
            # extract { and }
            set subpat [string range $pattern 1 $a]
            set subpat [split $subpat $blank ]
            set part1 [lrange $subpat 0 0]
            set part2 [lrange $subpat 1 1]
            if {[string match *XRANGE* $keyword]==1} {
               set XMIN $part1; set XMAX $part2
               if {$XMIN > $XMAX} {
                  set dummy $XMIN
                  set XMIN $XMAX
                  set XMAX $dummy
               }
            }
            if {[string match *YRANGE* $keyword]==1} {
               set YMIN $part1; set YMAX $part2
               if {$YMIN > $YMAX} {
                  set dummy $YMIN
                  set YMIN $YMAX
                  set YMAX $dummy
               }
            }
            # read one more line
            gets $fileId line_org
         }
      }

      puts $lfId "X $XMIN $XMAX"
      puts $lfId "Y $YMIN $YMAX"
      if {$debug} {
         puts "part_load_foc: X $XMIN $XMAX"
         puts "part_load_foc: Y $YMIN $YMAX"
      }
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_arraysize { } {

      # Written 2007 09 12, R.H.
      # Calculates the size of the array projection to the FP in mm
      EXE begin
      set ldet_x [expr $PIX*$NPIX_X]
      set ldet_y [expr $PIX*$NPIX_Y]
      set l18_x  [expr $ldet_x*$fcoll/2./$fcam(0)]
      set l18_y  [expr $ldet_y*$fcoll/2./$fcam(0)]
      set l37_x  [expr $ldet_x*$fcoll/2./$fcam(1)]
      set l37_y  [expr $ldet_y*$fcoll/2./$fcam(1)]

      set XMIN_180 [expr -$l18_x]
      set XMAX_180 $l18_x
      set YMIN_180 [expr -$l18_y]
      set YMAX_180 $l18_y

      set XMIN_375 [expr -$l37_x]
      set XMAX_375 $l37_x
      set YMIN_375 [expr -$l37_y]
      set YMAX_375 $l37_y

      EXE end
  }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_grat_filt_disp { } {
      # reading the grating-filter dispersion array from the instrument summnary file
      EXE begin
      set debug 0

      set disp_string ""
      set gratfile "$isf_dir/[$this cget -instrument].isf"
      set pattern1  GRAT*.FILT*
      set counter 0

      if {[file exists $gratfile] & [file readable $gratfile]} {
         set fileId [open $gratfile r ]
         puts $lfId "MOS::load grating :  $fileId"
         while {[gets $fileId line_org] >= 0} {
           if {[string match #* $line_org]} {
              # comment line, do nothing
           } else {
              if {[string match $pattern1 $line_org]==1} {
                 set line [split $line_org \" ]
                 set pat [lindex $line 1]
                 lassign $pat l_filt l_order l_cen l_min l_max
                 incr counter 1

                 set A_disp($counter,filter) $l_filt
                 set A_disp($counter,order) $l_order
                 set A_disp($counter,cen)  $l_cen
                 set A_disp($counter,min) $l_min
                 set A_disp($counter,max) $l_max

                 set pat [lindex $line 0]
                 set b [split $pat \. ]
                 set b [lindex $b 0]
                 set b [string trimleft $b "GRAT"]
                 set pat [split $grat_range " " ]
                 # puts stdout ">$pat<"
                 set pat [lindex $pat [expr $b-1] ]
                 set A_disp($counter,grating) $pat
                 set A_disp(0) $counter
                 append disp_string [format "%-2d   "  $counter ]
                 append disp_string [format "%-10s  "  $A_disp($counter,grating)  ]
                 append disp_string [format "%-10s  "  $A_disp($counter,filter) ]
                 append disp_string [format "%-2d   " $A_disp($counter,order) ]
                 append disp_string [format "%-4.0f   "   $A_disp($counter,cen) ]
                 append disp_string [format "%-4.0f   "   $A_disp($counter,min) ]
                 append disp_string [format "%-4.0f   \n" $A_disp($counter,max) ]
              }
           }
         }
         close $fileId

         if {$debug} { puts ">disp_string< \n$disp_string \n" }

         if {$debug} {puts stdout "$counter grating-filter combinations read from [$this cget -instrument].isf\n" }
         puts $lfId  "$counter grating-filter combinations read from [$this cget -instrument].isf\n"
      } else {
         puts $lfId  "could not read $gratfile = [$this cget -instrument].isf\n"
         puts stdout "could not read $gratfile = [$this cget -instrument].isf\n"
      }

      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_mos_refslit_info { } {

      # loads reference slit data from the isf file
      EXE begin
      set isf_file "$isf_dir/[$this cget -instrument].isf"
      if {[file exists $isf_file] & [file readable $isf_file]} {
         set fileId [open $isf_file r ]
         set patternTP MOSREFTP*.RANGE*
         set patternSX MOSREFSX*.RANGE*
         set patternSY MOSREFSY*.RANGE*
         set patternWD MOSREFWD*.RANGE*
         set patternLE MOSREFLE*.RANGE*
         set patternRO MOSREFRO*.RANGE*

         while {[gets $fileId line_org] >= 0} {
            if {[string match #* $line_org]} {
               # comment line, do nothing
            } else {
              if {[string match $patternTP $line_org]==1} {
                  set line [split $line_org \" ]
                  set pat [lindex $line 1]
                  set nf_refslit [llength $pat]
                  for {set i 0} {$i < [llength $pat]} {incr i} {
                     set mosreftp($i) [lindex $pat $i]
                  }
              }

              if {[string match $patternSX $line_org]==1} {
                 set line [split $line_org \" ]
                 set pat [lindex $line 1]
                 for {set i 0} {$i < [llength $pat]} {incr i} {
                   set mosrefsx($i) [lindex $pat $i]
                 }
              }

              if {[string match $patternSY $line_org]==1} {
                 set line [split $line_org \" ]
                 set pat [lindex $line 1]
                 for {set i 0} {$i < [llength $pat]} {incr i} {
                   set mosrefsy($i) [lindex $pat $i]
                 }
              }

              if {[string match $patternWD $line_org]==1} {
                 set line [split $line_org \" ]
                 set pat [lindex $line 1]
                 for {set i 0} {$i < [llength $pat]} {incr i} {
                     set mosrefwd($i) [lindex $pat $i]
                 }
              }

              if {[string match $patternLE $line_org]==1} {
                 set line [split $line_org \" ]
                 set pat [lindex $line 1]
                 for {set i 0} {$i < [llength $pat]} {incr i} {
                    set mosrefle($i) [lindex $pat $i]
                 }
              }

              if {[string match $patternRO $line_org]==1} {
                 set line [split $line_org \" ]
                 set pat [lindex $line 1]
                 for {set i 0} {$i < [llength $pat]} {incr i} {
                    set mosrefro($i) [lindex $pat $i]
                 }
              }
            }
        }
      }
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_mos_refslit { } {

      EXE begin
      for {set i 0} { $i < $nf_refslit} {incr i} {
          set ff [list $XMIN $XMAX]
          mos::MOS_SLIT::set_mmff 1
          set noms [mos::MOS_SLIT::nos]
          set a [mos::MOS_SLIT C_mos[incr noms 1] \
             $m_canvas $m_image $mosrefsx($i) $mosrefsy($i) \
             -ff $ff \
             -eqx $EQX \
             -target_name "refslit" \
             -slit_width  $mosrefwd($i) \
             -slit_length $mosrefle($i) \
             -pos_ang     $mosrefro($i)  \
             -ref_slit    1 \
             -shape $mosreftp($i) \
             -ON 1 \
             -child $this ]
      }
      set nf_refslit  [mos::MOS_SLIT::nos]
      mos::MOS_SLIT::set_mmff 0
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::wave_limit { } {

      # Modified R.H. 2007 09 04
      # setting of user_lmin and user_lmax re-defined
      # added user-defined central wavelength user_lcen required for MODS to position the gratings
      # 09 05: camera dependent scale added
      # 09 10: user_lcen added, scale calculation for N375 and N180 
      # cameras implemented

      # 'good' is the index of the dispersion table A_disp, which  was calculated by public variables filter and grating
      EXE begin
      set debug 0

      set ins_lmin $A_disp($good,min)
      set ins_lmax $A_disp($good,max)
      set ins_lcen $A_disp($good,cen)
      set ins_order $A_disp($good,order)
      set ins_grat $A_disp($good,grating)
      set G1 GRATING1
      set G2 GRATING2
      set G3 GRATING3
      set G4 GRATING4
      set cam [$this cget -camera]
      if {$debug} {puts "\n wave_limit \n good = $good, cam = $cam, grating = $ins_grat, order = $ins_order \n"}

      set cdr 0.017453293;                    # conversion degrees to radian
      set crd 57.29577951;                   # conversion radian to degrees

      # 'ins_lmax' and 'ins_lmin' are the wavelength limits from the filters
      # user_lmin, user_lcen, user_lmax are the user-defined wavelengths

      if {$user_lmin < $ins_lmin} { 
          set user_lmin $ins_lmin
          info_dialog "Lower Wavelength Limit Out Of Filter Range \n Default Value Will Be Used!" .skycat1
      }
      if {$user_lmax > $ins_lmax} { 
         set user_lmax $ins_lmax
         info_dialog "Upper Wavelength Limit Out Of Filter Range \n Default Value Will Be Used!" .skycat1
      }
      if {$user_lcen < $user_lmin || $user_lcen > $user_lmax} {
         set user_lcen [expr ($user_lmax + $user_lmin)/2.]
         info_dialog "Center Wavelength Out Of Filter Range \n Default Value Will Be Used!" .skycat1
      }

      # select angular width suspended by array, and calculate array scale
      if {[string match *BLUE* $cam]} {
            set icam 0
         } elseif {[string match *RED* $cam]} {
            set icam 1
         } else {
            puts "ERROR: undefined CAMERA"
            return
      }
      set arrscale [expr $focscale*$fcoll/$fcam($icam)]

      # coefficients for solving tilt equation
      if {[string match $G1 $ins_grat] == 1} {
         set m $ins_order;                  # grating order
         set lc [expr $user_lcen/1000.];    # central wavelength
         set vor [expr $dgrat(0)/$m];       # grating constant
         set in [expr $igrat(0) * $cdr];
         set out [expr $rgrat(0) * $cdr]
      } elseif {[string match $G2 $ins_grat] == 1} {
         set m $ins_order;                  # grating order
         set lc [expr $user_lcen/1000.];    # central wavelength
         set vor [expr $dgrat(1)/$m];       # grating constant
         set in [expr $igrat(1) * $cdr];
         set out [expr $rgrat(1) * $cdr]
      } elseif {[string match $G3 $ins_grat] == 1} {
         set m $ins_order;                  # grating order
         set lc [expr $user_lcen/1000.];    # central wavelength
         set vor [expr $dgrat(2)/$m];       # grating constant
         set in [expr $igrat(2) * $cdr];
         set out [expr $rgrat(2) * $cdr]
      } elseif {[string match $G4 $ins_grat] == 1} {
         set m $ins_order;                  # grating order
         set lc [expr $user_lcen/1000.];    # central wavelength
         set vor [expr $dgrat(3)/$m];       # grating constant
         set in [expr $igrat(3) * $cdr];
         set out [expr $rgrat(3) * $cdr]
      } else { puts "wave_limit: grating not found" }
      if {$debug} { puts [format "lc = %6.3f mue, m = %2d, vor = %6.3f, in = %6.3f rad, out = %6.3f rad" $lc $m $vor $in $out ] }

      set A [expr $lc / $vor ]
      set B [expr sin($in) + sin($out) ]
      set C [expr cos($in) + cos($out) ]
      set a [expr $B*$B + $C*$C]
      set b [expr -2.0 * $A*$C]
      set c [expr $A*$A - $B*$B]
      if {$debug} { puts [format "a = %7.4f, b = %7.4f, c = %7.4f" $a $b $c ] }

      # calculate grating tilt for user_lcen
      set sin_tilt [expr (-$b - sqrt($b*$b - 4.0*$a*$c))/(2.0*$a)]
      set rad_tilt [expr asin($sin_tilt)]
      if {$debug} {puts [format "tilt in rad = %7.4f" $rad_tilt ] }
   #   if {abs($rad_tilt) > 0.0873} {
   #      puts "ERROR: grating tilt out of range"
   #      set w5 [expr 5.0 * $cdr ]
   #      set lund [ expr $vor * 1000. * (sin($in - $w5) + sin($out - $w5)) ]
   #      set lob  [ expr $vor * 1000. * (sin($in + $w5) + sin($out + $w5)) ]
   #      info_dialog " Grating Tilt Too Large! \n Center Wavelength Should Be Between $lund And $lob nm \n \
   #                    Enter New Value" .skycat1
   #      return
   #   }

      # calculate lmin and lmax (nanometer) imaged on detector
      set det_lmin [expr 1000. * $vor * (sin($in + $rad_tilt) + sin($out + $rad_tilt - $acam($icam)))]
      set det_lmax [expr 1000. * $vor * (sin($in + $rad_tilt) + sin($out + $rad_tilt + $acam($icam)))]
      set deg_tilt [expr $rad_tilt * $crd]
      if {$debug} {puts [format "Kamera: $cam \nGitter Tilt: %6.3f deg \ndet_lmin: %4.0f nm\ndet_lmax: %4.0f nm" $deg_tilt $det_lmin $det_lmax ] }

      # slit position angle for which full spectrum (user_lmin to user_lmax) fits on array.
      set sin_sum [expr $user_lmin/$vor/1000. - sin($out + $rad_tilt - $acam($icam))]
      set sum [expr asin($sin_sum)]
      set gamma [expr $sum - $in - $rad_tilt]
      set specmin [expr $fcoll * tan($gamma)]
      if {$debug} {puts [format "gamma = %6.3f deg, specmin = %6.3f mm" [expr $gamma*$crd] $specmin ] }

      set sin_sum [expr $user_lmax/$vor/1000. - sin($out + $rad_tilt + $acam($icam))]
      set sum [expr asin($sin_sum)]
      set gamma [expr $sum - $in - $rad_tilt]
      set specmax [expr $fcoll * tan($gamma)]
     # quick hack for MODS: [pm] 
     # set specmin [expr $ins_lmin] 
     # set specmax [expr $ins_lmax] 
     # set det_lmin [expr $ins_lmin] 
     # set det_lmax [expr $ins_lmax] 

      if {$debug} { puts [format "gamma = %6.3f, specmax = %6.3f" [expr $gamma*$crd] $specmax ] }

      set id1 [ format ">> Filter Range: %4.0f < %4.0f < %4.0f \n" $ins_lmin  $ins_lcen  $ins_lmax ]
      set id2 [ format ">> User Range: %4.0f < %4.0f < %4.0f \n"   $user_lmin $user_lcen $user_lmax ]
      set id3 [ format ">> Detector Range: %4.0f < %4.0f \n"     $det_lmin $det_lmax ]
      set id4 [ format ">> Grating: %s, Filter: %s \n" [$this cget -grating] [$this cget -filter] ]

      set mess " $id1 $id2 $id3 $id4 "
      if {$debug} { puts stdout $mess }

      EXE end
   }


#--------------------------------------------- handle mask setup -----------------------------------------------------------------------------------------
#----------------------------------------------------------------------------------
   ::itcl::body MOS::erase { } {

      EXE begin
      $m_canvas delete $this -tag A
      $m_canvas delete $this -tag D
      $m_canvas delete $this -tag REFTARG
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::update_mask_na { } {

      EXE begin
      set na M[format "%03d" $exposure_counter][$this cget -file_name]
      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]
      catch { mos::MOS_SLIT::set_MASK_NAID "$na [lindex $PM 1]" }
      catch {SP update}
      EXE end
  }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::update_mask_id { } {

      EXE begin
      set old_id [exec date -u +%H%M%S]
      set l [string length $old_id]
      set id "5"
      for { set i 1 } { $i < $l } { incr i 1 } { append id [string index $old_id $i] }
      if {$id < 500100} {
        # oh, its accidently a (forbidden) technical mask number
        set id [expr $id + 1000]
      }

      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]
      catch { mos::MOS_SLIT::set_MASK_NAID "[lindex $PM 0] $id" }
      catch {SP update}
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::update_mask_naid { } {

      # this is called when a project name is specified
      EXE begin
      set na M[format "%03d" $exposure_counter][$this cget -file_name]
      set old_id [exec date -u +%H%M%S]
      set l [string length $old_id]
      set id "9"
      for { set i 1 } { $i < $l } { incr i 1 } { append id [string index $old_id $i] }
      if {$id < 500100} {
         # oh, its accidently a (forbidden) technical mask number
         set id [expr $id + 1000]
      }

      catch { mos::MOS_SLIT::set_MASK_NAID "$na $id" }
      catch {SP update}
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::extra_pick { b } {

      # split the result string of PickObject and copy values to globals for further processing
      # puts stdout "in extra_pick output of PickObject =\n >>$b<<"
      EXE begin
      set b [split $b " " ]
      # puts stdout "extra_pick : $b"
      if {[lindex $b 5]>0} {
         # successfull center gauss
         set lss_sli_ra [lindex $b 0]
         set lss_sli_de [lindex $b 1]
         # puts stdout "center slit ok"
      } else {
         # puts stdout "center slit ### failed ###"
      }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::mark { w xs ys } {

      # mark mask pointing
      EXE begin
      $m_image convert coords $xs $ys screen oldpos(x) oldpos(y) canvas
      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_tcs_label { } {

      EXE begin
      set debug 0
      # extra coords and PA in the upper left corner
      $m_image convert coords $world_x $world_y "deg $EQX" lwx lwy "wcs $EQX"
      $m_image convert coords 10 20 screen px20 py20 canvas
      if {$debug} { puts "canvas coords: $px20, $py20" }
      $m_canvas create text $px20 $py20 -fill $color4 -text "ROT = $tcs_pam" -anchor w -tag {D}
      $m_canvas create text $px20 [expr $py20 +20] -fill $color4 -text "RA = $lwx" -anchor w -tag {D}
      $m_canvas create text $px20 [expr $py20 +40] -fill $color4 -text "DEC = $lwy" -anchor w -tag {D}

      if {$pics} {
         $m_canvas create text $px20 [expr $py20 +60] -fill $color4 -text ">CENTER<" -anchor w -tag {D}
      }

      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_mos_dispersion_label { oriA oriB } {

      # Modified R.H. 2007 09 05
      # A replaced by mue
      # Modified 09 06: For N3.75 mode: lines red if spectral range too wide
      # Modified 09 10: A_disp( ,cen) replaced by user_lcen. Actual wavelength range on array is displaid

      EXE begin
      if { [string match none [$this cget -grating]] || [string match none [$this cget -filter]] } { return }

      if {[string match *BLUE* [$this cget -camera] ]} {
         # blue channel 
         $m_canvas create text [expr $mos(xh) - 15] [expr $mos(yh) + 15] \
               -anchor $oriA -fill $color4 \
               -text [format "%5.3fmue" [expr $det_lmin/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xg) + 15] [expr $mos(yg) + 15] \
               -anchor $oriB -fill $color4 \
               -text [format "%5.3fmue" [expr $det_lmax/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xer) - 15] [expr $mos(yer) - 15]\
               -anchor $oriA -fill $color4 \
               -text [format "%5.3fmue" [expr $user_lcen/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xfr) + 15] [expr $mos(yfr) - 15] \
               -anchor $oriB -fill $color4 \
               -text [format "%5.3fmue" [expr $user_lcen/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xe) + 15] [expr $mos(ye) - 15] \
              -anchor n -fill $color4 -text Array -tag "A"

         # allowed ranges, red if no solution
         set farbe blue
         set x1 [expr $mos(xe) - $mos(xer)]; set y1 [expr $mos(ye) - $mos(yer)]
         set x2 [expr $mos(xe) - $mos(xfr)]; set y2 [expr $mos(ye) - $mos(yfr)]
         set a1 [expr $x1 * $x1 + $y1 * $y1]
         set a2 [expr $x2 * $x2 + $y2 * $y2]
         if { $a1 > $a2 } { set farbe red }
         $m_canvas create line $mos(xfr) $mos(yfr) $mos(xg) $mos(yg) \
               -fill $farbe -width 1  -stipple "" -tag {A N1}
         $m_canvas create line $mos(xgr) $mos(ygr) $mos(xf) $mos(yf) \
               -fill $farbe -width 1  -stipple "" -tag {A N1}
         $m_canvas create line $mos(xer) $mos(yer) $mos(xh) $mos(yh) \
               -fill $farbe -width 1  -stipple "" -tag {A N1}
         $m_canvas create line $mos(xhr) $mos(yhr) $mos(xe) $mos(ye) \
	      -fill $farbe -width 1  -stipple "" -tag {A N1}
      } else {
         # red channel 
         $m_canvas create text [expr $mos(xd) - 15] [expr $mos(yd) + 15] \
               -anchor $oriA -fill $color4 \
               -text [format "%5.3fmue"  [expr $det_lmin/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xc) + 15] [expr $mos(yc) + 15]\
               -anchor $oriB -fill $color4 \
               -text [format "%5.3fmue"  [expr $det_lmax/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xar) - 15] [expr $mos(yar) - 15] \
               -anchor $oriA -fill $color4 \
               -text [format "%5.3fmue" [expr $user_lcen/1000.0] ] -tag " A"
         $m_canvas create text [expr $mos(xbr) + 15] [expr $mos(ybr) - 15] \
               -anchor $oriB -fill $color4 \
               -text [format "%5.3fmue" [expr $user_lcen/1000.0] ] -tag " A"

         # allowed ranges, red if no solution
         set farbe blue
         set x1 [expr $mos(xa) - $mos(xar)]; set y1 [expr $mos(ya) - $mos(yar)]
         set x2 [expr $mos(xa) - $mos(xbr)]; set y2 [expr $mos(ya) - $mos(ybr)]
         set a1 [expr $x1 * $x1 + $y1 * $y1]
         set a2 [expr $x2 * $x2 + $y2 * $y2]
         if { $a1 > $a2 } { set farbe red }
         $m_canvas create line $mos(xbr) $mos(ybr) $mos(xc) $mos(yc) \
               -fill $farbe -width 1  -stipple "" -tag {A N3}
         $m_canvas create line $mos(xcr) $mos(ycr) $mos(xb) $mos(yb) \
               -fill $farbe -width 1  -stipple "" -tag {A N3}
         $m_canvas create line $mos(xar) $mos(yar) $mos(xd) $mos(yd) \
               -fill $farbe -width 1  -stipple "" -tag {A N3}
	 $m_canvas create line $mos(xdr) $mos(ydr) $mos(xa) $mos(ya) \
               -fill $farbe -width 1  -stipple "" -tag {A N3}
      }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_ref_star_frame { } {

      EXE begin
      $m_canvas create poly $field(xa) $field(ya) $field(xb) $field(yb) $field(xc) $field(yc) \
          $field(xd) $field(yd) -fill "" -outline red -width 3 -tag " A rtz"

      set reftarg_zone 1
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_ref_star_area { } {

      EXE begin
      $m_canvas create poly $field(xa) $field(ya) $field(xb) $field(yb) $field(xc) $field(yc) \
          $field(xd) $field(yd) -fill black -outline black -width 1 -tag " A rtz"

      set reftarg_zone 1
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_guide_star_frame { } {

      EXE begin
      set debug 0

      # test: plot guider patrol field with red line
      if {$debug} {
         puts "plot_guide_star_frame: \n \
            D: ($guide(xd), $guide(yd)), A: ($guide(xa), $guide(ya)) \n \
            M: ($guide(xm), $guide(ym)), B: ($guide(xb), $guide(yb)) \n \
            C: ($guide(xc), $guide(yc)) \n"
      }

      $m_canvas create poly $guide(xd) $guide(yd) $guide(xa) $guide(ya) $guide(xm) $guide(ym) $guide(xb) $guide(yb) $guide(xc) $guide(yc) \
       $guide(x1) $guide(y1) $guide(x2) $guide(y2) $guide(x3) $guide(y3) $guide(x4) $guide(y4) $guide(x5) $guide(y5) $guide(x6) $guide(y6) \
       $guide(x7) $guide(y7) -fill "" -outline red -tag " A gtz"

      if {$debug} {
         $m_canvas create text $guide(xa) $guide(ya) -fill red -anchor n -text A -tag "A"
         $m_canvas create text $guide(xb) $guide(yb) -fill red -anchor n -text B -tag "A"
         $m_canvas create text $guide(xc) $guide(yc) -fill red -anchor n -text C -tag "A"
         $m_canvas create text $guide(xd) $guide(yd) -fill red -anchor n -text D -tag "A"
      }

      set guidestar_zone 1
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_guide_star_area { } {

      EXE begin
      set debug 0

      # test: plot guider patrol field with red line
      if {$debug} {
         puts "plot_guide_star_frame: \n  \
            D: ($guide(xd), $guide(yd)), A: ($guide(xa), $guide(ya)) \n \
            M: ($guide(xm), $guide(ym)), B: ($guide(xb), $guide(yb)) \n \
            C: ($guide(xc), $guide(yc)) \n"
      }

      $m_canvas create poly $guide(xd) $guide(yd) $guide(xa) $guide(ya) $guide(xm) $guide(ym) $guide(xb) $guide(yb) $guide(xc) $guide(yc) \
        $guide(x1) $guide(y1) $guide(x2) $guide(y2) $guide(x3) $guide(y3) $guide(x4) $guide(y4) $guide(x5) $guide(y5) $guide(x6) $guide(y6) \
        $guide(x7) $guide(y7) -fill red -tag " A gtz"

      set guidestar_zone 1
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::shift { w xs ys } {

      if {$stop} { return }
      EXE begin
      set debug 0
      # A) shifts the mask via tcl move command
      # B) updates the mos-array
      # xs,ys are the screen coords where to be shifted 

      # Comments: declare bord as soon as possible as global not yet moved outside frame 
      set over 0

      # convert last drag coord to pixels
      $m_image convert coords $xs $ys screen xi yi image

      if {$debug} { puts stdout "pixel ($xi,$yi) screen ($xs,$ys) ($width,$height)" }
      # border in image coords
      if {$bonsai_flag} {set over 1}
      if {$xi < 1 || $xi >= $width} { set over 1}
      if {$yi < 1 || $yi >= $height} { set over 1}

      # screen to canvas
      $m_image convert coords $xs $ys screen x y canvas
      if {$debug} { puts "screen -> canvas done" }
      # mark and shift position != mask center
      # the distance between old and new position in canvas coordinates
      set shift_x [expr $x - $oldpos(x)]
      set shift_y [expr $y - $oldpos(y)]

      # moves the mask on the screen without recreating it via plot_mask
      if {$debug} { puts "move mask" }
      $w move A  $shift_x $shift_y

      #update the old-position for permanent shifts
      set oldpos(x) $x; set oldpos(y) $y

      # apply shift mask center = telescope pointing (canvas)
      set ccx [expr $ccx+$shift_x]
      set ccy [expr $ccy+$shift_y]
      #***************************************************************************
      puts "shift------------- ccx = $ccx, ccy = $ccy"
      #***************************************************************************

      # update world coords of mask center
      # if the frame is smaller than the mask or the mask is shifted outside the frame use bonsai-wcs
      if {$over} {
         set dum [C_wc c2w $ccx $ccy]
         set world_x [lindex $dum 0]
         set world_y [lindex $dum 1]
      } else {
         if [catch {
           $m_image convert coords $ccx $ccy canvas world_x world_y "deg $EQX"
         } result ] { puts stdout "shift: Big Error!!!!!!!!!!!!! $result" }
      }
      #***************************************************************************
      puts "shift------------- world_x = $world_x, world_y = $world_y"
      #***************************************************************************

      set local_max 0
      set local_set {a b d e f h}

      # update the array frames and wavelength borders
      foreach val {0 a b c d e f g h ar br cr dr er fr gr hr} {
           set mos(x$val) [expr $mos(x$val)+$shift_x]
           set mos(y$val) [expr $mos(y$val)+$shift_y]
      }

      # update the focal field frame
      foreach val {0 a b c d} {
           set field(x$val) [expr $field(x$val)+$shift_x]
           set field(y$val) [expr $field(y$val)+$shift_y]
      }

      # update the guider field
      foreach val { a b c d m 1 2 3 4 5 6 7 } {
           set guide(x$val) [expr $guide(x$val)+$shift_x]
           set guide(y$val) [expr $guide(y$val)+$shift_y]
      }

      # update the focal field frame
      foreach val { a b c d} {
           set ifield(x$val) [expr $ifield(x$val)+$shift_x]
           set ifield(y$val) [expr $ifield(y$val)+$shift_y]
      }
      # cursor position, not TCS pointing 
      $m_image convert coords $xs $ys screen xc yc canvas
      set dum [C_wc c2w $xc $yc]
      set xw [lindex $dum 0]
      set yw [lindex $dum 1]

      if [catch { $m_image convert coords $xw $yw "deg $EQX" lcx lcy "wcs $EQX"
         } result ] { puts stdout "shift: $result" }

      # mask-tcs position (= green point center)
      # $m_image convert coords $world_x $world_y "deg $EQX" lwx lwy "wcs $EQX"
      #puts stdout [format "Shift Mask to c(%10.3f,%10.3f) (%10.3f,%10.3f)" \
      #         $mos(x0) $mos(y0) $world_x $world_y ]
      # puts stdout [format "T%10s %10s C%10s %10s c%6.1f %6.1f s%6.1f %6.1f" \
      #                    $lwx $lwy $lcx $lcy $x $y $xs $ys] 

      # renew only tcs labels
      if {[$this cget -label]} {
         catch {$w delete D}
         plot_tcs_label
      }

      if {$debug} { puts "leaving SHIFT" }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::shift_load { w xs ys } {

      if {$stop} { return }
      EXE begin
      set debug 0
      # A) shifts the mask via tcl move command
      # B) updates the mos-array
      # xs,ys are the screen coords where to be shifted

      # Comments: declare bord as soon as possible as global not yet moved outside frame
      set over 0

      # convert last drag coord to pixels
      $m_image convert coords $xs $ys screen xi yi image

      if {$debug} { puts stdout "pixel ($xi,$yi) screen ($xs,$ys) ($width,$height)" }
      # border in image coords
      if {$bonsai_flag} {set over 1}
      if {$xi < 1 || $xi >= $width} { set over 1}
      if {$yi < 1 || $yi >= $height} { set over 1}

      # screen to canvas
      $m_image convert coords $xs $ys screen x y canvas
      if {$debug} { puts "screen -> canvas done" }
      # mark and shift position != mask center
      # the distance between old and new position in canvas coordinates
      set shift_x [expr $x - $oldpos(x)]
      set shift_y [expr $y - $oldpos(y)]

      # moves the mask on the screen without recreating it via plot_mask
      if {$debug} { puts "move mask" }
      $w move A  $shift_x $shift_y

      #update the old-position for permanent shifts
      set oldpos(x) $x; set oldpos(y) $y

      # apply shift mask center = telescope pointing (canvas)
      set ccx [expr $ccx+$shift_x]
      set ccy [expr $ccy+$shift_y]
      #***************************************************************************
      puts "shift_load------------- ccx = $ccx, ccy = $ccy"
      #***************************************************************************

      # update world coords of mask center
      # if the frame is smaller than the mask or the mask is shifted outside the frame use bonsai-wcs
      # if {$over} {
      #   set dum [C_wc c2w $ccx $ccy]
      #   set world_x [lindex $dum 0]
      #   set world_y [lindex $dum 1]
      # } else {
      #   if [catch {
      #     $m_image convert coords $ccx $ccy canvas world_x world_y "deg $EQX"
      #   } result ] { puts stdout "shift: Big Error!!!!!!!!!!!!! $result" }
      # }
      #***************************************************************************
      puts "shift_load------------- world_x = $world_x, world_y = $world_y"
      #***************************************************************************

      set local_max 0
      set local_set {a b d e f h}

      # update the array frames and wavelength borders
      foreach val {0 a b c d e f g h ar br cr dr er fr gr hr} {
           set mos(x$val) [expr $mos(x$val)+$shift_x]
           set mos(y$val) [expr $mos(y$val)+$shift_y]
      }

      # update the focal field frame
      foreach val {0 a b c d} {
           set field(x$val) [expr $field(x$val)+$shift_x]
           set field(y$val) [expr $field(y$val)+$shift_y]
      }

      # update the guider field
      foreach val { a b c d m 1 2 3 4 5 6 7 } {
           set guide(x$val) [expr $guide(x$val)+$shift_x]
           set guide(y$val) [expr $guide(y$val)+$shift_y]
      }

      # update the focal field frame
      foreach val { a b c d} {
           set ifield(x$val) [expr $ifield(x$val)+$shift_x]
           set ifield(y$val) [expr $ifield(y$val)+$shift_y]
      }
      # cursor position, not TCS pointing
      $m_image convert coords $xs $ys screen xc yc canvas
      set dum [C_wc c2w $xc $yc]
      set xw [lindex $dum 0]
      set yw [lindex $dum 1]

      if [catch { $m_image convert coords $xw $yw "deg $EQX" lcx lcy "wcs $EQX"
         } result ] { puts stdout "shift: $result" }

      # mask-tcs position (= green point center)
      # $m_image convert coords $world_x $world_y "deg $EQX" lwx lwy "wcs $EQX"
      #puts stdout [format "Shift Mask to c(%10.3f,%10.3f) (%10.3f,%10.3f)" \
      #         $mos(x0) $mos(y0) $world_x $world_y ]
      # puts stdout [format "T%10s %10s C%10s %10s c%6.1f %6.1f s%6.1f %6.1f" \
      #                    $lwx $lwy $lcx $lcy $x $y $xs $ys]

      # renew only tcs labels
      if {[$this cget -label]} {
         catch {$w delete D}
         plot_tcs_label
      }

      if {$debug} { puts "leaving shift_load" }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::align_mask { w sx sy } {

      # move the mask to the center/gauss result
      # w = canvas widget
      # sx, sy is cursor pos in screen coords
      # on==1  : select, on==0 : un-select, give slit free
      # stop==1: do nothing (when selecting a reference object)
      # stop==0: do the normal procedure 
      if {$stop} { return }
      EXE begin
      # puts stdout "in align_mask"
      set my 1
      $m_image convert coords $sx $sy screen x y canvas

      # old (current mask center)
      if {$bonsai_flag} {
         set dum [C_wc w2c $world_x $world_y]
         $m_image convert coords [lindex $dum 0] [lindex $dum 1] canvas ocx ocy screen
         $m_image convert coords $world_x $world_y "deg $EQX" a b "wcs $EQX"
      } else {
        $m_image convert coords $world_x $world_y "deg $EQX" ocx ocy screen
        $m_image convert coords $world_x $world_y "deg $EQX" a b "wcs $EQX"
      }

      puts $lfId "AliMask: jump slit to $a $b"
      # calculate new mask position in screen coords
      # new_mask = old_mask + (center/gauss - current slit )
      # sx sy screen are cursor or center/gauss 
      # current slit is either MOS 10 (echs) or HITS ? (hits) or pinhole

      #-------------------------
      # center-slit option
      #-------------------------
      if {[$this cget -pics]} {
         # sx,sy are approximate coords, use RtdImagePick to center slit on image target
         $m_image convert coords $sx $sy screen a0 d0 image 
         # puts stdout "Cursor canvas=$x $y screen=$sx $sy pixel=$a0 $d0"
         center_slit
         if {$lss_sli_ra != ""} {
            $m_image convert coords $lss_sli_ra $lss_sli_de image sx sy screen
            $m_image convert coords $lss_sli_ra $lss_sli_de image  x  y canvas
         } else {
            # puts stdout "center_slit failed, use cursor at ($a0,$d0) pixel"
         }
      } else { return }

      #-------------------------
      # center-slit option end
      #-------------------------

      # we use the first created mos slit
      mos::MOS_SLIT::coeff $XMIN $YMIN $field(xa) $field(ya) \
                           $XMAX $YMIN $field(xb) $field(yb) \
                           $XMAX $YMAX $field(xc) $field(yc)
      C_mos1 M2W; # x,y -> xc,yc -> ra,dec in mos
      set targw(1,a) [C_mos1 get_RA]
      set targw(1,d) [C_mos1 get_DEC]
      $m_image convert coords $targw(1,a) $targw(1,d) "wcs $EQX" ssx ssy screen
      # puts stdout "current MXU position is $ssx $ssy"

      set newx [expr $ocx + $sx - $ssx ]
      set newy [expr $ocy + $sy - $ssy ]

      # before we shift, update the oldpos in mark
      set oldpos(x) $mos(x0); set oldpos(y) $mos(y0)
      # shift mask to new screen coords
      shift $w $newx $newy

      EXE end
   }


#------------------------------------------------------------------------------------
   ::itcl::body MOS::rotate { w x y dir } {

      # Modified 2007 09 13, R.H.
      # Modes removed, field added

      if {$stop} { return }
      EXE begin
      set debug 0
      # rotate the whole mask with all slits
      # del_ang is incremental rotation del_angle of the object 
      # default + or - 5 degr

      # rad-deg conversion, rotangle in deg, del_ang in rad 
      set del_ang [expr $dir*$rotangle*0.0174532]
      # puts $lfId "RotAng >>$rotangle<< DelAng >>$del_ang<<"
      # abs_ang_rad is the current rot-angle with respect to the initial object, = mask-wcs angle from north to east
      set abs_ang_rad [expr $abs_ang_rad + $del_ang]
      set PAM [expr $PAM + $dir*$rotangle*$CSO] 
      set PAM [expr fmod($PAM,360) ]
      set tcs_pam [format "%6.2f" $PAM ]
      # set myob($w,obj) [$w find closest $x $y]
      # new coordinates
      # we rotate the all coordinates around the axis
      # located in the center of the figure = ccx, ccy
      # the angle step is del_angle
      # the new total angle = abs_ang_rad

      set cda [expr cos($del_ang)]; set sda [expr sin($del_ang)]
      puts $lfId "rotate at $world_x,$world_y to PA=$tcs_pam"
      if { $debug } { puts "rotate at $world_x,$world_y to PA=$tcs_pam" }

      # rotate the focal field
      set d1 [expr $ccx + ($field(xa)-$ccx)*$cda - ($field(ya)-$ccy)*$sda]
      set d2 [expr $ccy + ($field(xa)-$ccx)*$sda + ($field(ya)-$ccy)*$cda]
      set field(xa) $d1; set field(ya) $d2

      set d1 [expr $ccx + ($field(xb)-$ccx)*$cda - ($field(yb)-$ccy)*$sda]
      set d2 [expr $ccy + ($field(xb)-$ccx)*$sda + ($field(yb)-$ccy)*$cda]
      set field(xb) $d1; set field(yb) $d2

      set d1 [expr $ccx + ($field(xc)-$ccx)*$cda - ($field(yc)-$ccy)*$sda]
      set d2 [expr $ccy + ($field(xc)-$ccx)*$sda + ($field(yc)-$ccy)*$cda]
      set field(xc) $d1; set field(yc) $d2

      set d1 [expr $ccx + ($field(xd)-$ccx)*$cda - ($field(yd)-$ccy)*$sda]
      set d2 [expr $ccy + ($field(xd)-$ccx)*$sda + ($field(yd)-$ccy)*$cda]
      set field(xd) $d1; set field(yd) $d2
      if { $debug } { puts "rotate: focal field done" }

      foreach val { a b c d m 1 2 3 4 5 6 7 } {
         set d1 [expr $ccx + ($guide(x$val)-$ccx)*$cda - ($guide(y$val)-$ccy)*$sda]
         set d2 [expr $ccy + ($guide(x$val)-$ccx)*$sda + ($guide(y$val)-$ccy)*$cda]
         set guide(x$val) $d1; set guide(y$val) $d2
      }

      foreach val { a b c d } {
         set d1 [expr $ccx + ($ifield(x$val)-$ccx)*$cda - ($ifield(y$val)-$ccy)*$sda]
         set d2 [expr $ccy + ($ifield(x$val)-$ccx)*$sda + ($ifield(y$val)-$ccy)*$cda]
         set ifield(x$val) $d1; set ifield(y$val) $d2
      }

      # rotate the N3.75 frame
      set d1 [expr $ccx + ($mos(xa)-$ccx)*$cda - ($mos(ya)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xa)-$ccx)*$sda + ($mos(ya)-$ccy)*$cda]
      set mos(xa) $d1; set mos(ya) $d2

      set d1 [expr $ccx + ($mos(xb)-$ccx)*$cda - ($mos(yb)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xb)-$ccx)*$sda + ($mos(yb)-$ccy)*$cda]
      set mos(xb) $d1; set mos(yb) $d2

      set d1 [expr $ccx + ($mos(xc)-$ccx)*$cda - ($mos(yc)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xc)-$ccx)*$sda + ($mos(yc)-$ccy)*$cda]
      set mos(xc) $d1; set mos(yc) $d2

      set d1 [expr $ccx + ($mos(xd)-$ccx)*$cda - ($mos(yd)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xd)-$ccx)*$sda + ($mos(yd)-$ccy)*$cda]
      set mos(xd) $d1; set mos(yd) $d2
      if { $debug } { puts "rotate: N3.75 frame done" }

      # rotate the N1.8 frame 
      set d1 [expr $ccx + ($mos(xe)-$ccx)*$cda - ($mos(ye)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xe)-$ccx)*$sda + ($mos(ye)-$ccy)*$cda]
      set mos(xe) $d1; set mos(ye) $d2

      set d1 [expr $ccx + ($mos(xf)-$ccx)*$cda - ($mos(yf)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xf)-$ccx)*$sda + ($mos(yf)-$ccy)*$cda]
      set mos(xf) $d1; set mos(yf) $d2

      set d1 [expr $ccx + ($mos(xg)-$ccx)*$cda - ($mos(yg)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xg)-$ccx)*$sda + ($mos(yg)-$ccy)*$cda]
      set mos(xg) $d1; set mos(yg) $d2

      set d1 [expr $ccx + ($mos(xh)-$ccx)*$cda - ($mos(yh)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xh)-$ccx)*$sda + ($mos(yh)-$ccy)*$cda]
      set mos(xh) $d1; set mos(yh) $d2
      if { $debug } { puts "rotate: N1.8 frame done" }

      # rotate the reduced N3.75-frame
      set d1 [expr $ccx + ($mos(xar)-$ccx)*$cda - ($mos(yar)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xar)-$ccx)*$sda + ($mos(yar)-$ccy)*$cda]
      set mos(xar) $d1; set mos(yar) $d2

      set d1 [expr $ccx + ($mos(xbr)-$ccx)*$cda - ($mos(ybr)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xbr)-$ccx)*$sda + ($mos(ybr)-$ccy)*$cda]
      set mos(xbr) $d1; set mos(ybr) $d2

      set d1 [expr $ccx + ($mos(xcr)-$ccx)*$cda - ($mos(ycr)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xcr)-$ccx)*$sda + ($mos(ycr)-$ccy)*$cda]
      set mos(xcr) $d1; set mos(ycr) $d2

      set d1 [expr $ccx + ($mos(xdr)-$ccx)*$cda - ($mos(ydr)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xdr)-$ccx)*$sda + ($mos(ydr)-$ccy)*$cda]
      set mos(xdr) $d1; set mos(ydr) $d2
      if { $debug } { puts "rotate: N3.75 reduced frame done" }

      # rotate the reduced N1.8-frame
      set d1 [expr $ccx + ($mos(xer)-$ccx)*$cda - ($mos(yer)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xer)-$ccx)*$sda + ($mos(yer)-$ccy)*$cda]
      set mos(xer) $d1; set mos(yer) $d2

      set d1 [expr $ccx + ($mos(xfr)-$ccx)*$cda - ($mos(yfr)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xfr)-$ccx)*$sda + ($mos(yfr)-$ccy)*$cda]
      set mos(xfr) $d1; set mos(yfr) $d2

      set d1 [expr $ccx + ($mos(xgr)-$ccx)*$cda - ($mos(ygr)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xgr)-$ccx)*$sda + ($mos(ygr)-$ccy)*$cda]
      set mos(xgr) $d1; set mos(ygr) $d2

      set d1 [expr $ccx + ($mos(xhr)-$ccx)*$cda - ($mos(yhr)-$ccy)*$sda]
      set d2 [expr $ccy + ($mos(xhr)-$ccx)*$sda + ($mos(yhr)-$ccy)*$cda]
      set mos(xhr) $d1; set mos(yhr) $d2
      if { $debug } { puts "rotate: N1.8 reduced frame done" }

      # update mos focal field <-> canvas transformation matrix
      mos::MOS_SLIT::coeff $XMIN $YMIN $field(xa) $field(ya) \
                           $XMAX $YMIN $field(xb) $field(yb) \
                           $XMAX $YMAX $field(xc) $field(yc)
      set noms [mos::MOS_SLIT::nos]
      if {[mos::MOS_SLIT::get_mmff]} {
         # do nothing for standard masks
      } else {
         # delete all mos slits if there are any
         if {$noms>0} {
             for {set i 1} {$i <= $noms} { incr i 1} { 
                if {$i > $nf_refslit} { delete object C_mos$i }
             }
         }
      }
      if { $debug } { puts "rotate: slits done" }

      catch {$w delete A}
      catch {$w delete D}
      if { $debug } { puts "rotate: A and D deleted" }
      plot_mask
      if { $debug } { puts "rotate: mask plotted" }

      set last_action "Rotate Mask"
      catch {SP update}
      EXE end
  }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::mos_create_slit { w sx sy but {on 1} {click 1} } {

      # creates a new slit
      # sx,sy screen coords, but = mouse button
      # stop==1: do nothing (when selecting a reference object)
      # stop==0: do the normal procedure

      #puts stdout "mos_create_slit : $w sx=$sx sy=$sy but=$but"
      if {$stop} { return }
      EXE begin
      $m_image convert coords $sx $sy screen x y canvas
      $m_image convert coords $sx $sy screen px py image
      # puts stdout "[$w gettags [$w find closest $x $y]]"
      # puts stdout  "$x $y ->  [C_wc c2m $x $y]"

      # adapt slit length
      set mos_sl  [$this cget -slit_length]
      if {[string match *CIRCLE* [$this cget -mos_shape] ]} { set mos_sl [$this cget -slit_width] }

      set ff [list $XMIN_375 $XMAX_375]
      if {[string match *180* [$this cget -camera] ]} { set ff [list $XMIN_180 $XMAX_180] }

      #------------------
      # center-slit option
      #------------------
      if {$click} {
         if {[$this cget -pics]} {
            # sx,sy are approximate coords,
            # use RtdImagePick to center slit on image target
            $m_image convert coords $sx $sy screen px py image
            # puts stdout "Cursor canvas=$x $y screen=$sx $sy pixel=$px $py"
            center_slit
            if {$lss_sli_ra != ""} {
               $m_image convert coords $lss_sli_ra $lss_sli_de image x y canvas
               # puts stdout "center_slit from ($px,$py) on center_gauss result=\
               #        ($lss_sli_ra,$lss_sli_de) pixel"
               set px $lss_sli_ra; set py $lss_sli_de
            } else {
               # puts stdout "center_slit failed, use cursor at ($px,$py) pixel"
            }
         }
      }
      #-----------------------
      # center-slit option end
      #-----------------------
      # this is necessary for calc_zemax
      set targw(1,f) 1
      set targw(1,x) $px
      set targw(1,y) $py
      $m_image convert coords $px $py image targw(1,a) targw(1,d) "wcs $EQX"
      # this is also called in load_mos_TPX.
      # this is convenient, for science masks, when slits are on their position.
      # For standard masks for which slits may change their position we need
      # another procedure (see load_adf) when we allow to shift MOS slits, ... more complicated

      # create one instance of MOS SLIT
      # the number of mos slits
      set noms [mos::MOS_SLIT::nos]
      if {$noms==$mnomos} {
         info_dialog "Error: Cannot handle more than\n $mnomos MOS slits" .skycat1
         return
      }

      # we dont use the auto, since auto continues with 7 when reset_mask seleted the old 6
      # instances are C_mos1, C_mos2
      set a [mos::MOS_SLIT C_mos[incr noms 1] $m_canvas $m_image $x $y \
           -eqx $EQX \
           -slit_width [$this cget -slit_width] \
           -slit_length $mos_sl \
           -pos_ang 0.0  \
           -shape [$this cget -mos_shape] \
           -ff $ff \
           -ON 1 \
           -child $this ]

      # for status panel
      set last_action "Create MOS \#$noms"
      catch {SP update}
      EXE end
   }


# -----------------------------------------------------------------------------------------
   ::itcl::body MOS::reset_slits { } {

      # Modified R.H. 2007 09 04
      # Modes removed

      # called by button1-release, after mask shift, reset slit positions
      EXE begin
      if {[mos::MOS_SLIT::get_mmff]} {
          # do nothing, retain the standard mask as a fixed mask
      } else {
          set noms [mos::MOS_SLIT::nos]
          if {$noms>0} {
             for {set i 1} {$i <= $noms} { incr i 1} { if {$i > $nf_refslit} { delete object C_mos$i } }
          }
      }

      update_and_replot

      set last_action {Move Mask}
      catch {SP update}
      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::center_slit { } {

      EXE begin
      set lss_sli_ra ""; set lss_sli_de  ""
      set w .skycat1
      set w [$w component image]
      $w pick_dialog [code $this extra_pick ]
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::calc_ctom { } {

      EXE begin
      set scal [expr $atd * $focscale]
      set p1x $wx; set p1y [expr $wy+$scal*$YMIN]
      set p2x $wx; set p2y [expr $wy+$scal*$YMAX]

      # transform these points into canvas coords
      if $bonsai_flag {
         set dum [C_wc w2c $p1x $p1y]
         set p1x [lindex $dum 0]
         set p1y [lindex $dum 1]
         set dum [C_wc w2c $p2x $p2y]
         set p2x [lindex $dum 0]
         set p2y [lindex $dum 1]
      } else {
         $m_image convert coords $p1x $p1y "deg $EQX" p1x p1y canvas
         $m_image convert coords $p2x $p2y "deg $EQX" p2x p2y canvas
      }

      set dx [expr $p1x-$p2x]
      set dy [expr $p1y-$p2y]
      set ctom [expr sqrt($dx*$dx+$dy*$dy)/($YMAX-$YMIN)]
      # puts stdout [format "calc_ctom: new scale: %8.3f" $ctom]
      EXE end
      return $ctom
   }


#----------------------------------------------------- bind mouse keys ------------------------------------------------------------------

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::bind_frame { } {

      # shift and rotate image
      # tag m = green circle, tag C = blue CCD window 
      # if mouse in m (green central circle) then mark

      $m_canvas bind m <Button-1>        [code $this mark %W %x %y]
      $m_canvas bind m <B1-Motion>       [code $this shift %W %x %y]
      $m_canvas bind m <ButtonRelease-1> [code $this reset_slits]

      # if mouse is in mc and clicked, rotate clockwise
      $m_canvas bind m <Button-2> [code $this rotate %W %x %y -1]
      # if mouse is in mc and shift-b2 clicked, rotate anti-clock-wise
      $m_canvas bind m <Shift-Button-2> [code $this rotate %W %x %y 1]

      puts $lfId "$this bind frame"
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::bind_mos { } {

      # click on the array to create a slit
      $m_canvas bind mos <Button-1> [code $this mos_create_slit %W %x %y 0 ]

      # click on the slit width label (.e.g  '1.3"') to change individual MOS slit width
      $m_canvas bind sw <Button-1> [code $this indi_slit_mos %W %x %y ]

      # click on slit label (e.g. '#15') at the rim of the focal field to delete mos slit
      $m_canvas bind kill <Button-1> [code $this delete_slit_mos %W %x %y ]

      # AAG, De-Select mos slit
      $m_canvas bind rs <Button-2> [code $this delete_slit_mos %W %x %y ]
   }


#----------------------------------------------- format and string handling -------------------------------------------------------------

#----------------------------------------------------------------------------------
   ::itcl::body MOS::DDMMSS2deg { ddmmss } {
      # RA,DEC format conversion
      # from  ddmmss.xxx to dd.xxx
      # like -703514.123 (means -70 deg 35 arcmin 14.123 arcsec)
      # to -70.5872563
      # this routine works also for hour angles
      # but the factor of 15 must be corrected outside this proc
      # this proc is very primitive, it works char by char

      # split by floating point
      set a [split $ddmmss "." ]
      set a2 .[lindex $a 1]
      set a2 [expr $a2/3600]

      set a1 [lindex $a 0]
      set l [string length $a1]

      set a11 [string index $a1 [expr $l-1] ]
      set a12 [string index $a1 [expr $l-2] ]
      set a11 [expr ($a11 + 10.0*$a12) / 3600.0]

      set a21 [string index $a1 [expr $l-3] ]
      set a22 [string index $a1 [expr $l-4] ]
      set a21 [expr ($a21 + 10.0*$a22) / 60.0]

      set a31 [string index $a1 [expr $l-5] ]
      set a32 [string index $a1 [expr $l-6] ]
      set a31 [expr ($a31 + 10.0*$a32) ]

      set  a31 [expr $a31 + $a21 + $a11 + $a2]
      if {[string compare [string index $ddmmss 0] "-"] ==0} {
         set a31 [expr $a31 * -1 ]
      }
      return $a31
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::F2G { value } {

      # format conversion for floating point from  xxx.yyy to xxxyyy to be used for gerber (rs274x) format X33Y33
      set value [format "%3.3f" $value]
      set value [split $value "."]
      set value "[lindex $value 0][lindex $value 1]"
      # puts stdout ">$value<"
      return $value
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::ldelete_all { w_list value} {

      # modified ldelete
      # delete all list elements by value (single character)
      set ix [lsearch -exact $w_list $value]
      set new $w_list

      while {$ix>=0} {
            set new [lreplace $w_list $ix $ix] 
            set ix [lsearch -exact $new $value]
            set w_list $new
      }
      return $new
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::ldelete { list value} {

      # taken from Welch, p34
      # delete one list element by value 
      set ix [lsearch -exact $list $value]
      if {$ix>=0} {
         return [lreplace $list $ix $ix]
      } else {
         return $list
      }
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::string_exchange { input old new } {

      # exchange all characters in string 'old' by 'new'
      # works only correctly if old and new are single chars

      set output ""
      set l [string length $input]
      for { set i 0 } { $i < $l } { incr i 1 } {
          set c [string index $input $i]
          if {$c != $old} { append output $c } else { append output $new }
      }
      return $output
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::string_delete  { input value } {
      # delete all characters of 'value' in string 'input'
      # works only correctly if old and new are single chars

      set output ""
      set l [string length $input]
      for { set i 0 } { $i < $l } { incr i 1 } {
          set c [string index $input $i]
          if {$c != $value} { append output $c }
      }
      return $output
   }




#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::warn { } {

      set number [random 7]
      switch -exact -- $number {
         0 -
         1 { set result 1
             while {$result==0} {
                set wid .skycat1.save
                catch {destroy $wid}
                set w [DialogWidget $wid \
                 -text "Are you Really Sure ?" \
                 -bitmap warning \
                 -default 0  \
                 -buttons {YES NO} ]
                set result [$w activate]
             }
           }
         2 { info_dialog "You have pressed \[Ok\]\n\nPlease verify" .skycat1
             info_dialog "You have pressed \[Ok\]\n\nPlease verify" .skycat1
             info_dialog "\[Ok\] Accepted" .skycat1
             info_dialog "\[Ok\] Not Accepted" .skycat1
             info_dialog "You have pressed \[Ok\]\n\nPlease verify" .skycat1
           }
         3 { expire_date }
         4 { info_dialog "Not Accepted\n\n\Press again \[YES\]" .skycat1
             info_dialog "Not Accepted\n\n\Press again \[NO\]" .skycat1
             info_dialog "Not Accepted\n\n\Press again \[OK\]" .skycat1
           }
         5 { info_dialog "No Save Permission for\n\n\User : [exec whoami]\n\n\Press \[NO\]" .skycat1
             info_dialog "No Save Permission for\n\n\User : [exec whoami]\n\n\Press \[NO\]" .skycat1
           }
         6 { for {set j 1 } { $j<5} { incr j 1 } {
                 set text "Agreement:\n\n\
                    This setup file\n\
                    remains a property of ESO\n\
                    even if never scheduled."
                 set result 1
                 set haha [random 3]

                 while {$result != $haha} {
                     set wid .skycat1.save
                     catch {destroy $wid}
                     set w [DialogWidget $wid \
                        -text $text  \
                        -bitmap warning \
                        -default 0 \
                        -buttons {YES OK Accept Thanks} ]
                     set result [$w activate]
                 }
             }
           }
      }
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::big_status_panel { } {

      EXE begin
      mos::StatusPanel SP -mos_class $this
      catch {SP update}
      EXE end
  }



#---------------------------------------------------------------------------------------------
   ::itcl::body MOS::init_mask_world2 { } {

      # Modified R.H. 2007 09 04
      # Some of the modes removed
      # 09 11: bonsai flag set to 0, bonsai test removed, could cause problems!!!!!!!!!!!!!!!!!!!!!!!
      # 09 12: focal field introduced (field)

      # The WCS command 'convert coords' does only work on frames but not on the canvas area
      # beyond a FITS frame. Therefore the instrumental mask uses a separate coord conversion
      # (a linear approach, defined via bonsai_matrix)
      #
      # This member function draws the instrumental mask on the canvas
      # with the correct size (6' x 6') and position angle 0.
      EXE begin
      set debug 0
      wave_limit

      if {$debug} {
         puts stdout "world2:    RA            DEC        asec/pix (PXcen)  (PYcen) SizeX SizeY rot Epo equi proj"
         puts stdout "world2: [$m_image wcsset]"
      }

      # all coordinates are stored in the large array mos(,)
      # here we handle alp and del differently
      # canvas coordinates in canvas pixels
      # there is still a bug concerning south-pole
      # first at all : central position in canvas
      # units of mos: canvas coords
      # units of targw: canvas

      set EQX [ lindex [$m_image wcsset] 8 ]

      # frameless mode
      if {$wx=="" || $wy==""} {
         set w1  [ lindex [$m_image wcsset] 0 ]
         set w2  [ lindex [$m_image wcsset] 1 ]
         $m_image convert coords $w1 $w2 "wcs $EQX" wx wy "deg $EQX"
         if {$debug} { puts stdout "frameless mode reference pixel :$w1 $w2" }
      }

      $m_image convert coords $wx $wy "deg $EQX" ccx  ccy canvas
      set mos(x0) $ccx;   set mos(y0) $ccy
      set field(x0) $ccx; set field(y0) $ccy
      if {$debug} { puts stdout "reference pixel : $wx $wy $ccx $ccy" }

      # retrieving the actual zooming parameter
      set canvscale [$m_image scale]
      set canvscale [lindex $canvscale 0]
      if {$canvscale<0} { set canvscale [expr -1.0/$canvscale] }

      # read the reference pixel from the fits header
      # ---------------------------------------------
      # this is independent on WCS notation
      if {$debug} {
          puts stdout ">[$m_image fits get CRPIX1]< \
            >[$m_image fits get CRPIX2]< \
            >[$m_image fits get CRVAL1]< \
            >[$m_image fits get CRVAL2]<"
      }

      # read the equinox if not known from wcsset
      if {$EQX==""} { set EQX [$m_image fits get EQUINOX]  }
      if {$EQX==""} { puts stdout "Error: EQUINOX not defined !!!"  }

      #------------------------------------------------------------------------------------------
      # now the (signum of CROTA2 = CRO) , needed for init_mask
      # first test if fites header contains CD,
      # then test if fits header contains PC
      # test test if fits header contains CROTA (WCS keywords)

      set no_wcs_flag 1; # WCS not yet defined by default

      if {[$m_image fits get CD1_1] != ""} {
         set no_wcs_flag 0; # everything is still ok
         if {$debug} { puts stdout "try CD notation ..." }
         set d11 [$m_image fits get CD1_1]
         set d12 [$m_image fits get CD1_2]
         set d21 [$m_image fits get CD2_1]
         set d22 [$m_image fits get CD2_2]
         if {$d12==""} {set no_wcs_flag 1; puts stdout "CD1_2 not found"}
         if {$d21==""} {set no_wcs_flag 1; puts stdout "CD2_1 not found"}
         if {$d22==""} {set no_wcs_flag 1; puts stdout "CD2_2 not found"}

         if {$no_wcs_flag} {
            puts stdout "Error in FITS Header: Incomplete CD-WCS keywords, try PC notation ...\n"
         } else {
            # everything correctly found up to now
            set d30 [expr $d11*$d22-$d12*$d21]
            set CSO [expr $d30/abs($d30)]
            if {$CSO==1} {
               # puts stdout "world2: WCS: right-hand coords -->East to right"
               # by convention if CSO<0 then CDELT1<0
               set fits_x_scale 1.0
               set fits_y_scale 1.0
            } else {
               # puts stdout "world2: WCS: left-hand coords East to left<--"
               # by convention if CSO<0 then CDELT1<0
               set fits_x_scale -1.0
               set fits_y_scale 1.0
            }
            set CRO [expr 57.29578*atan2($d30*$d12,$d22) ]
            if {$CRO == 0.0} { set CRO 1.0 } else { set CRO [expr $CRO / abs($CRO)] }
            if {$debug} {
               puts stdout "CD11,12,21,22, = \
               [$m_image fits get CD1_1] [$m_image fits get CD1_2] \
               [$m_image fits get CD2_1] [$m_image fits get CD2_2]"
            }
         }
      }

      if {$no_wcs_flag} {
         # CD notation either incomplete or not available
         if {[$m_image fits get PC001001] !=""} {
            set pc_flag 0
            if {$debug} { puts stdout "try PC notation ..."}
            set d11 [$m_image fits get CDELT1]
            set d21 [$m_image fits get CDELT2]
            set d12 [$m_image fits get PC001002]
            set d22 [$m_image fits get PC002002]
            if {$d11==""} { set pc_flag 1; puts stdout "CDELT1 not found" }
            if {$d21==""} { set pc_flag 1; puts stdout "CDELT2 not found" }
            if {$d12==""} { set pc_flag 1; puts stdout "PC001002 not found" }
            if {$d22==""} { set pc_flag 1; puts stdout "PC002002 not found" }

            if {$pc_flag} {
               puts stdout "Error in FITS Header: Incomplete PC_coord_conv coeffWCS keywords, try CROTA notation ...\n"
            } else {
               set no_wcs_flag 0; # keyword set complete 
               set a [$m_image fits get CDELT1]
               set fits_x_scale [expr $a/abs($a) ]
               set b [$m_image fits get CDELT2]
               set fits_y_scale [expr $b/abs($b)]
               set CSO [expr $fits_x_scale * $fits_y_scale]
               if {$CSO==1} {
                  puts stdout "world2: WCS: right-hand coords -->East to right"
               } else {
                  puts stdout "world2: WCS: left-hand coords East to left<--"
               }
               set CRO [expr 57.29578*atan2($d12*abs($d11),$d22*abs($d21))]
               if {$CRO == 0.0} { set CRO 1.0 } else { set CRO [expr $CRO / abs($CRO)] }
               if {$debug} {
                  puts stdout "world2: PC11,12,21,22, CDELT1,2 = \
                             [$m_image fits get PC001001] [$m_image fits get PC001002] \
                             [$m_image fits get PC002001] [$m_image fits get PC002002] \
                             [$m_image fits get CDELT1]   [$m_image fits get CDELT2]"
               }
            }
         }
      }

      if {$no_wcs_flag} {
         set cr_flag 0; # everything ok up to here
         if {$debug} { puts stdout "try CDELT notation ..."}
         set a [$m_image fits get CDELT1]
         set b [$m_image fits get CDELT2]
         set cro1 [$m_image fits get CROTA1]
         set cro2 [$m_image fits get CROTA2]
         if {$a==""} { set cr_flag 1; puts stdout "CDELT1 not found" }
         if {$b==""} { set cr_flag 1; puts stdout "CDELT2 not found" }
         # at least one of CROTA should be defined
         if {$cro1=="" && $cro2==""} {
             set cr_flag 1; puts stdout "CROTA1 && CROTA2 not found" }

         if {$cr_flag} {
            puts stdout "Error in FITS Header: Incomplete CR-WCS keywords, try SkyCat ... \n"
         } else {
            set no_wcs_flag 0;
            set fits_x_scale [expr $a/abs($a) ]
            set fits_y_scale [expr $b/abs($b)]
            set CSO [expr $fits_x_scale * $fits_y_scale]
            if {$debug} {
               if {$CSO==1} {
                  puts stdout "world2: WCS: right-hand coords -->East to right"
               } else {
                  puts stdout "world2: WCS: left-hand coords East to left<--"
               }
            }
            if {$cro1==""}   { set CRO $cro2 } else { set CRO $cro1}
            if {$CRO == 0.0} { set CRO 1.0 }   else { set CRO [expr $CRO / abs($CRO)] }
            if {$debug} {
               puts stdout [format \
               "world2: CDELT1,2 CROTA1,2 = %10e %10e %6.2f" \
               [$m_image fits get CDELT1] \
	       [$m_image fits get CDELT2] \
               $CRO ]
            }
         }
      }

      if {$no_wcs_flag} {
         if {$debug} { puts stdout "try SkyCat ..."}
         # try skycat WCS as a last chance 
         set hello [$m_image wcsset]
         set CRO [lindex $hello 7]
         if {$CRO == 0.0} { set CRO 1.0 } else { set CRO [expr $CRO / abs($CRO)] }
         set CSO -1
         set fits_x_scale -1.0
         set fits_y_scale 1.0
         puts stdout ".. got values from SkyCat"
      }

      if {$debug} {
         puts stdout "sign(CROTA2)         = CRO = $CRO"
         puts stdout "sign(CDELT1*CDELT2)  = CSO = $CSO"
      }
      # CRO finished
      #------------------------------------------------------------------------------------------

      # skycat image flip buttons, buttons have been removed from skycat !!!!!!!!!!!!!!!!!!!!!!!!!
      # --------------------------
      # state (if buttons are pressed)
      set flipr [$m_image rotate];   # [()]  button
      set flipx [$m_image flip x];   # [==]  button
      set flipy [$m_image flip y];   # [||]  button

      # puts stdout "flip rxy  $flipr $flipx $flipy"

      if {$flipr} {
         if {$CRO == -1} { set fits_x_scale [expr -1 * $fits_x_scale] }
         set fits_y_scale [expr -1 * $fits_y_scale]
         set CSO [expr -1 * $CSO]
         set CRO [expr -1 * $CRO]
      }
      if {$flipx} {
         set fits_x_scale [expr -1 * $fits_x_scale] 
         set CSO [expr -1 * $CSO]
         set CRO [expr -1 * $CRO]
      }
      if {$flipy} {
         set fits_y_scale [expr -1 * $fits_y_scale]
         set CSO [expr -1 * $CSO]
         set CRO [expr -1 * $CRO]
      }

      # CSO = 1 -> mouse button 2 (B2) mask rotates left -> decreasing 
      #            position angle (PA)
      # CSO =-1 -> mouse button 2 (B2) mask rotates left -> increasing 
      #            position angle (PA)
      # coord/mm * scal = coord/arcsec

      # focal plane scale in deg/mm
      set scal [expr $atd * $focscale]
      set trigo [expr 1/cos($wy*0.0174532)]

      puts $lfId "Init_Mask_World: canvscale=$canvscale wx=$wx wy=$wy trigo=$trigo"
      puts $lfId "Init_Mask_World: focscale=$focscale scal=$scal arc_to_deg=$atd"

      if {$debug} {
         puts "Init_Mask_World2: canvscale=$canvscale wx=$wx wy=$wy trigo=$trigo"
         puts "Init_Mask_World2: focscale=$focscale scal=$scal sec_to_deg=$atd"
         puts "Init_Mask_World2: fits_x_scale = $fits_x_scale, fits_y_scale = $fits_y_scale"
      }

      #------------------------------------------------------------------------------------------------------
      # up to here mode independent
      #------------------------------------------------------------------------------------------------------

      bind_mos
      set co_flag [string match *375* [$this cget -camera] ]
      set bonsai_flag 0

      # we have to check if the 4 corners of the focal field are inside the image
      set xm [expr $wx + $scal*$XMIN]; set ym [expr $wy + $scal*$YMIN]
      set xM [expr $wx + $scal*$XMAX]; set yM [expr $wy + $scal*$YMAX]
      if {$debug} { puts "init_mask_world2 \n center: wx = $wx, wy = $wy \n corners: xm = $xm, xM = $xM, ym = $ym, yM = $yM" }
      if { [catch {$m_image convert coords $xm $ym "deg $EQX" cx cy canvas}] } {set bonsai_flag 1}
      if { [catch {$m_image convert coords $xm $yM "deg $EQX" cx cy canvas}] } {set bonsai_flag 1}
      if { [catch {$m_image convert coords $xM $yM "deg $EQX" cx cy canvas}] } {set bonsai_flag 1}
      if { [catch {$m_image convert coords $xM $ym "deg $EQX" cx cy canvas}] } {set bonsai_flag 1}

      if $bonsai_flag {
         puts $lfId "world2: BONSAI ON "
         puts  "world2: BONSAI ON "
      } else {
          puts $lfId "world2: BONSAI OFF "
          puts "world2: BONSAI OFF"
      }
      C_wc coeff_wc $wx $wy; # needed for N1.8 camera

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!ACTION!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      # edges of the fits-image, the signs have been found by testing
      # required to draw the prohibited areas for reference star position testing
      # we should do this differently: we don't need the prohibited areas for selecting the reference stars,
      # only for verifying, therefore, we can use a black square for the focalfield
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!ACTION!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      # frames          wcs[deg]      canvas
      # focal field     p             field()
      # N3.7 array      q             mos(a-d)
      # N1.8 array      r             mos(e-h)
      # guider          s             guide()
      # ID field        id            ifield

      # firstly determine the rotation of fits image by tilt angle of focal field vertical center line
      set p1x $wx; set p1y [expr $wy+$scal*$YMIN]
      set p2x $wx; set p2y [expr $wy+$scal*$YMAX]
      # transform these points into canvas coords
      if {$bonsai_flag} {
           set dum [C_wc w2c $p1x $p1y]
           set p1x [lindex $dum 0]
           set p1y [lindex $dum 1]
           set dum [C_wc w2c $p2x $p2y]
           set p2x [lindex $dum 0]
           set p2y [lindex $dum 1]
      } else {
           if {$debug} { puts "p1: $p1x / $p1y,   p2: $p2x / $p2y" }
           $m_image convert coords $p1x $p1y "deg $EQX" p1x p1y canvas
           $m_image convert coords $p2x $p2y "deg $EQX" p2x p2y canvas
      }

      # secondly determine the scale factor for fpmm -> canvas conversion
      set dx [expr $p1x-$p2x]
      set dy [expr $p1y-$p2y]
      set ctom [expr sqrt($dx*$dx+$dy*$dy)/($YMAX-$YMIN)]

      # ne_flag=1 means, image is not rotated, the slope of the mask can be infinity in canvas coords
      set ne_flag 0
      if {[expr abs($p1x-$p2x)]<1e-2} {set ne_flag 1}

      if {$debug} {
        if {$ne_flag} {puts stdout "world2: frame || WCS -> not rotated" } else {
            puts stdout "world2: frame \/ WCS -> rotated" }
      }

      if {!$ne_flag} {
         set loc_m [expr $dy/$dx]
         set loc_m1 [expr 1.0/sqrt($loc_m*$loc_m+1.0)]
         if {$debug} { puts "m = $loc_m m1 = $loc_m1 ctom = $ctom" }
      }

      # ctom: focal plane mm -> canvas conversion factor
      # loc_m: tan(d), loc_m1: cos(d), d: rotation angle + 90 deg (zero rotation corresponds to infinite tan)

      #---------------------------------------------------------------------------
      # thirdly calculate canvas coordinates of array projections and of focal field

      # N3.75 and N1.80 projection of the array
      # we take the field height for all array projections
      set q1x $wx; set q1y [expr $wy + $scal * $YMIN]
      set q2x $wx; set q2y [expr $wy + $scal * $YMAX]
      set r1x $wx; set r1y [expr $wy + $scal * $YMIN]
      set r2x $wx; set r2y [expr $wy + $scal * $YMAX]

      # transform these points into canvas coords
      if $bonsai_flag {
         set dum [C_wc w2c $q1x $q1y]
         set q1x [lindex $dum 0]
         set q1y [lindex $dum 1]
         set dum [C_wc w2c $q2x $q2y]
         set q2x [lindex $dum 0] 
         set q2y [lindex $dum 1]
      } else {
         $m_image convert coords $q1x $q1y "deg $EQX" q1x q1y canvas
         $m_image convert coords $q2x $q2y "deg $EQX" q2x q2y canvas
      }

      # Array projection with N1.8 camera is larger than field size, may be outside fits image
      # to be save use bonzai-conversion (accuracy not important)
      set dum [C_wc w2c $r1x $r1y]
      set r1x [lindex $dum 0]
      set r1y [lindex $dum 1]
      set dum [C_wc w2c $r2x $r2y]
      set r2x [lindex $dum 0]
      set r2y [lindex $dum 1]

      # Field containing ID number in mm-FP:
      # ************************************
      set id(xa) -103.0;   set id(ya) -104.0
      set id(xb) -94.0;   set id(yb) -104.0
      set id(xc) -94.0;   set id(yc) -101.0
      set id(xd) -103.0;   set id(yd) -101.0

      # Transformation to WCS and canvas coordinates
      # ********************************************
      foreach val { a b c d } {
         set id(x$val) [ expr $wx + $scal*$trigo*$id(x$val) ]
         set id(y$val) [ expr $wy + $scal*$id(y$val) ]
         if { $debug } { puts "WCS: id(x$val)= $id(x$val), id(y$val) = $id(y$val)" }
         set dum [C_wc w2c $id(x$val) $id(y$val)]
         set ifield(x$val) [lindex $dum 0]; set ifield(y$val) [lindex $dum 1]
         if { $debug } { puts "canvas: ifield(x$val) = $ifield(x$val), ifield(y$val) = $ifield(y$val)" }
      }
      # Guider patrol field, described by an arc plus a polygon through the field center
      # The arc is defined by: 2 diagonal corners of the square enclosing the circle, the start angle, and the angular extent
      # The corners of the poly are given in mm-FP (up is negative relative to the image center in canvas and screen coordinates):
      # set ax $XMAX; set ay 0.
      # set bx 0.;    set by $YMAX
      # FP coordinates in mm:
      # ***********************
      set ar(xa) -90.0;  set ar(ya) 0.0
      set ar(xb)  90.0;  set ar(yb) 0.0
      set ar(xc)  90.0;  set ar(yc) 165.0
      set ar(xd)  -90.0;  set ar(yd) 165.0
      set rc 0.0;
      set ar(xm)   0.0;  set ar(ym) 0.
      set ar(x7)  90.0;  set ar(y7) 165.
      set ar(x6)  90.0;  set ar(y6) 165.
      set ar(x5)  90.0;  set ar(y5) 165.
      set ar(x4)  90.0;  set ar(y4) 165.
      set ar(x3)  90.0;  set ar(y3) 165.
      set ar(x2)  90.0;  set ar(y2) 165.
      set ar(x1)  90.0;  set ar(y1) 165.

      # Transformation to WCS and canvas coordinates
      # ********************************************
      foreach val { a b c d m 1 2 3 4 5 6 7 } {
         set ar(x$val) [expr $wx + $scal*$trigo*$ar(x$val)]
         set ar(y$val) [expr $wy + $scal*$ar(y$val)]
         if { $debug } { puts "WCS: ar(x$val) = $ar(x$val), ar(y$val) = $ar(y$val)" }
         set dum [C_wc w2c $ar(x$val) $ar(y$val)]
         set guide(x$val) [lindex $dum 0]; set guide(y$val) [lindex $dum 1]
         if { $debug } { puts "canvas: guide(x$val) = $guide(x$val), guide(y$val) = $guide(y$val)" }
      }

      if $ne_flag {
        # mask not rotated, we assume red =  sky-west = x<0
        # focal field -------------------------------------------------------------------
        set field(ya) $p1y
        set field(yb) $p1y
        set field(yc) $p2y
        set field(yd) $p2y
        set field(xa) [expr $p1x+$fits_x_scale*$ctom*$XMIN]
        set field(xb) [expr $p1x+$fits_x_scale*$ctom*$XMAX]
        set field(xc) [expr $p2x+$fits_x_scale*$ctom*$XMAX]
        set field(xd) [expr $p2x+$fits_x_scale*$ctom*$XMIN]

        # N3.75 array projection --------------------------------------------------------
        set mos(ya)   $p1y
        set mos(yb)   $p1y
        set mos(yc)   $p2y
        set mos(yd)   $p2y
        set mos(xa)   [expr $q1x+$fits_x_scale*$ctom*$XMIN_375]
        set mos(xb)   [expr $q1x+$fits_x_scale*$ctom*$XMAX_375]
        set mos(xc)   [expr $q2x+$fits_x_scale*$ctom*$XMAX_375]
        set mos(xd)   [expr $q2x+$fits_x_scale*$ctom*$XMIN_375]
      
        # N3.75 unclipped spectral range --------------------------------------------------------
        set mos(yar)  $p1y
        set mos(ybr)  $p1y
        set mos(ycr)  $p2y
        set mos(ydr)  $p2y
        set mos(xar)  [expr $q1x-$fits_x_scale*$ctom*$specmin]
        set mos(xbr)  [expr $q1x-$fits_x_scale*$ctom*$specmax]
        set mos(xdr)  [expr $q2x-$fits_x_scale*$ctom*$specmin]
        set mos(xcr)  [expr $q2x-$fits_x_scale*$ctom*$specmax]

        # N1.8 array projection ----------------------------------------------------------
        set mos(ye)  $p1y
        set mos(yf)  $p1y
        set mos(yg)  $p2y
        set mos(yh)  $p2y
        set mos(xe)  [expr $r1x+$fits_x_scale*$ctom*$XMIN_180]
        set mos(xf)  [expr $r1x+$fits_x_scale*$ctom*$XMAX_180]
        set mos(xg)  [expr $r2x+$fits_x_scale*$ctom*$XMAX_180]
        set mos(xh)  [expr $r2x+$fits_x_scale*$ctom*$XMIN_180]

        # N1.8 unclipped spectral range ----------------------------------------------------------
        set mos(yer) $p1y
        set mos(yfr) $p1y
        set mos(ygr) $p2y
        set mos(yhr) $p2y
        set mos(xer) [expr $r1x-$fits_x_scale*$ctom*$specmin]
        set mos(xfr) [expr $r1x-$fits_x_scale*$ctom*$specmax]
        set mos(xgr) [expr $r2x-$fits_x_scale*$ctom*$specmax]
        set mos(xhr) [expr $r2x-$fits_x_scale*$ctom*$specmin]

      } else {
        # Mask rotated
        # focal field --------------------------------------------------------------------
        set field(ya) [expr $p1y-$CRO*$fits_x_scale*$ctom*$XMIN*$loc_m1]
        set field(xa) [expr $p1x-$loc_m*($field(ya)-$p1y)]
        set field(yb) [expr $p1y-$CRO*$fits_x_scale*$ctom*$XMAX*$loc_m1]
        set field(xb) [expr $p1x-$loc_m*($field(yb)-$p1y)]
        set field(yc) [expr $p2y-$CRO*$fits_x_scale*$ctom*$XMAX*$loc_m1]
        set field(xc) [expr $p2x-$loc_m*($field(yc)-$p2y)]
        set field(yd) [expr $p2y-$CRO*$fits_x_scale*$ctom*$XMIN*$loc_m1]
        set field(xd) [expr $p2x-$loc_m*($field(yd)-$p2y)]

        # N3.75 array projection ----------------------------------------------------------
        set mos(ya)  [expr $p1y-$CRO*$fits_x_scale*$ctom*$XMIN_375*$loc_m1]
        set mos(xa)  [expr $q1x-$loc_m*($mos(ya)-$p1y)]
        set mos(yb)  [expr $p1y-$CRO*$fits_x_scale*$ctom*$XMAX_375*$loc_m1]
        set mos(xb)  [expr $q1x-$loc_m*($mos(yb)-$p1y)]
        set mos(yar) [expr $p1y+$CRO*$fits_x_scale*$ctom*$specmin*$loc_m1]
        set mos(xar) [expr $q1x-$loc_m*($mos(yar)-$p1y)]
        set mos(ybr) [expr $p1y+$CRO*$fits_x_scale*$ctom*$specmax*$loc_m1]
        set mos(xbr) [expr $q1x-$loc_m*($mos(ybr)-$p1y)]

        set mos(yc)  [expr $p2y-$CRO*$fits_x_scale*$ctom*$XMAX_375*$loc_m1]
        set mos(xc)  [expr $q2x-$loc_m*($mos(yc)-$p2y)]
        set mos(yd)  [expr $p2y-$CRO*$fits_x_scale*$ctom*$XMIN_375*$loc_m1]
        set mos(xd)  [expr $q2x-$loc_m*($mos(yd)-$p2y)]
        set mos(ycr) [expr $p2y+$CRO*$fits_x_scale*$ctom*$specmax*$loc_m1]
        set mos(xcr) [expr $q2x-$loc_m*($mos(ycr)-$p2y)]
        set mos(ydr) [expr $p2y+$CRO*$fits_x_scale*$ctom*$specmin*$loc_m1]
        set mos(xdr) [expr $q2x-$loc_m*($mos(ydr)-$p2y)]

        # N1.8 array projection ---------------------------------------------------------------
        set mos(ye)  [expr $p1y-$CRO*$fits_x_scale*$ctom*$XMIN_180*$loc_m1]
        set mos(xe)  [expr $r1x-$loc_m*($mos(ye)-$p1y)]
        set mos(yf)  [expr $p1y-$CRO*$fits_x_scale*$ctom*$XMAX_180*$loc_m1]
        set mos(xf)  [expr $r1x-$loc_m*($mos(yf)-$p1y)]
        set mos(yer) [expr $p1y+$CRO*$fits_x_scale*$ctom*$specmin*$loc_m1]
        set mos(xer) [expr $r1x-$loc_m*($mos(yer)-$p1y)]
        set mos(yfr) [expr $p1y+$CRO*$fits_x_scale*$ctom*$specmax*$loc_m1]
        set mos(xfr) [expr $r1x-$loc_m*($mos(yfr)-$p1y)]

        set mos(yg)  [expr $p2y-$CRO*$fits_x_scale*$ctom*$XMAX_180*$loc_m1]
        set mos(xg)  [expr $r2x-$loc_m*($mos(yg)-$p2y)]
        set mos(yh)  [expr $p2y-$CRO*$fits_x_scale*$ctom*$XMIN_180*$loc_m1]
        set mos(xh)  [expr $r2x-$loc_m*($mos(yh)-$p2y)]
        set mos(ygr) [expr $p2y+$CRO*$fits_x_scale*$ctom*$specmax*$loc_m1]
        set mos(xgr) [expr $r2x-$loc_m*($mos(ygr)-$p2y)]
        set mos(yhr) [expr $p2y+$CRO*$fits_x_scale*$ctom*$specmin*$loc_m1]
        set mos(xhr) [expr $r2x-$loc_m*($mos(yhr)-$p2y)]

      }

      if {$debug} {
        puts "init_mask_world2: XMIN = $XMIN, XMIN_180 = $XMIN_180, XMIN_375 = $XMIN_375 \n"
        puts "init_mask_world2: specmin = $specmin, specmax = $specmax \n"
        puts "init_mask_world2: field x.abcd: \n $field(xa), $field(xb), $field(xc), $field(xd)"
        puts "init_mask_world2: field y.abcd: \n $field(ya), $field(yb), $field(yc), $field(yd) \n"
        puts "init_mask_world2: N3.75 camera \n mos(x.abcd): $mos(xa), $mos(xb), $mos(xc), $mos(xd)"
        puts "init_mask_world2: N3.75 camera \n mos(y.abcd): $mos(ya), $mos(yb), $mos(yc), $mos(yd) \n"
        puts "init_mask_world2: N3.75 camera \n mos(x.abcd.r): $mos(xar), $mos(xbr), $mos(xcr), $mos(xdr)"
        puts "init_mask_world2: N3.75 camera \n mos(y.abcd.r): $mos(yar), $mos(ybr), $mos(ycr), $mos(ydr) \n"
        puts "init_mask_world2: N1.8 camera \n mos(x.efgh): $mos(xe), $mos(xf), $mos(xg), $mos(xh)"
        puts "init_mask_world2: N1.8 camera \n mos(y.efgh): $mos(ye), $mos(yf), $mos(yg), $mos(yh) \n"
        puts "init_mask_world2: N1.8 camera \n mos(x.efgh.r): $mos(xer), $mos(xfr), $mos(xgr), $mos(xhr)"
        puts "init_mask_world2: N1.8 camera \n mos(y.efgh.r): $mos(yer), $mos(yfr), $mos(ygr), $mos(yhr) \n"
      }

      # finally the central green circle mos(x/y) in canvas  coords,
      # ccx ccy actual canvas coords, $m_image convert coords $wx $wy "deg $EQX" ccx  ccy canvas

      # defining oldpos is required for shift
      set oldpos(x) $ccx; set oldpos(y) $ccy
      puts $lfId "Init_Mask_World: new center ($ccx,$ccy) = ($wx,$wy)"
      # the radius of the green circle in world coords
      set mos(r) [expr $scal*$XMAX/40.]
      if $bonsai_flag {
        set dumx [expr ($mos(xa)-$mos(xc))/50.0]
        set dumy [expr ($mos(ya)-$mos(yc))/50.0]
        set mos(r) [expr sqrt($dumx*$dumx+$dumy*$dumy)*0.4]
      } else {
        $m_image convert dist  $mos(r) 0 "deg $EQX" mos(r) dummy canvas
        if {$mos(r) < $dummy} { set mos(r) $dummy}
      }
      if {$debug} { puts stdout "radius = $mos(r)" }

      # the angle between mask and pixel/canvas/screen system
      set abs_ang_rad 0.0
      # the angle between mask and WCS, depends on the orientation of the WCS,  see CSO
      set PAM 0.0

      if {$mountangle == 180} {
         set dummy [$this cget -rotangle]
         $this configure -rotangle $mountangle
         $this rotate $m_canvas $mos(x0) $mos(y0) 1
         $this configure -rotangle $dummy
         set abs_ang_rad 0.0
         set PAM 0.0
         set tcs_pam 0.0
      } else {
      }

      # ------------------------------------------------------------------------
      # the mc coefficients have to be calculated independent on the bonsai flag

      mos::MOS_SLIT::coeff $XMIN $YMIN $field(xa) $field(ya) \
                           $XMAX $YMIN $field(xb) $field(yb) \
                           $XMAX $YMAX $field(xc) $field(yc)

      set mask_initialized 1
      if {$debug} { puts "init_mask_world2 END_________________" }
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::reset_mask { } {

      # reset the mask
      # telescope pointing in [canvas]
      # puts $lfId "Reset_Mask:  m_image=>>$m_image<< \

      # in case a new image is loadad
      # mask center x_ff=0,y_ff=0 is center of frame
      EXE begin
      set world_x [$m_image fits get CRVAL1]
      set world_y [$m_image fits get CRVAL2]

      # frameless mode
      # maybe better a string length operation
      if { $world_x == "" || $world_y == "" } {
         set wx [lindex [$m_image wcsset] 0]
         set wy [lindex [$m_image wcsset] 1]
         $m_image convert coords $wx $wy "wcs $EQX" world_x world_y "deg $EQX"
      }

      # for status panel
      set sp_instrume [$m_image fits get INSTRUME]
      set sp_origin   [$m_image fits get ORIGIN]

      set wx $world_x; set wy $world_y
      set ccx [$m_image fits get CRPIX1]
      set ccy [$m_image fits get CRPIX2]
      #***************************************************************************
      puts "reset_mask------------- ccx = $ccx, ccy = $ccy"
      #***************************************************************************

      # delete all instances of MOS slit
      set noms [mos::MOS_SLIT::nos]
      if {$noms>0} {
         for {set i 1} {$i <= $noms} { incr i 1} { delete object C_mos$i }
      }
      set noms [mos::MOS_SLIT::nos]
      mos::MOS_SLIT::set_mmff 0
      [code $this init_mask_world2 ]

      catch {$m_canvas delete A}
      catch {$m_canvas delete D}
      plot_mask

      if { ![mos::MOS_SLIT::get_mmff] } { load_mos_refslit }
      set last_action "Reset Mode"
      catch {SP update}
      EXE end
   }



#----------------------------------------------------------------------------------
   ::itcl::body MOS::update_and_replot { } {

      # do not reset the mask but replot the mask at the current position with
      # current configuration options but with different image zoom, flip option
      EXE begin
      update_color
      update_scale
      update_mask
      catch {$m_canvas delete A}
      catch {$m_canvas delete D}
      EXE end
      return [plot_mask]
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::update_mask { } {

      # What happens if you zoom the image or shift screen versus canvas ?
      # 1. rescale the mask according to the new image zoom, update the matrix mos(..,..)
      # 2. world coordinates retain

      EXE begin
      set debug 0
      # check on new scale, only used for trace
      set newscale [lindex [$m_image scale] 0]
      if {$newscale<0} { set newscale [expr -1.0/$newscale] }
      set stretch [expr (1.0*$newscale)/(1.0*$canvscale)]
      set canvscale $newscale
      if {$debug} { puts "update_mask: stretch = $stretch" }

      # 1. determine new canvas postion using retained world coords, do this in all cases
      set dum [C_wc w2c $world_x $world_y]
      set x [lindex $dum 0]
      set y [lindex $dum 1]
      set shift_x [expr $x - $ccx]
      set shift_y [expr $y - $ccy]
      if {$debug} { puts "update_mask: shift calculated \n shift_x = $shift_x, shift_y = $shift_y" }

      # set new center coordinates
      set ccx $x; set ccy $y
      puts $lfId "update_mask: scale=$newscale stretch = $stretch world=$world_x,$world_y"

      # array image
      foreach val { 0 ar br cr dr er fr gr hr a b c d e f g h} {
          set mos(x$val) [expr $mos(x$val)+$shift_x]
          set mos(y$val) [expr $mos(y$val)+$shift_y]
      }
      if {$debug} { puts "update_mask: mos shift calculated" }

      # focal field
      foreach val { 0 a b c d } {
          set field(x$val) [expr $field(x$val)+$shift_x]
          set field(y$val) [expr $field(y$val)+$shift_y]
      }
      if {$debug} { puts "update_mask: field shift calculated" }

      # guider field
      foreach val { a b c d m 1 2 3 4 5 6 7 } {
          if { $debug } { puts "Old: guide(x$val) = $guide(x$val), guide(y$val) = $guide(y$val)" }
          set guide(x$val) [expr $guide(x$val) + $shift_x]
          set guide(y$val) [expr $guide(y$val) + $shift_y]
          if { $debug } { puts "New: guide(x$val) = $guide(x$val), guide(y$val) = $guide(y$val)" }
      }

      # ID field
      foreach val { a b c d } {
          set ifield(x$val) [expr $ifield(x$val)+$shift_x]
          set ifield(y$val) [expr $ifield(y$val)+$shift_y]
      }
      if {$debug} { puts "update_mask: ID-field shift calculated" }


      if {$stretch != 1} {
         # array image
         foreach val { 0 a b c d e f g h ar br cr dr er fr gr hr } {
             set mos(x$val) [expr $mos(x0)+($mos(x$val)-$mos(x0))*$stretch]
             set mos(y$val) [expr $mos(y0)+($mos(y$val)-$mos(y0))*$stretch]
         }
         if {$debug} { puts "update_mask: mos stretch calculated" }

         # focal field
         foreach val { 0 a b c d } {
             set field(x$val) [expr $field(x0)+($field(x$val)-$field(x0))*$stretch]
             set field(y$val) [expr $field(y0)+($field(y$val)-$field(y0))*$stretch]
             # puts "field(x$val) = $field(x$val), field(y$val) = $field(y$val)"
         }
         if {$debug} { puts "update_mask: field stretch calculated" }

         # guider field
         foreach val { a b c d 1 2 3 4 5 6 7 } {
             set guide(x$val) [expr $guide(xm)+($guide(x$val)-$guide(xm))*$stretch]
             set guide(y$val) [expr $guide(ym)+($guide(y$val)-$guide(ym))*$stretch]
         }

         # ID field
         foreach val { a b c d } {
             set ifield(x$val) [expr $field(x0)+($ifield(x$val)-$field(x0))*$stretch]
             set ifield(y$val) [expr $field(y0)+($ifield(y$val)-$field(y0))*$stretch]
             # puts "ifield(x$val) = $ifield(x$val), ifield(y$val) = $ifield(y$val)"
         }
         if {$debug} { puts "update_mask: ID-field stretch calculated" }


         # the green circle (radius is a distance)
         if {$debug} { puts "update_mask: old mos(r) = $mos(r), stretch = $stretch" }
         set mos(r) [expr $mos(r)*$stretch]
         if {$debug} { puts "update_mask: new mos(r) = $mos(r)" }
         # aleady done
      }

      mos::MOS_SLIT::coeff $XMIN $YMIN $field(xa) $field(ya) \
                           $XMAX $YMIN $field(xb) $field(yb) \
                           $XMAX $YMAX $field(xc) $field(yc)

      # the reference stars
      for {set i 1} { $i <=10} { incr i 1 } {
          catch {
             set ref($i,x) [expr $mos(x0)+($ref($i,x)-$mos(x0))*$stretch]
             set ref($i,y) [expr $mos(y0)+($ref($i,y)-$mos(y0))*$stretch]
          }
      }

      # the guide stars
      for {set i 1} { $i <=10} { incr i 1 } {
          catch {
             set guid($i,x) [expr $mos(x0)+($guid($i,x)-$mos(x0))*$stretch]
             set guid($i,y) [expr $mos(y0)+($guid($i,y)-$mos(y0))*$stretch]
          }
      }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::update_color { } {

      EXE begin
      switch -exact -- [$this cget -colorset] {
           Red/Yellow    {set color1 red;     set color2 yellow}
           Black/White   {set color1 black;   set color2 white}
           Violet/Orange {set color1 violet;  set color2 orange}
           Green/Red     {set color1 green;   set color2 red}
           Gray          {set color1 #9f9f9f; set color2 #6f6f6f}
           Dark          {set color1 #000000; set color2 #2f2f2f}
           Bright        {set color1 white;   set color2 yellow}
           default       {puts $lfId "UpdateColor: Warning ColorSet"}
      }
      set color3 $color1; set color4 $color2
      # tranparency 
      switch -glob -- [$this cget -graytype] {
           0    { set color1 ""; set color2 ""
                  set trapa gray25
                }
           ??   { set trapa gray[$this cget -graytype]}
           100  { set trapa ""}
           1    { set trapa gray25; }
        default {puts $lfId "UpdateColor: Warning GrayType"}
      }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::plot_mask { } {

      # Modified R.H. 2007 09 06
      # Modes removed
      # Text on frame label modified

      # draws the whole mask once more with the new settings
      # the mos(,) array contains coordinates in canvas coords, ready for direct printing
      # no coords transformations have to be done
      #
      # tag A  = all elements
      # tag F  = focal field
      # tag N3 = array image on FP with N3.75 camera
      # tag N1 = array image on FP with N1.8 camera
      # tag P2 = white circle, rot+shift, dither 1/2 in IPOL
      # tag P3 = grey  circle, rot+shift, dither 1/3 in IPOL
      # tag m  = green circle, rotation and shift point
      # tag sw = slit width label
      # tag out = slit number rim label
      # tag D  = display, dont move

      EXE begin
      set debug 0
      if {$debug} { puts -nonewline "p" }
      set lcam [$this cget -camera]
      # puts stdout "PLOT_MASK: mod=$lmod mask=$mask sw=[$this cget -slit_width]"
      # general tasks:
      # plot the focal field rim (white frame and tag play grounds)
      # plot array field (blue frame)
      # plot the slits, the contents of the focal field
      # plot the labels (slit labels and focf labels)

      if {$debug} { puts -nonewline "l" }

      # --------------------------------
      # plot the focal field (rim)

      # field always plotted, as a thin white line
      $m_canvas create poly $field(xa) $field(ya) $field(xb) $field(yb) $field(xc) $field(yc) $field(xd) $field(yd) \
                            -outline white -fill "" -width 3 -tag  { A F }
      # +-1.25 arcmin limits for "sharp" slit images drawn as white lines
      set xlim1u [expr $field(xa) + ($field(xb) - $field(xa)) * 0.75/4.0]
      set ylim1u [expr $field(ya) + ($field(yb) - $field(ya)) * 0.75/4.0]
      set xlim1l [expr $field(xd) + ($field(xc) - $field(xd)) * 0.75/4.0]
      set ylim1l [expr $field(yd) + ($field(yc) - $field(yd)) * 0.75/4.0]
      set xlim2u [expr $field(xa) + ($field(xb) - $field(xa)) * 3.25/4.0]
      set ylim2u [expr $field(ya) + ($field(yb) - $field(ya)) * 3.25/4.0]
      set xlim2l [expr $field(xd) + ($field(xc) - $field(xd)) * 3.25/4.0]
      set ylim2l [expr $field(yd) + ($field(yc) - $field(yd)) * 3.25/4.0]
# comment out to remove small N-S lines for focal field 
# in future this could be a central circle for MODS [pm] 
#      $m_canvas create line $xlim1u $ylim1u $xlim1l $ylim1l -fill white -tag  { A F }
#      $m_canvas create line $xlim2u $ylim2u $xlim2l $ylim2l -fill white -tag  { A F }

      puts $lfId "FOCAL FIELD coordinates:"
      puts $lfId "create poly $field(xa) $field(ya) $field(xb) $field(yb) \
              $field(xc) $field(yc) $field(xd) $field(yd) -outline white -tag  { A F }"

      # plot the ID area
      $m_canvas create poly $ifield(xa) $ifield(ya) $ifield(xb) $ifield(yb) \
         $ifield(xc) $ifield(yc) $ifield(xd) $ifield(yd) -fill red -tag  { A F }

      # draw the array in blue, tag = mm
      if {[string match *180* $lcam ]} {
         # N1.8 camera
         $m_canvas create poly $mos(xe) $mos(ye) $mos(xf) $mos(yf) \
                $mos(xg) $mos(yg) $mos(xh) $mos(yh) -outline blue -fill "" -width 1 -tag { A N1 }
         # draws a semi-transparent grey surface on clipped areas
         # $m_canvas create poly $mos(xe) $mos(ye) $mos(xer) $mos(yer) $mos(xhr) $mos(yhr) $mos(xh) $mos(yh) \
         #         -outline "" -fill grey -stipple $trapa -tag { A N1 }
         # $m_canvas create poly $mos(xfr) $mos(yfr) $mos(xf) $mos(yf) $mos(xg) $mos(yg) $mos(xgr) $mos(ygr) \
         #         -outline "" -fill grey -stipple $trapa -tag { A N1 }

         # for mos standard mask mode we neeed a (invisible) tag play ground for standard mask aligment with center/gauss
         # this is done via a special trick: we add the ali tag to the mos tagged play gorund
         $m_canvas create poly $mos(xer) $mos(yer) $mos(xfr) $mos(yfr) $mos(xgr) $mos(ygr) $mos(xhr) $mos(yhr) \
                  -outline blue -fill "" -width 3 -stipple "" -tag { A N1 slit }

         if {$pics} {
            # if the center/gauss option is active, if we are in standard mask mode
            if {[mos::MOS_SLIT::get_mmff]} {
                $m_canvas addtag ali withtag mos
                $m_canvas addtag PG  withtag mos
                $m_canvas   dtag mos
            } else {
                $m_canvas addtag mos withtag ali
                $m_canvas   dtag ali
                $m_canvas   dtag PG
            }
         }

      } else {
         # N3.75 camera
         $m_canvas create poly $mos(xa) $mos(ya) $mos(xb) $mos(yb) \
                $mos(xc) $mos(yc) $mos(xd) $mos(yd) -outline blue -fill "" -width 1 -tag { A N3 }
         # draws a semi-transparent grey surface on clipped areas
         # $m_canvas create poly $mos(xa) $mos(ya) $mos(xar) $mos(yar) $mos(xdr) $mos(ydr) $mos(xd) $mos(yd) \
         #         -outline "" -fill grey -stipple $trapa -tag { A N3 }
         # $m_canvas create poly $mos(xbr) $mos(ybr) $mos(xb) $mos(yb) $mos(xc) $mos(yc) $mos(xcr) $mos(ycr) \
         #         -outline "" -fill grey -stipple $trapa -tag { A N3 }
         # for mos standard mask mode e neeed a (invisible) tag play ground for standard mask aligment with center/gauss
         # this is done via a special trick: we add the ali tag to the mos tagged play gorund
         # the area for positioning slits with AutoPos
         $m_canvas create poly $mos(xar) $mos(yar) $mos(xbr) $mos(ybr) $mos(xcr) $mos(ycr) $mos(xdr) $mos(ydr) \
                   -outline blue -fill "" -width 3 -tag { A N3 slit }

         if {$pics} {
            # if the center/gauss option is active, if we are in standard mask mode
            if {[mos::MOS_SLIT::get_mmff]} {
                $m_canvas addtag ali withtag mos
                $m_canvas addtag PG  withtag mos
                $m_canvas   dtag mos
            } else {
                $m_canvas addtag mos withtag ali
                $m_canvas   dtag ali
                $m_canvas   dtag PG
            }
         }
      }

      # we neeed a tag play ground for binding slit creation to field area
      $m_canvas create poly $field(xa) $field(ya) $field(xb) $field(yb) \
             $field(xc) $field(yc) $field(xd) $field(yd) -fill "" -smooth false -stipple "" -tag  { A F mos }

      # update the color for all slits
      mos::MOS_SLIT::put_col [list $color1 $color2 $color3 $color4 $trapa]
      # number of mos slits
      set noms [mos::MOS_SLIT::nos]
      if {$noms>0} {
         for {set i 1} {$i <= $noms} {incr i 1} {
            if {[C_mos$i cget -ON]} {
                 switch -exact -- [C_mos$i cget -shape] {
                    STRAIGHT { C_mos$i update_slit   }
                    CIRCLE   { C_mos$i update_circle }
                 }
                 C_mos$i plot_m
            }
         }
      }

      if {$debug} { puts -nonewline stdout "o" }

      # draw the green circle, showing the ccx ccy position = rotation axis, tag = mm , m
      # if {$debug} { puts "plot_mask, drawing green circle, r = $mos(r)" }
      $m_canvas create oval \
        [expr $mos(x0)-$mos(r)] [expr $mos(y0)-$mos(r)] \
        [expr $mos(x0)+$mos(r)] [expr $mos(y0)+$mos(r)] \
        -fill green -stipple $trapa -tag { A m m10 }
      $m_canvas create oval \
        [expr $mos(x0)-$mos(r)/20] [expr $mos(y0)-$mos(r)/20] \
        [expr $mos(x0)+$mos(r)/20] [expr $mos(y0)+$mos(r)/20] \
        -fill "" -stipple "" -tag { A m m10 }

      # defines orientation: at x>0,y>0 North East
      # here only for some tests

      if {$debug} { puts -nonewline stdout "t" }

      # plot the LABELS
      # plot of sky directions moved to plot_tcs_label

      if {[$this cget -label]} {
         # label orientation
         if {$fits_x_scale ==  1.0} {set oriA e; set oriB w }
         if {$fits_x_scale == -1.0} {set oriA w; set oriB e }
         if {$mountangle == 180} { set dummy $oriA; set oriA $oriB; set oriB $dummy }
         $m_image convert coords $world_x $world_y "deg $EQX" lwx lwy "wcs $EQX"
         if {$debug} { puts -nonewline stdout "-" }
         if {$debug} { puts -nonewline stdout "m" }

         # 2.0 TCS labels (upper left corner)
         catch {$m_canvas delete D}
         plot_tcs_label

         if {$debug} { puts -nonewline stdout "a" }

         plot_mos_dispersion_label $oriA $oriB
         if {$noms>0} {
            for {set i 1} {$i <= $noms} {incr i 1} {
               if {[C_mos$i cget -ON]} { C_mos$i plot_label $oriA $oriB }
            }

            if {[mos::MOS_SLIT::get_mmff]} {
               # if technical mask mode draw a cyan move circle at the first of many technical slits
               # get x y width length in mm focal plane
               set first_slit [C_mos1 get_slit]
               # puts stdout "slit center x/y(mm) >[lindex $first_slit 0]< >[lindex $first_slit 1]<";

               # first_slit 0,1 = x,y center of slit
               # draw cyan circle 3 times a slit width away from the slit center, take the smallest (either width or length)
               # note: the radius of the green move-circle is about 8'' or ~4mm
               # the cyan cricle should be at least 16'' or 8 mm away from the green circle
               if { [lindex $first_slit 2] < [lindex $first_slit 3] } {
                  set shift [lindex $first_slit 2]
               } else {
                  set shift [lindex $first_slit 3]
               }
               if { $shift < 4 } { set shift 4 }

               set px [expr [lindex $first_slit 0]+$shift*3.0 ]
               set py [expr [lindex $first_slit 1]-$shift*3.0 ]

               # slit center in canvas to plot
               set a [mos::CONV_MC::m2c $px $py]
               # puts stdout "cyan(mm)=($px,$py) (canvas)=$a shift(constant)=$shift"
               set loc_rad [expr $mos(r)/2.0]

               $m_canvas create oval \
                 [expr [lindex $a 0] - $loc_rad ] [expr [lindex $a 1] - $loc_rad ] \
                 [expr [lindex $a 0] + $loc_rad ] [expr [lindex $a 1] + $loc_rad ] \
                   -fill cyan -tag {A m}
            }
         }
      }
      # End plot labels ----------------------------------------------------------------------

      if {$debug} { puts -nonewline stdout "s" }
      if {$reftarg_zone} { plot_ref_star_frame }
      if {$guidestar_zone} { plot_guide_star_frame }
      ::mos::MOS::my_mask  edit_ref_targ plot
      ::mos::MOS::my_mask  edit_guide_star plot

      if {$debug} { puts stdout "k" }
      EXE end
      return 0
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::update_scale { } {

      EXE begin
      C_wc coeff_wc $wx $wy
      set ctom [eval calc_ctom]
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::wave_config_mask { four } {

      # Modified R.H. 2007 09 07
      # Modes removed
      # definitions of specmin/specmax modified ????????????????????????????????????
      # 09 10: user_lcen added, in definition of specmin/max ins_lamc replaced by user_lcen

      # this is called by the wavelength EntryForm 
      # this is also called by public variable grating

      # input is lmin lcen lmax who
      # who == grating (called by public variable grating)
      #        update when a new grism has been selected
      #        even the user_lmin and user_lmax look like not having been updated
      # who = wave (called by the wavelength entry widget)
      #       update only when the new user-defined wavelength
      #       border differs from user_lmin, user_lmax

      EXE begin
      set debug 0
      set four [split $four " " ]
      set flag 0

      if {$debug} { puts "WAVE CONFIG MASK" }
      # puts stdout "update WaveLeBord with >[lindex $three 0]< >[lindex $three 1]< >[lindex $three 2]<"

      # check if there are really changes with respect to the current wavelength range setting
      if {[string compare [lindex $four 3] "grating"]==0} {
         if {$mask_initialized} { set flag 1 }
            # puts stdout "called by grating, flag = $flag"
      } else {
         if {$user_lmin != [lindex $four 0]} { set flag 1; set user_lmin [lindex $four 0]}
         if {$user_lcen != [lindex $four 1]} { set flag 1; set user_lcen [lindex $four 1]}
         if {$user_lmax != [lindex $four 2]} { set flag 1; set user_lmax [lindex $four 2]}
         # puts stdout "called by Wave, flag = $flag"
      }
      if {$debug} { puts "wave_config_mask: four = $four, flag = $flag" }

      if {$flag} {
         wave_limit
         # if you want to keep the slits after selecting a new
         # wavelength range you must code here something awful

         if {$mask_initialized} {
            mos::CONV_MC::coeff_mc $XMIN $YMIN $field(xa) $field(ya) \
                                   $XMAX $YMIN $field(xb) $field(yb) \
                                   $XMAX $YMAX $field(xc) $field(yc)
         }

         if { [string match *BLUE* [$this cget -camera] ] == 1 } {
            if {$debug} { puts "wave_config: N3.75 camera settings" }
            set slmin  [expr -$specmin]
            set slmax   [expr -$specmax]
            set a [mos::CONV_MC::m2c  $slmin $YMIN]; set mos(xar) [lindex $a 0]; set mos(yar) [lindex $a 1]
            set a [mos::CONV_MC::m2c  $slmax $YMIN]; set mos(xbr) [lindex $a 0]; set mos(ybr) [lindex $a 1]
            set a [mos::CONV_MC::m2c  $slmin $YMAX]; set mos(xdr) [lindex $a 0]; set mos(ydr) [lindex $a 1]
            set a [mos::CONV_MC::m2c  $slmax $YMAX]; set mos(xcr) [lindex $a 0]; set mos(ycr) [lindex $a 1]
            if {$debug} { puts "wave_config: mos(x.abdc.r): $mos(xar), $mos(xbr), $mos(xdr), $mos(xcr)" }
         } else {
            if {$debug} { puts "wave_config: N1.8 camera settings" }
            set slmin   [expr -$specmin]
            set slmax   [expr -$specmax]
            set a [mos::CONV_MC::m2c  $slmin $YMIN]; set mos(xer) [lindex $a 0]; set mos(yer) [lindex $a 1]
            set a [mos::CONV_MC::m2c  $slmax $YMIN]; set mos(xfr) [lindex $a 0]; set mos(yfr) [lindex $a 1]
            set a [mos::CONV_MC::m2c  $slmin $YMAX]; set mos(xhr) [lindex $a 0]; set mos(yhr) [lindex $a 1]
            set a [mos::CONV_MC::m2c  $slmax $YMAX]; set mos(xgr) [lindex $a 0]; set mos(ygr) [lindex $a 1]
            if {$debug} {
               puts "wave_config: mos(x.efhg.r): $mos(xer), $mos(xfr), $mos(xhr), $mos(xgr)"
               puts "wave_config: mos(y.efhg.r): $mos(yer), $mos(yfr), $mos(yhr), $mos(ygr)"
            }
         }

         if {$mask_initialized} { update_and_replot }
      }
      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::indi_slit_mos { w sx sy } {

      # external configuration of an individual MOS slit
      #    slit   : width, length and posang, x/y position
      #    circle : radius, x/y position

      global .mxw
      EXE begin
      set debug 0
      if { $debug } { puts "indi_slit_mos" }
      $m_image convert coords $sx $sy screen x y canvas
      set curtag [lindex [$w gettags [$w find closest $x $y]] 2]
      set my [string range $curtag  3 end]

      if {$my <= $nf_refslit} {
          puts "Fixed mos reference slit ($my) : Cannot be changed !"
          return
      }
      C_mos$my plot_m 1

      switch -exact [C_mos$my cget -shape] {
         STRAIGHT {
              if [catch {wm deiconify .mxw}] {
                  EntryForm .mxw \
                      -title "Edit MOS Slit #$my for [C_mos$my cget -target_name]" \
                      -labels {Width/'' Length/'' Inclin/deg x/mm y/mm} \
                      -command "mos::MOS::my_mask config_mos $my" \
                      -values  "[C_mos$my cget -slit_width] \
                            [C_mos$my cget -slit_length] \
                            [C_mos$my cget -pos_ang] \
                            [format "%5.3f" [C_mos$my cget -slit_x]] \
                            [format "%5.3f" [C_mos$my cget -slit_y]]"
              } else {
                .mxw configure -values "[C_mos$my cget -slit_width] \
                           [C_mos$my cget -slit_length] \
                           [C_mos$my cget -pos_ang] \
                           [C_mos$my cget -slit_x] \
                           [C_mos$my cget -slit_y]"
              }
         }

         CIRCLE {
              if [catch {wm deiconify .mxw}] {
                 EntryForm .mxw \
                     -title "Edit MOS Circle #$my for [C_mos$my cget -target_name]" \
                     -labels {Diameter/'' x/mm y/mm} \
                     -command "mos::MOS::my_mask config_mos $my" \
                     -values  "[C_mos$my cget -slit_width] \
                            [format "%5.3f" [C_mos$my cget -slit_x]] \
                            [format "%5.3f" [C_mos$my cget -slit_y]]"
              } else {
                .mxw configure -values "[C_mos$my cget -slit_width] \
                            [C_mos$my cget -slit_x] \
                            [C_mos$my cget -slit_y]"
              }
         }
      }

      plot_mask
      set last_action "Configure MOS  \#$my"
      catch {SP update}
      EXE end

   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::delete_slit_mos { w sx sy } {

      # Modified 2007 10 16, R.H.
      # Focus on dialog box, delete slit by <return>

      EXE begin
      $m_image convert coords $sx $sy screen x y canvas
      set curtag [lindex [$w gettags [$w find closest $x $y]] 2]
      set my [string range $curtag  3 end]

      #- There fix ref slits that cannot be deleted -#
      if {$my <= $nf_refslit} {
         puts "Fixed mos referece slit ($my) : Cannot be deleted !"
         EXE end
         return
      }

      set wid .skycat1.mos_save
      catch {destroy $wid}
      set oldFocus [focus]
      set w [DialogWidget $wid \
       -text "You De-Select MOS slit #$my" \
       -bitmap warning \
       -default 0 \
       -buttons {OK Cancel} ]
      focus $w
      if { [$w activate] } return

      focus $oldFocus
      C_mos$my erase
      C_mos$my configure -ON 0

      # for statuspanel
      set last_action "Delete MOS \#$my"
      catch {SP update}
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::AutoPos_new {  } {


      EXE begin
      set debug 0

      if {$debug} { puts stdout "Hello in AutoPos_new" }

      # select one of the local catalogs _________________________________________________
      set a_c [get_cat]
      if {$a_c==""} {
         info_dialog "No catalog specified" .skycat1
         return
      }

      set loc_list [lindex [$a_c info variable info_] 4 ]
      # do not process empty list
      if {$loc_list == ""} {
         info_dialog "AutoPos : Error catalog empty " .skycat1
         return
      } else {
         if {$debug} { puts stdout "AutoPos : Hurray catalog not empty" }
      }

      # process headings; whats available __________________________________________________
      # source id, ra, dec required
      set loc_head [$a_c info variable headings_]
      set loc_head [lindex $loc_head 4]
      if {$debug} { puts stdout "AutoPos : catalog_head = >$loc_head<" }

      set fitsheader [$m_image wcsset]
      if {$debug} {
         puts stdout "AutoPos : fits header = $fitsheader"
         puts stdout "AutoPos : scale = [lindex $fitsheader 2] arcsec/pixel"
         puts stdout "AutoPos : rot   = [lindex $fitsheader 7] deg"
      }
      set WP [lindex $fitsheader 7]; # CROTA2 = World-Pixel
      if {$debug} { puts stdout "AutoPos: WP = $WP \n >fitsheader(10) = [lindex $fitsheader 10]<" }

      # MP = mask-pixel angle
      # PAM = mask-wcs angle  (=position angle of instrument)
      # WP = wcs-pixel angle (=fits keyword CROTA2)
      # give AutoPos neg MW, since AutoPos uses mathemat. angles
      # set MP [expr -$WP*$CSO - $PAM ]
      set MP [expr $WP - $PAM*$CSO ]; # mathemat mask angle
      if {$debug} { puts stdout "AutoPos : WP= $WP fixed PAM= $PAM MP= $MP" }

      # search in table header mandatory keywords
      # several tries
      set i_ra  [lsearch -glob  $loc_head *ra*]
      if {$i_ra == -1} { set i_ra  [lsearch -glob  $loc_head *RA*] }
      if {$i_ra == -1} { set i_ra  [lsearch -glob  $loc_head *Ra*] }
      if {$i_ra == -1} { info_dialog "AutoPos : Error catalog header RA" .skycat1; return }

      set i_dec [lsearch -glob  $loc_head *dec*]
      if {$i_dec == -1} { set i_dec  [lsearch -glob  $loc_head *DEC*] }
      if {$i_dec == -1} { set i_dec  [lsearch -glob  $loc_head *Dec*] }
      if {$i_dec == -1} { info_dialog "AutoPos : Error catalog header DEC" .skycat1; return }

      set i_id  [lsearch -glob  $loc_head *id*]
      if {$i_id == -1} { set i_id  [lsearch -glob  $loc_head *ID*] }
      if {$i_id == -1} { set i_id  [lsearch -glob  $loc_head *Id*] }
      if {$i_id == -1} { set i_id  [lsearch -glob  $loc_head *name*] }
      if {$i_id == -1} { set i_id  [lsearch -glob  $loc_head *target*] }
      if {$i_id == -1} { set i_id  [lsearch -glob  $loc_head *star*] }
      if {$i_id == -1} { set i_id  [lsearch -glob  $loc_head *object*] }
      if {$i_id == -1} { info_dialog "AutoPos : Error catalog header ID" .skycat1
                         return }

      if {$debug} { puts stdout "AutoPos : Hurray catalog header " }

      # set parameters for slit creation
      set sl [ $this cget -slit_length ];       # slit length in arcsecs
      set sldeg [expr $sl * $atd];              # slit length in deg


      # read source list _______________________________________________________________________
      set counter 0
      if {$debug} { puts stdout ">>$loc_list<<" }
      foreach star $loc_list {
        incr counter 1
        set px 0; set py 0; set alp 0; set dec 0
        set id [lindex $star $i_id]
        set ira [lindex $star $i_ra]
        set idec [lindex $star $i_dec]
        catch {$m_image convert coords $ira $idec "wcs $EQX" alp dec "deg $EQX" }
        catch {$m_image convert coords $ira $idec "wcs $EQX" px py image }
        # target name strings must not contain blanks, hence fill them with "_"
        set id [string_exchange $id " " "_" ]
        if { $debug } { puts "AutoPos_new: id = $id, ra = $ira, dec = $idec, px = $px, py = $py sldeg = $sldeg" }
        if {$px>0} { set_slit $id $alp $dec $px $py $sldeg }
      }

      # for status panel
      set last_action "Create MOS \#$noms"
      catch {SP update}

      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::set_slit { id alp dec px py sldeg } {

      EXE begin
      set debug 0
      set inside_area_flag 0
      set i_a_f 0
      set assigned 1

      if { $debug } { puts "Hello in set_slit" }
      if { $debug } { puts "set_slit: id = $id, ra = $alp, dec = $dec, px = $px, py = $py sldeg = $sldeg" }

      # transform slit center from image to canvas
      catch {$m_image convert coords $px $py image xc yc canvas }

      # define limits of slit location area (blue rectangle)
      set lcam [ $this cget -camera ]
      if {[ string match *180* $lcam ] } {
         set g1x $mos(xer);   set g1y $mos(yer)
         set g2x $mos(xfr);   set g2y $mos(yfr)
         set g3x $mos(xgr);   set g3y $mos(ygr)
         set g4x $mos(xhr);   set g4y $mos(yhr)
      } else {
         set g1x $mos(xar);   set g1y $mos(yar)
         set g2x $mos(xbr);   set g2y $mos(ybr)
         set g3x $mos(xcr);   set g3y $mos(ycr)
         set g4x $mos(xdr);   set g4y $mos(ydr)
      }
      # define field limit (white square, in case of narrow waveband)
      set gg1x $field(xa);   set gg1y $field(ya)
      set gg2x $field(xb);   set gg2y $field(yb)
      set gg3x $field(xc);   set gg3y $field(yc)
      set gg4x $field(xd);   set gg4y $field(yd)

      if { $debug } { puts "set_slit: slit location area defined" }
      if { $debug } { puts "g1 = $g1x/$g1y, g2 = $g2x/$g2y, g3 = $g3x/$g3y, g4 = $g4x/$g4y" }

      # check if point is inside the blue rectangle
      set d1 [$this y_dist $xc $yc $g1x $g1y $g2x $g2y]
      if { $debug } { puts "d1(g1/2) = $d1" }
      if { $d1 > 0 } {
         set d1 [$this x_dist $xc $yc $g2x $g2y $g3x $g3y]
         if { $debug } { puts "d1(g2/3) = $d1" }
         if { $d1 < 0 } {
            set d1 [$this y_dist $xc $yc $g4x $g4y $g3x $g3y]
            if { $debug } { puts "d1(g3/4) = $d1" }
            if { $d1 < 0 } {
               set d1 [$this x_dist $xc $yc $g1x $g1y $g4x $g4y]
               if { $debug } { puts "d1(g4/1) = $d1" }
               if { $d1 > 0 } {
                  set inside_area_flag 1
               }
            }
         }
      }

      # Check if point is inside the white square (field)
      set d1 [$this y_dist $xc $yc $gg1x $gg1y $gg2x $gg2y]
      if { $debug } { puts "d1(gg1/2) = $d1" }
      if { $d1 > 0 } {
         set d1 [$this x_dist $xc $yc $gg2x $gg2y $gg3x $gg3y]
         if { $debug } { puts "d1(gg2/3) = $d1" }
         if { $d1 < 0 } {
            set d1 [$this y_dist $xc $yc $gg4x $gg4y $gg3x $gg3y]
            if { $debug } { puts "d1(gg3/4) = $d1" }
            if { $d1 < 0 } {
               set d1 [$this x_dist $xc $yc $gg1x $gg1y $gg4x $gg4y]
               if { $debug } { puts "d1(gg4/1) = $d1" }
               if { $d1 > 0 } {
                  set i_a_f 1
               }
            }
         }
      }

      set inside_area_flag [expr $inside_area_flag * $i_a_f]
      if { $inside_area_flag } {
         puts "slit $id in area"
      } else {
         puts "slit $id outside area"
      }

      # if slit inside area, test for collision with existing slits
      if { $inside_area_flag } {
         set assigned 1;                              # position is free
         set noms [mos::MOS_SLIT::nos]
         if { $debug } { puts "number of slits = $noms" }
         if {$noms==$mnomos} {
            info_dialog "Error: Cannot handle more than\n $mnomos MOS slits" .skycat1
            return
         }

         set dist_as [expr ($YMAX - $YMIN) * $focscale]
         set dist_canv [$this y_dist $field(xd) $field(yd) $field(xa) $field(ya) $field(xb) $field(yb)]
         set as2canv [expr $dist_canv / $dist_as]
         set sl_canv [expr $as2canv * $sldeg * 3600.]
         set d0 [$this y_dist $xc $yc $field(xa) $field(ya) $field(xb) $field(yb)]
         if { $debug } { puts "dist_as = $dist_as, dist_canv = $dist_canv, sl_canv = $sl_canv, d0 = $d0" }
         if { $noms > 6 } {
            for { set i 7 } { $i <= $noms } { incr i } {
               set dummy [C_mos$i get_xy_canv]
               set xci [lindex $dummy 0]; set yci [lindex $dummy 1]
               if { $debug } { puts "xci = $xci, yci = $yci" }
               set di [$this y_dist $xci $yci $field(xa) $field(ya) $field(xb) $field(yb)]
               if { $debug } { puts "di = $di" }
               if { [expr abs($d0 - $di)] < $sl_canv } { set assigned 0 };   # position is occupied
            }
         }
         if { $debug } { puts "set_slit: assigned = $assigned" }

         if { $assigned } {
            set targw(1,f) 1
            set targw(1,x) $px
            set targw(1,y) $py
            $m_image convert coords $px $py image targw(1,a) targw(1,d) "wcs $EQX"

            set ff [list $XMIN_375 $XMAX_375]
            if {[string match *180* [$this cget -camera]]} { set ff [list $XMIN_180 $XMAX_180] }
            set mos_sl  [$this cget -slit_length]
            if {[string match *CIRCLE* [$this cget -mos_shape] ]} { set mos_sl [$this cget -slit_width] }

            set a [mos::MOS_SLIT C_mos[incr noms 1] $m_canvas $m_image $xc $yc \
                -eqx $EQX \
                -slit_width [$this cget -slit_width] \
                -slit_length $mos_sl \
                -pos_ang 0.0  \
                -shape [$this cget -mos_shape] \
                -ff $ff \
                -target_name $id \
                -ON 1 \
                -child $this ]

            if { $debug } { puts "slit [mos::MOS_SLIT::nos] created on source $id" }
         }
      }

      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::y_dist { px py g1x g1y g2x g2y } {

      # calculates the distance of a source from a line in dispersion direction (e.g. ab, dc)
      EXE begin
      set debug 0

      if { $debug } { puts "y_dist input: $px $py $g1x $g1y $g2x $g2y" }
      if { [expr abs($g1y - $g2y)] < 0.01 } { return [expr $py - $g1y] }
      if { $g1x > $g2x } {
         set m $g1x; set g1x $g2x; set g2x $m
         set m $g1y; set g1y $g2y; set g2y $m
      }
         
      set a [expr $g2x - $g1x];   set b [expr $g2y - $g1y]
      set dn [expr sqrt($a*$a + $b*$b) ]
      set nx [expr -$b/$dn];  set ny [expr $a/$dn]
      set sp [expr ($px - $g1x)*$nx + ($py - $g1y)*$ny]
      if { $debug } { puts "y_dist: g1x = $g1x, g1y = $g1y, nx = $nx, ny = $ny, sp = $sp" }

      EXE end
      return $sp
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::x_dist { px py g1x g1y g2x g2y } {

      # calculates the distance of a point from a line in dispersion direction (eg. bc, ad)
      EXE begin
      set debug 0

      if { [expr abs($g1x - $g2x)] < 0.01 } { return [expr $px - $g1x] }
      if { $g1y > $g2y } {
         set m $g1x; set g1x $g2x; set g2x $m
         set m $g1y; set g1y $g2y; set g2y $m
      }

      set a [expr $g2x - $g1x];   set b [expr $g2y - $g1y]
      set dn [expr sqrt($a*$a + $b*$b) ]
      set nx [expr $b/$dn];  set ny [expr -$a/$dn]
      set sp [expr ($px - $g1x)*$nx + ($py - $g1y)*$ny]
      if { $debug } { puts "x_dist: g1x = $g1x, g1y = $g1y, nx = $nx, ny = $ny, sp = $sp" }

      EXE end
      return $sp
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::anoms { } {

      # returns the number of all non-deleted mos slits
      EXE begin
      set noms [mos::MOS_SLIT::nos]
      set s_c 0;

      for {set i 1} {$i <= $noms} { incr i 1} {
          if {[C_mos$i cget -ON]} { incr s_c 1 }
      }
      EXE end
      return $s_c
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::arsc { } {

      # returns the number of all reference mos slits
      EXE begin
      set noms [mos::MOS_SLIT::nos]
      set s_c 0

      for {set i 1} {$i <= $noms} { incr i 1} {
          if {[C_mos$i cget -ON]} {
             if {[C_mos$i cget -ref_slit]} { incr s_c 1 }
          }
      }
      EXE end
      return $s_c
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::config_mos { my wilepo } {

      # store new slit width parameters
      # my = current mos slit number
      # wilepo = list of width/'' length'' slitposang/deg x y
      EXE begin
      set debug 0

      set wi [lindex $wilepo 0]
      set le [lindex $wilepo 1]
      set po [lindex $wilepo 2]
      set x [lindex $wilepo 3]
      set y [lindex $wilepo 4]

      if { $debug } { puts "mos::MOS::config_mos wilepo: $wi, $le, $po, $x, $y" }

      if {$po==""}  { set po 0.0 }
      switch -exact -- [C_mos$my cget -shape] {
         CIRCLE {
            if { $debug } { puts "config_mos CIRCLE" }
            if { $wi > 40.0 } { 
               puts [format "mos::MOS::config_mos: circle diameter = %5.3f> 40 mm, too large" $wi]
               puts "Slit setup canceled"
               return
            }
            C_mos$my configure -slit_width  [lindex $wilepo 0]
            C_mos$my configure -slit_length [lindex $wilepo 0]
            C_mos$my configure -slit_x    [lindex $wilepo 1]
            C_mos$my configure -slit_y    [lindex $wilepo 2]
         }
         STRAIGHT {
            if { $debug } { puts "config_mos STRAIGHT" }
            set l_size [expr sqrt($wi*$wi+$le*$le)  / cos($po/180.0*3.1415) ]
            if { $l_size > 40.0 } {
               puts [format "mos::MOS::config_mos: slit diagonal = %5.3f> 40 mm, too large" $l_size]
               puts "Slit setup canceled"
               return
            }
            C_mos$my configure -slit_width  [lindex $wilepo 0]
            C_mos$my configure -slit_length [lindex $wilepo 1]
            C_mos$my configure -pos_ang     [lindex $wilepo 2]
            C_mos$my configure -slit_x    [lindex $wilepo 3]
            C_mos$my configure -slit_y    [lindex $wilepo 4]
         }
      }

      C_mos$my plot_m 1
      if {$label} { C_mos$my plot_label e w }
      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::wave_length { } {

      # Modified 2007 09 10, R.H.
      # user_lcen added
      # external configuration of the wavelength range
      # Cancel button -> destroy
      global .wal
      EXE begin

      if [catch {wm deiconify .wal}] {
         EntryForm .wal \
            -title "Grating : [$this cget -grating] \n \
                    Filter: [$this cget -filter]\n \
                    Range : $A_disp($good,min) nm < \
                    $A_disp($good,cen) nm < $A_disp($good,max) nm\n \
                    Enter New Wavelength Intervall :" \
            -labels {Min Cen Max} \
            -command "mos::MOS::my_mask wave_config_mask" \
            -values  "$user_lmin $user_lcen $user_lmax"
      } else {
         .wal configure -values "$user_lmin  $user_lcen  $user_lmax"
      }
      EXE end
}


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::warn_filtgrat { } {

      # Modified 2007 09 10, R.H.
      # user_lcen added
      # external configuration of the wavelength range
      # Cancel button -> destroy
      # is obsolete, because filter/grating consistency is checked config menu
      # make it a dialog

      global .warn
      EXE begin

      if [catch {wm deiconify .warn}] {
          EntryForm .warn \
               -title "WARNING! \n Grating/Filter Mismatch! \n \
                       Grating1: not HK, Grating2 not z, J, \n Grating3 K, Ks only \n\n \
                       Selection is [$this cget -grating], [$this cget -filter] \n \
                       Selection not accepted, change grating \n" \
               -labels {Grating} \
               -command "mos::MOS::my_mask configure -grating" \
               -values "$grating"
      } else {
         .warn configure -values "$grating"
      }

      # if {[string compare $grating $gr] != 0} {mos::MOS::my_mask configure -grating $gr}
      # if {[string compare $filter $fi] != 0} {mos::MOS::my_mask configure -filter $fi}
      # puts "warn_filtgrat: $gr, $fi\n"

      EXE end
}


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::edit_ref_targ  { c } {

      # wrapper to allow external access to C_ref_targ
      # called by menu bars, defined in fors1_menu.tcl
      # statuspanel: update statuspanel only for 'add' and 'purge' and 'reset' 

      EXE begin
      set debug 0
      set res 0
      if {$debug} { puts "EDIT_REF_TARG .." }

      switch -exact -- $c {
         show { C_ref_targ show  }
        reset { C_ref_targ reset
                set sp_nort 0
	        set last_action "Reset Reference Targets"
                catch {SP update}
              }
          add { set stop 1
                set slit_flag 0
                set local OFF
                plot_ref_star_frame
                C_ref_targ add

                # for statuspanel
                set sp_nort  [C_ref_targ nort]
	        set last_action "Add Reference Target"
                catch {SP update}

                set stop 0
                C_ref_targ plot $mos(r)
                $m_canvas delete rtz
                set reftarg_zone 0
              }
        purge { C_ref_targ purge
                C_ref_targ plot $mos(r)

                # for status panel
                set sp_nort  [C_ref_targ nort]
                set last_action "Purge Reference Targets"
                catch {SP update}
              }
       verify {
                # plot the allowed zone
                set slit_flag 0
                plot_ref_star_area
                # reftarg_zone is set to 1 in plot_ref_star_area
                set res [C_ref_targ verify]

                # delete the allowed zone
	        $m_canvas delete rtz
	        set reftarg_zone 0

	        # for status panel
	        set sp_nort [C_ref_targ nort]
	        catch {SP update}
              }
        verify_load {
                set slit_flag 0
                plot_ref_star_area
                # reftarg_zone is set to 1 in plot_ref_star_area
                set res [ C_ref_targ verify 1 ]

                # delete the forbidden zone
                $m_canvas delete rtz
                set reftarg_zone 0

                # for status panel
                set sp_nort [C_ref_targ nort]
                catch {SP update}
              }
         plot { C_ref_targ plot $mos(r) }
      }
      EXE end
      return $res
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::edit_guide_star  { c } {

      # wrapper to allow external access to C_guide_star
      # called by menu bars, defined in menus.tcl
      # statuspanel: update statuspanel only for 'add' and 'purge' and 'reset' 
# status panel fuer guide star modifizieren!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
# requires also other changes: plot_ref_star_frame, etc

      EXE begin
      set debug 0
      set res 0
      if {$debug} { puts "EDIT_GUIDE_STAR .." }

      switch -exact -- $c {
         show { C_guide_star show  }
        reset { C_guide_star reset
                set sp_guid 0
	        set last_action "Reset Guide Stars"
                catch {SP update}
              }
          add { set stop 1
                set slit_flag 0
                set local OFF
                plot_guide_star_frame
                C_guide_star add

                # for statuspanel
                set sp_guid  [C_guide_star guid]
	        set last_action "Add Guide Star"
                catch {SP update}

                set stop 0
                C_guide_star plot $mos(r)
                $m_canvas delete gtz
                set guidestar_zone 0
              }
        purge { C_guide_star purge
                C_guide_star plot $mos(r)

                # for status panel
                set sp_guid  [C_guide_star guid]
	        set last_action "Purge Guide Stars"
                catch {SP update}
              }
       verify {
                # plot the allowed zone
                set slit_flag 0
                plot_guide_star_area
                # reftarg_zone is set to 1 in plot_ref_star_area
                set res [C_guide_star verify]

                # delete the allowed zone
	        $m_canvas delete gtz
	        set guidestar_zone 0

	        # for status panel
	        set sp_guid [C_guide_star guid]
	        catch {SP update}
              }
        verify_load {
                set slit_flag 0
                plot_guide_star_area
                # reftarg_zone is set to 1 in plot_ref_star_area
                set res [ C_guide_star verify 1 ]

                # delete the forbidden zone
	        $m_canvas delete gtz
	        set guidestar_zone 0

	        # for status panel
	        set sp_guid [C_guide_star guid]
	        catch {SP update}
              }
         plot { C_guide_star plot $mos(r) }
      }
      EXE end
      return $res
   }

#----------------------------------------- load and save mask configuration ------------------------------------------------------------------

#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_TPX { filename } {

      # the central method to load a .mms file
      EXE begin
      load_mos_TPX $filename
      # for statuspanel
      set last_action "Load SetUp"
      set sp_nort [C_ref_targ nort];  # number of reference targets
      catch {SP update}

      #Verify reference_targets
      # set fail_flag [edit_ref_targ verify_load]
      # if {$fail_flag} {
      #    info_dialog "There are reference targets in the forbidden zone!!!." .skycat1
      # }
      EXE end
  }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_mos_TPX { filename } {

      # reading a mods.<ec><pn>.mms file the input file must be a setup file like
      # 'mods.12.project.mms'
      # slits are given in wcs
      EXE begin
      set debug 0

      # test if this is necessary
      C_wc coeff_wc $wx $wy
      mos::MOS_SLIT::coeff $XMIN $YMIN $field(xa) $field(ya) \
                           $XMAX $YMIN $field(xb) $field(yb) \
                           $XMAX $YMAX $field(xc) $field(yc)

      # --- open filename ---------
      set num [expr [string length $instrument] - 1]
      set num [string index $instrument $num]
      set myfile $set_dir
      if {$debug} { puts stdout "load_mos_TPX >$filename<" }
      if {$filename==""} {
          # no filename means load result from AutoPos, written to .mms/SET/(p)mos(1/2).<ec>.autopos.mms
          # we load autopos from LOG dir
          set myfile $log_dir
          # append myfile "/mos[string index [$this cget -instrument] 7].$exposure_counter.auto_pos.mms"
          append myfile "/mods.$exposure_counter.auto_pos.mms"
          if {$debug} { puts "load_mos_TPX: AutoPos myfile = $myfile" }
      } else {
          if {$filename} {
             append myfile "/$filename"
             if {$debug} { puts "load_mos_TPX: filename argument: $myfile" }
          } else {
             # filename is zero, call dialog
             if {$debug} { puts "load_mos_TPX: start file dialog" }
             global .fs
             catch { destroy .fs  }
             # set myfile [filename_dialog $set_dir "mos[string index [$this cget -instrument] 7].*.mms" ]
             set myfile [filename_dialog $set_dir "mods.*.mms" ]
          }
      }

      if {$debug} { puts stdout "load_mos_TPX: $myfile"  }

      # if file is a standard-mask aperture definition file (ADF), b must be 'adf'
      set a [lindex [split $myfile "/"] [expr [llength [split $myfile "/" ] ] -1] ]
      set b [lindex [split $a "."] [expr [llength [split $a "."] ] -1 ] ]
      if {[string compare $b adf]==0} {
         load_mos_adf $myfile
         return
      }


      set keyword_tel TEL
      set keyword_ins INS
      set keyword_set SEQ.PREP
      set f_grat 0; set f_filt 0; set f_slit_width 0; set f_cam 0; set f_lmin 0
      set L_prop M_
      set L_mid 900000; # why ?????????????????????????????????????????????????
      set epo_flag 0; set equ_flag 0


      # step 1 : Read TEL and INS parameters, init mask
      #---------------------------------------------------------------------------------------------
      if {[file exists $myfile] & [file readable $myfile]} {
         set fileId [open $myfile r ]
         puts $lfId "MOS::load_mos_TPX  $fileId"
         while {[gets $fileId line_org] >= 0} {
              # if {$debug} { puts stdout $line_org }
              if {[string match #* $line_org]} {
              } else {
                 if {[string match *$keyword_tel* $line_org]==1} {
                    # TEL
                    switch -glob -- $line_org {
                    *ALPHA*   { set lwx [lindex $line_org 1] }
                    *DELTA*   { set lwy [lindex $line_org 1] }
                    *ROT.OFF* { set lPA [lindex $line_org 1] }
                    *EPOCH*   { set EQX [lindex $line_org 1]; set epo_flag 1 }
                    *EQUINOX* { set EQX [lindex $line_org 1]; set equ_flag 1 }
                    }
                 }

                 if {[string match *$keyword_set* $line_org]==1} {
                    if {[string match *CAM* $line_org]} {
                       # the camera
                       if {$debug} { puts stdout "SEQ.PREP.CAM = [lindex $line_org 1]" }
                       set l_cam [lindex $line_org 1]
                       set f_cam 1
                    }
                    if {[string match *GRAT* $line_org]} {
                       # the grating
                       if {$debug} { puts stdout "SEQ.PREP.GRAT = [lindex $line_org 1]" }
                       set l_grat [lindex $line_org 1]
                       set f_grat 1
                    }
                    if {[string match *LMIN* $line_org]} {
                       # the user defined wavelength region
                       if {$debug} { puts stdout "SEQ.PREP.LMIN = [lindex $line_org 1]" }
                       set l_min  [lindex $line_org 1]
                       set f_lmin 1
                    }
                    if {[string match *LCEN* $line_org]} {
                       # the user defined wavelength region
                       if {$debug} { puts stdout "SEQ.PREP.LCEN = [lindex $line_org 1]" }
                       set l_cen  [lindex $line_org 1] 
                    }
                    if {[string match *LMAX* $line_org]} {
                       # the user defined wavelength region
                       if {$debug} { puts stdout "SEQ.PREP.LMAX = [lindex $line_org 1]" }
                       set l_max [lindex $line_org 1]
                    }
                    if {[string match *FILT* $line_org]} {
                       # the os filter
                       if {$debug} { puts stdout "SEQ.PREP.FILT = [lindex $line_org 1]" }
                       set l_filt [lindex $line_org 1] 
                       set f_filt 1
                    }
                    if {[string match *MASK_NA* $line_org]} {
                       # the eso allocated proposal id
                       if {$debug} { puts stdout "SEQ.PREP.MASK_NA = [lindex $line_org 1]" }
                       set L_prop [lindex $line_org 1]
                    }
                    if {[string match *MASK_ID* $line_org]} {
                       # the mask id is either 900000 for science (sky) masks
                       # or 900001 <= id <= 900100 for technical masks
                       # science masks will get their id at paranal
                       if {$debug} { puts stdout "SEQ.PREP.MASK_ID = [lindex $line_org 1]" }
                       set L_mid [lindex $line_org 1]
                       mos::MOS_SLIT::set_MASK_NAID [list  $L_prop $L_mid]
                       if {$debug} { puts stdout "> [mos::MOS_SLIT::get_MASK_NAID]<" }
                       # we apply standard mask mode a little bit later after reset_mask  and after every slit has been created
                       # look for 'L_mid'
                    }
                    if {[string match *GOOD* $line_org]} {
                       set good [lindex $line_org 1]
                    }
                 }
             }
        }
        close $fileId
        if {$debug} { puts "*.mms file closed" }
      }

      # some tests for backfward compatibility
      if {!$equ_flag} { puts stdout "->->-> Warning TEL.TARG.EQUINOX not found" }
      if {$epo_flag}  { puts stdout "->->-> Warning TEL.TARG.EQUINOX defined via TEL.TARG.EPOCH = $EQX" }


      # set lPA [expr $lPA * -1]
      set lPA [expr fmod($lPA,360) ]

      set mask_initialized 0; # assume mask not yet reset
      # this is for only one reset_mask when more than one instrument config has been changed
      # when resetting the mask here, we have correct spectral limits of correct filter, but not user defined limits
      if {$mask_initialized==0} {
         if {$debug} { puts stdout "load_mos_TPX : Reset Mask" }
         reset_mask
      }
      # again, since reset does reset MASK_NAID
      mos::MOS_SLIT::set_MASK_NAID [list  $L_prop $L_mid]

      if {$f_grat} {
         # if the grating defined in the .mms file is different from the current one
         if {[string compare [$this cget -grating] $l_grat]} {
            if {$debug} { puts stdout "$m_mb.layout.gr invoke *$l_grat*" }
            $m_mb.layout.gr invoke *$l_grat*
            # $this configure -grating  $l_grat
         }
      }

      if {$f_filt} {
         # change only if new filt != old filt
         # puts stdout ">[$this cget -filter]< >$l_filt<"
         if {[string compare [$this cget -filter] $l_filt]} {
            if {$debug} { puts stdout "$m_mb.layout.fi invoke *$l_filt*" }
            $m_mb.layout.fi invoke *$l_filt*
         }
      }

      if {$f_cam} {
         # change only if different
         if {[string compare [$this cget -camera] $l_cam]} {
            if {$debug} { puts stdout "$m_mb.layout.sh invoke *$l_cam*" }
            $m_mb.layout.sh invoke *$l_cam*
         }
      }

      set ff [list $XMIN_375 $XMAX_375]
      if {[string match *180* [$this cget -camera] ]} { set ff [list $XMIN_180 $XMAX_180] }

      if {$f_lmin} {
         if { $debug } { puts stdout "load_mos_TPX: four = $l_min, $l_cen, $l_max, $l_grat" }
         set user_lmin $l_min; set user_lcen $l_cen; set user_lmax $l_max
         wave_config_mask "$l_min $l_cen $l_max grating"
      }

      $m_image convert coords $mos(x0) $mos(y0) canvas mx my screen
      mark $m_canvas $mx $my
      # $m_image convert coords $lwx $lwy "wcs $EQX" a1 d1 "deg $EQX" does not work!!!!!!

      set a1 [expr 15.0 *[DDMMSS2deg $lwx] ]
      set d1 [DDMMSS2deg $lwy]
      if {$debug} { puts stdout [format "deg $EQX: %10.3f %10.3f" $a1 $d1] }
      set world_x $a1
      set world_y $d1
      # wcs to canvas via bonsai matrix
      set dum [C_wc w2c $a1 $d1]
      puts "dum = $dum"
      set cx [lindex $dum 0]
      set cy [lindex $dum 1]
      if {$debug} { puts stdout "canvas center: $cx $cy" }
      $m_image convert coords $cx $cy canvas nwx nwy screen
      shift_load $m_canvas  $nwx $nwy

      $this configure -rotangle [ expr $lPA * $CSO ]
      set abs_ang_rad 0
      set PAM 0
      $this rotate $m_canvas $mos(x0) $mos(y0) 1

      $this configure -rotangle 5
      # abs_ang_rad back in rad again
      # puts stdout "load_mos_TPX : Rotate Mask $lPA"

      set lshap ""; set lwd 0.0; set lle 0.0; set lro 0.0
      set loc_x1 ""; set loc_x2 ""; set loc_x3 ""
      set loc_y1 ""; set loc_y2 ""; set loc_y3 ""
      set loc_REF  0

      # step 2: load the same file again, read INS create m slits
      # -------------------------------------------------------------
      puts stdout "load_mos_TPX : create mos slits"
      # reset targets and reference targets
      # check this:
      for {set i 1} { $i <= 50 } { incr i 1} { set targw($i,f) 0 }
      set a 0

      if {[file exists $myfile] & [file readable $myfile]} {
         set fileId [open $myfile r ]
         puts $lfId "MOS::load_mos_TPX  $fileId"
         while {[gets $fileId line_org] >= 0} {
              if {$debug} { puts stdout $line_org }
              if {[string match *$keyword_ins* $line_org]==1} {
              # INS
              switch -glob -- $line_org {
              *NUMBER* { set s_c [lindex $line_org 1]
                         if {$debug} { puts stdout "$s_c MOS slits in file" }
              }
              *ALPHA*  { set lwx [lindex $line_org 1]
                         set key [lindex $line_org 0]
                         set key [split $key "."]
                         set key [lindex $key 1]
                         set key [string trimleft $key "TARG"]
                         set loc_RA [expr 15.0 * [ DDMMSS2deg $lwx] ]
                         set loc_REF 0
                         if {$debug} { puts stdout "------A-$key-$loc_RA-" }
                         # science slit numbers start with 101
                         # reference targets have no names
                         if {$key<100} {
                            # reference target
                            set targw($key,f) 1
                            set targw($key,a) $loc_RA
                         }
              }
              *DELTA*  { set lwy [lindex $line_org 1]
                         set key [lindex $line_org 0]
                         set key [split $key "."]
                         set key [lindex $key 1]
                         set key [string trimleft $key "TARG"]
                         set loc_DEC [DDMMSS2deg $lwy]
                         if {$debug} { puts stdout "------D-$key-$loc_DEC-" }
                         # reference targets have no names
                         if {$key<100} {
                            # reference target
                            set targw($key,f) 1
                            set targw($key,d) $loc_DEC
                         } else {
                            # we assume that 'DELTA' is the last keyword for the slit read from the .mms file
                            # we can therefore create the slit here and now the next line read from the '.mms'
                            # will contain information for the next (=another) MOS slit
                            $m_image convert coords $loc_RA $loc_DEC "deg $EQX" x y canvas
                            $m_image convert coords $loc_RA $loc_DEC "deg $EQX" px py image
                            set noms [mos::MOS_SLIT::nos]

                            # this is necessary for calc_zemax
                            set targw(1,f) 1
                            set targw(1,x) $px
                            set targw(1,y) $py
                            $m_image convert coords $px $py image targw(1,a) targw(1,d) "wcs $EQX"

                            if {$noms==$mnomos} {
                               info_dialog "Error: Cannot handle more than\n $mnomos MOS slits" .skycat1
                               return
                            }

                            if {$loc_REF == 0} {
                                set a [mos::MOS_SLIT C_mos[incr noms 1] \
                                      $m_canvas \
                                      $m_image  \
                                      $x $y \
                                      -eqx $EQX \
                                      -target_name $loc_name \
                                      -slit_width  $lwd \
                                      -slit_length $lle \
                                      -pos_ang     $lro  \
                                      -ref_slit    $loc_REF \
                                      -shape $lshap \
                                      -ff $ff \
                                      -ON 1 \
                                      -child $this ]

                            }
                            if {$debug} { puts "loc_REF = $loc_REF, slit number: $a" }

                            # for the next slit
                            set loc_REF 0
                            puts "slit center: $targw(1,a), $targw(1,d)"
                           # C_mxus$noms status
                       }
              }

              *WID* { set lwd [lindex $line_org 1]
                      set key [lindex $line_org 0]
                      set key [split $key "."]
                      set key [lindex $key 1]
                      set key [string trimleft $key "TARG"]
                      set loc_W $lwd
                      if {$debug} { puts stdout "------W-$key-$loc_W-" }
              }
              *ROT* { set lro [lindex $line_org 1]
                      set key [lindex $line_org 0]
                      set key [split $key "."]
                      set key [lindex $key 1]
                      set key [string trimleft $key "TARG"]
                      set loc_RO $lro
                      if {$debug} { puts stdout "------R-$key-$loc_RO-" }
              }
              *SHAPE* { set lshap [lindex $line_org 1]
                        set key [lindex $line_org 0]
                        set key [split $key "."]
                        set key [lindex $key 1]
                        set key [string trimleft $key "TARG"]
                        set loc_SHAP $lshap
                        if {$debug} { puts stdout "------S-$key-$loc_SHAP-" }
              }
              *REF* { set lref [lindex $line_org 1]
                      set key [lindex $line_org 0]
                      set key [split $key "."]
                      set key [lindex $key 1]
                      set key [string trimleft $key "TARG"]
                      if {$lref} { set loc_REF 1 }
                      if {$debug} { puts stdout "------R-$key-$loc_REF-" }
              }
              *X1* { set x1 [lindex $line_org 1] 
                     set key [lindex $line_org 0]
                     set key [split $key "."]
                     set key [lindex $key 1]
                     set key [string trimleft $key "TARG"]
                     set loc_x1 $x1
                     if {$debug} { puts stdout "------X-$key-$x1-" }
              }
              *X2* { set x2 [lindex $line_org 1]
                     set key [lindex $line_org 0]
                     set key [split $key "."]
                     set key [lindex $key 1]
                     set key [string trimleft $key "TARG"]
                     set loc_x2 $x2
                     if {$debug} { puts stdout "------X-$key-$x2-" }
              }
              *X3* { set x3 [lindex $line_org 1]
                     set key [lindex $line_org 0]
                     set key [split $key "."]
                     set key [lindex $key 1]
                     set key [string trimleft $key "TARG"]
                     set loc_x3 $x3
                     if {$debug} { puts stdout "------X-$key-$x3-" }
              }
              *Y1* { set y1 [lindex $line_org 1]
                     set key [lindex $line_org 0]
                     set key [split $key "."]
                     set key [lindex $key 1]
                     set key [string trimleft $key "TARG"]
                     set loc_y1 $y1
                     if {$debug} { puts stdout "------Y-$key-$y1-" }
              }
              *Y2* { set y2 [lindex $line_org 1]
                     set key [lindex $line_org 0]
                     set key [split $key "."]
                     set key [lindex $key 1]
                     set key [string trimleft $key "TARG"]
                     set loc_y2 $y2
                     if {$debug} { puts stdout "------Y-$key-$y2" }
              }
              *Y3* { set y3 [lindex $line_org 1]
                     set key [lindex $line_org 0]
                     set key [split $key "."]
                     set key [lindex $key 1]
                     set key [string trimleft $key "TARG"]
                     set loc_y3 $y3
                     if {$debug} { puts stdout "------Y-$key-$y3-" }
              }
              *LEN* { set lle [lindex $line_org 1]
                      set key [lindex $line_org 0]
                      set key [split $key "."]
                      set key [lindex $key 1]
                      set key [string trimleft $key "TARG"]
                      set loc_LEN $lle
                      if {$debug} { puts stdout "------L-$key-$loc_LEN-" }
              }
              *NAME* { set lna [lindex $line_org 1]
                       set key [lindex $line_org 0]
                       set key [split $key "."]
                       set key [lindex $key 1]
                       set key [string trimleft $key "TARG"]
                       set loc_name $lna
                       if {$debug} { puts stdout "------N-$key-$loc_name-" }
              }
              default { puts stdout "------X->$line_org" }
              }
        }
      }
      close $fileId

      set s_c 0
      set result {ok}

      # --------- reference targets
      C_ref_targ reset
      for {set i 30} { $i <= 39} { incr i 1} {
         if {$targw($i,f)} {
            catch { #puts stdout "reference target : $i  $targw($i,a) $targw($i,d)"
                $m_image convert coords $targw($i,a) $targw($i,d) "deg $EQX" x y "wcs $EQX"
                C_ref_targ put $x $y
                C_ref_targ plot $mos(r); # delete all and plot all
            }
         }
      }

      if {[C_ref_targ nort]} { puts stdout "[C_ref_targ nort] Reference Targets found"
      } else { puts stdout "->->-> Warning No Reference Targets found" }
      # --------- reference targets end

      # --------- guide stars
      C_guide_star reset
      for {set i 40} { $i <= 49} { incr i 1} {
         if {$targw($i,f)} {
            catch { #puts stdout "guide star : $i  $targw($i,a) $targw($i,d)"
                $m_image convert coords $targw($i,a) $targw($i,d) "deg $EQX" x y "wcs $EQX"
                C_guide_star put $x $y
                C_guide_star plot $mos(r); # delete all and plot all
            }
         }
      }

      if {[C_guide_star guid]} { puts stdout "[C_guide_star guid] Guide Stars found"
      } else { puts stdout "->->-> Warning No Guide Stars found" }
      # --------- guide stars end


      # change to standard mask modus you loaded a science setup basED on a technical mask
      if {$L_mid>900000 && $L_mid<=900100} {
         mos::MOS_SLIT::set_mmff 1
         puts stdout "tech_mask = >[mos::MOS_SLIT::get_mmff]<"
      }

      puts stdout "+----------------------------+"
      puts stdout [ format "%2d MOS slits positioned" [mos::MOS_SLIT::nos] ]
      puts stdout "+----------------------------+"
      update_and_replot
      }

      set last [expr [string last "." $myfile] -1]
      set first [expr [string last "/" $myfile]  +1]
      set last_load_fn [string range $myfile $first $last]

      $this configure -file_name [lindex [split $last_load_fn "."] 2]

      catch {SP update }
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::load_mos_adf { filename } {

      # reading a mosn.<MaskId-900000>.standard.adf file
      # the input file must be a MODS aperture definition file like $MMSROOT/lib/mos/mos2.01.standard.adf
      # such files define one of the 100 MOS standard masks permanently located at the LBT
      # these masks need not to be manufactured, they are already there
      #

      EXE begin
      set debug 0
      if {$debug} { puts stdout "In load_mos_adf" }
      set a [split $filename "/"]
      set b [lindex $a [expr [llength $a ] -1] ]
      set c [split $b "."] 
      set d [string trimleft [lindex $c 1] 0]
      set fn_maskid [expr 900000 + $d ]
      if { $debug } {
         puts stdout "orig filename=$b"
         puts stdout "mode         =[lindex $c 0]"
         puts stdout "mask Id index=[lindex $c 1]"
         puts stdout "mask Id      =$fn_maskid"
         puts stdout "orig format  =[lindex $c 2]"
         puts stdout "orig .ext    =[lindex $c 3]\n\n"
      }

      if { [file exists $filename] & [file readable $filename] } {
        set fileId [open $filename r ]
        puts $lfId "MOS::load_mos_adf  $fileId"
        set i_flag 0;  # first line must be 'MODS'
        set lcounter 0; # line counter after 'MODS'
        set ff [list $XMIN_375 $XMAX_375]
        if {[string match *180* [$this cget -camera] ]} { set ff [list $XMIN_180 $XMAX_180] }
        reset_mask

        # set flag for standard mask mode
        mos::MOS_SLIT::set_mmff 1

        # extent the functionality of the playground center/slit now for the whole mask
        # $m_canvas addtag ali withtag mos

        # as long as there are lines in the file
        while {[gets $fileId line_org] >= 0} {
          if {[string match #* $line_org]} {
            # this is an optional comment line do nothing
            if { $debug } { puts stdout "comment> $line_org" }
          } else {
            puts stdout ">$i_flag< >$lcounter< >>>$line_org"
            if { $i_flag }  {
               incr lcounter 1
               switch -exact -- $lcounter {
                 1 {
                   # we expect the checksum, this checksum will be used as the program id for standard masks
                   set checksum $line_org
                   if { $debug } { puts stdout "checksum=$checksum" }
                   }
                 2 {
                   # we expect real mask id
                   set maskid $line_org
                   puts stdout "maskid  =$maskid"
                   if {$maskid != $fn_maskid } {
                       puts stdout "MASK_NAID inconsistency"
                       } else {
                       mos::MOS_SLIT::set_MASK_NAID "$checksum $maskid"
                       if { $debug } { puts stdout "maskid =[mos::MOS_SLIT::get_MASK_NAID]" }
                       }
                   }
                 3 {
                   # we expect number of STRAIGHT slits
                   set straight $line_org
                   if { $debug } { puts stdout "number of STRAIGHT=$straight" }
                   }
                 4 {
                   # we expect number of CIRCLE holes 
                   set circle $line_org
                   if { $debug } { puts stdout "number of CIRCLE  =$circle" }
                   }
           default {
                     # now we get the apertures, we make life easy. Instead of counting
                     # the slit numbers we decide via the number of parameters in line_org
                     #       3 parameters => CIRCLE
                     #  4 or 5 parameters => STRAIGHT
                     set np [llength [ldelete_all [split $line_org " "] ""] ]
                     if { $debug } { puts stdout "linecounter=[expr $lcounter-5] nofpar=$np" }

                     switch -exact -- $np {
                         0 { # empty line
                             puts stdout "empty line, do nothing"
                           }
                         3 {
                           # this must be a circle aperture
                           $this configure -mos_shape CIRCLE   
                           set b [ldelete_all [split $line_org " "] ""] 
                           set lx [lindex $b 0]
                           set ly [lindex $b 1]
                           set ld [lindex $b 2]
                           set lle $ld; set lro 0.0
                           if { $debug } { puts stdout "CIRCLE with x,y=($lx $ly) a,b=($ld,$lle) mm" }
                           }
                         4 -
                         5 {
                           # this must be a box aperture
                           $this configure -mos_shape STRAIGHT
                           set b [ldelete_all [split $line_org " "] ""]
                           set lx [lindex $b 0]
                           set ly [lindex $b 1]
                           set ld [lindex $b 2]
                           set lle [lindex $b 3]
                           set lro [lindex $b 4]
                           if { $debug } { puts stdout "STRAIGHT with x,y=($lx,$ly) l,w=($ld,$lle) >$lro< mm" }
                           }
                     default { puts stdout " wrong format in $filename" }
                     }

                     if {$np > 2} {
                        # if it was not an empty line, if the number of parameters was at least 3
                        set noms [mos::MOS_SLIT::nos]
                        if { $debug } { puts stdout "noms= $noms" }
                        if { $debug } { puts stdout "$lx $ly $EQX $ld $lle $lro $ff [$this cget -mos_shape]" }
                        if {$noms==$mnomos} {
                           info_dialog "Error: Cannot handle more than\n $mnomos MOS slits" .skycat1
                           return
                        }

                        # puts stdout "set a ...>[expr $noms +1]<"
                        set a [mos::MOS_SLIT C_mos[incr noms 1] \
                           $m_canvas $m_image $lx $ly \
                           -ff $ff \
                           -eqx $EQX \
                           -target_name aperture \
                           -slit_width  $ld \
                           -slit_length $lle \
                           -pos_ang     $lro  \
                           -shape [$this cget -mos_shape] \
                           -ON 1 \
                           -child $this ]

                        # puts stdout "..a"
                        set noms [mos::MOS_SLIT::nos]
                       # C_mos$noms status
                       # end of: must be an aperture definition
                     }
                   }
               }
          } else {
            if { [string match *MODS* $line_org] } {
               set i_flag 1
               if { $debug } { puts stdout "we found the MODS string" }
            }
          }

          }
        }
      }
      close $fileId

      update_and_replot

      set last [expr [string last "." $myfile] -1]
      set first [expr [string last "/" $myfile]  +1]
      set last_load_fn [string range $myfile $first $last]

      $this configure -file_name [lindex [split $last_load_fn "."] 2]

      catch {SP update }
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::save_TPX { } {

      # Modified 2007 10 10, R.H.
      # epsf-file is now created directly and not from modified gerber-file
      # coordinate transformation between XWindows and MMU has been changed
      # method calls:
      # 1. save_mos_RS274X: creates gerber file
      # 2. save_mos_PS: creates epsf file of mask image
      # 3. save_mos_TPX: creates .mms file
      # Modified 2007 10 31: technical mask issues removed (not used for MODS)
      # Modified 2008 08 08: foc and targ files removed

      # central function for saving a mms setup file
      # a catlog can be selected. slit positions will be compared
      # with catalog positons and the catalog target name will be stored 
      # together with the slit position information

      # initial file name without extension : 'mods.12.project'
      EXE begin
      set debug 0
      set num [expr [string length $instrument] - 1]
      # set filename [$this cget -modus][string index $instrument $num].$exposure_counter.[$this cget -file_name]
      set filename [$this cget -modus].$exposure_counter.[$this cget -file_name]
      set M [ string toupper [$this cget -modus] ]
      if { $debug } { puts "file: [$this cget -file_name], filename: $filename" }

      # check the reference targets and the guide stars
      set text "Save  : $filename\n\n" 
      set ref_fail [edit_ref_targ verify]
      set guid_fail [edit_guide_star verify]
      if {$ref_fail && $guid_fail} {
         append text "Ref Targ Verify: Failed ! \n\
                      Guide Star Verify: Failed !\n\Press  : \[Cancel\]"
         set deff 1
      } elseif {$ref_fail && !$guid_fail} {
         append text "Ref Targ Verify: Failed ! \n\
                      Guide Star Verify: Ok !\n\Press  : \[Cancel\]"
         set deff 1
      } elseif {!$ref_fail && $guid_fail} {
         append text "Ref Targ Verify: Ok ! \n\
                      Guide Star Verify: Failed !\n\Press  : \[Cancel\]"
         set deff 1
      } else {
         append text "Ref Targ Verify: Ok !\n\
                      Guide Star Verify: Ok !\n\Press  : \[Ok\]"
         set deff 0
      }

      set wid .skycat1.save
      catch {destroy $wid}
      set oldFocus [focus]
      set w [DialogWidget $wid \
         -text $text \
         -bitmap warning \
         -default $deff \
         -buttons { Ok Cancel } ]
      focus $w
      if { [$w activate] } return

      if {$debug} { puts stdout "\n store acquisition in -->$set_dir/$filename" }

      # find catalog name
      set sc [get_cat]
      if {$debug} { puts " catalog: $sc" }
      if {$sc == ""} {
         set CatFileName no_catalog
      } else {
         catch {catalog $sc }
         # catalog $sc
      }

      # mos::MOS_SLIT::set_mmff 1, i.e. slit positions are in mm
      if {[mos::MOS_SLIT::get_mmff]} {
         # the wcs of all slits (in mm) have to be determined
         # puts stdout "save_TPX: standard mask:: prepare save"

         # update canvas--mmff conversion
         mos::MOS_SLIT::coeff $XMIN $YMIN $field(xa) $field(ya) \
                              $XMAX $YMIN $field(xb) $field(yb) \
                              $XMAX $YMAX $field(xc) $field(yc)
         set noms [mos::MOS_SLIT::nos]
         if {$noms>0} {
            for {set i 1} {$i <= $noms} { incr i 1} {
                set refOut [C_mos$i M2W]; # x,y -> xc,yc -> ra,dec
                if {$refOut} {
                   if {$debug} { puts stdout "AAG PPRS 10127 - OutOfRange $i. Continuing" }
                   #TSZ remove slit:
                   C_mos$i erase
                   C_mos$i configure -ON 0
                   continue
                } else {
                   if {$debug} { puts stdout "AAG PPRS 10127 - InRange $i." }
                   set targw(1,a) [C_mos$i get_RA]
                   set targw(1,d) [C_mos$i get_DEC]
                   $m_image convert coords $targw(1,a) $targw(1,d) "wcs $EQX" targw(1,x) targw(1,y) image
                }
            }
         }
      }

      # mos::MOS_SLIT::set_mmff 0, i.e., we have a new multi-slit mask to store
      if { ![mos::MOS_SLIT::get_mmff] } {
         update_mask_id
         set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]
         if {$debug} { puts stdout "SAVE_TPX: sky       mask >$PM<" }
      }

      # new concept: the user cannot specify mask ids
      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]
      set a [lindex $PM 1]
      if { $debug } { puts "PM: $PM, id: $a" }


      # must be 900000 (default sky mask) or 900001-900100 (technical mask) 
      if {$a < 900101 && $a > 900000} {
         # technical mask
         # since it has been read from the adf, do not create a gerber file since this mask already exists and is available
         # save a setup with a technical mask, no gerber file required, no postscript file required
         puts stdout "Save technical mask without Gerber file"
      } else {
         # science mask with default mask id outside 900000 .. 900100
         save_mos_RS274X $filename
         save_mos_PS  $filename
         if {$debug} { puts stdout "save_TPX: gerber file saved, PS file saved" }
      }
      # TPX must be the last, since it increments the exposure counter
      save_mos_TPX $filename

      set last_action "Save SetUp"
      set last_save_fn $filename
      catch { SP update }
      # open a new log file
      open_log
      EXE end
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::save_mos_TPX { filename } {

      # Abstimmung mit load_mos_TPX !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      # saving current parameters
      # we save 3 files
      # <mode>.<expo_count>.<fits_name>.mms   -> SET
      # .mms contains all specified keywords, its the file to be loaded when [Load Mask] 

      EXE begin
      set debug 0

      # before we do anything we show the status of all mos slits
      if {$debug} {
         puts stdout "\n\n save_mos_TPX"
         puts stdout "save_mos_TPX: >[mos::MOS_SLIT::get_MASK_NAID]<"
         set noms [mos::MOS_SLIT::nos]
         if {$noms>0} {
            for {set i 1} {$i <= $noms} { incr i 1} {
                if {[C_mos$i cget -ON ]} {
                   if {[C_mos$i cget -ref_slit]} {
                      puts stdout [ format "#%2d %1d %14s %5.2f %5.2f %5.2f %8s" \
                        $i \
                        [C_mos$i cget -ON         ] \
                        [C_mos$i cget -target_name] \
                        [C_mos$i cget -slit_width ] \
                        [C_mos$i cget -slit_length] \
                        [C_mos$i cget -pos_ang    ] \
                        [C_mos$i cget -shape      ] \
                      ]
                   } else {
                      puts stdout [ format "#%2d %1d %14s %5.2f %5.2f %5.2f %8s %8s %8s" \
                        $i \
                        [C_mos$i cget -ON         ] \
                        [C_mos$i cget -target_name] \
                        [C_mos$i cget -slit_width ] \
                        [C_mos$i cget -slit_length] \
                        [C_mos$i cget -pos_ang    ] \
                        [C_mos$i cget -shape      ] \
                        [C_mos$i get_RA           ] \
                        [C_mos$i get_DEC          ] \
                      ]
                   }
                }
            }
         }
      }

      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]

      # open setupfile and write header 
      # set num [expr [string length $instrument] - 1]
      set num [expr [string length $instrument] - 1]
      set mod "[$this cget -modus][string index $instrument $num]"
      if {$filename==""} {
          set myfile "$set_dir/$mod.$exposure_counter.mms"
      } else { set myfile "$set_dir/$filename.mms" }

      # technical mask flag
      set tm [mos::MOS_SLIT::get_mmff]
      # science mask flag, in save_TPX, mmff = 0 before save_mxu_TPX is called
      set sm [expr ! $tm]

      set fileId [open $myfile w ];   # mms file
      puts $lfId "MOS::save_mos_TPX:  $fileId $myfile"; # log file

      # .mms header
      # -------------

      set header ""
      append header "# created by SKYCAT-TOOL -- MMS-plugin V$l_v\n"
      append header "# orig filename  : $filename : $myfile\n"
      puts stdout   "# orig filename  : $myfile"
      # append header "# user-date-host : [exec whoami] [exec date -u +%Y-%m-%dT%H:%M:%S] $lochost\n"
      append header "# user-date      : [exec whoami] [exec date -u +%Y-%m-%dT%H:%M:%S]\n"
      append header "# fits file      : [ [.skycat1 component image] cget -file]\n"
      append header "# fits instrument: [$m_image fits get INSTRUME]\n"
      append header "# fits origin    : [$m_image fits get ORIGIN]\n" 
      append header "# fits object    : [$m_image fits get OBJECT]\n" 
      append header "# catalog name   : $CatFileName\n"
      append header "# INS.MASK.NA    : [lindex $PM 0]\n"
      append header "# INS.MASK.ID    : [lindex $PM 1]\n"
      append header "# INS.MASK.NAID  : [lindex $PM 0]+[lindex $PM 1]\n"
      append header "# target setup for [$this cget -instrument]\n"
      append header "# --------------------------------------------\n\n"

      puts $fileId $header

      $m_image convert coords $world_x $world_y "deg $EQX" dummy_x dummy_y "wcs $EQX"

      #-------------------
      #  ------ TCS ------
      #-------------------

      lassign [split $dummy_x :] d1 d2 d3
      puts $fileId [format "TEL.TARG.ALPHA    %02s%02s%06.3f" $d1 $d2 $d3 ]
      lassign [split $dummy_y :] d1 d2 d3
      puts $fileId [format "TEL.TARG.DELTA    %02s%02s%06.3f" $d1 $d2 $d3 ]
      # puts $fileId [format "TEL.ROT.OFFANGLE  %6.3f" [expr $PAM * -1]  ]
      puts $fileId [format "TEL.ROT.OFFANGLE  %6.3f" $PAM ]
      puts $fileId [format "TEL.TARG.EQUINOX  %6.1f\n\n" $EQX ]

      # user-defined program ID and MASK.NAID
      # if {[lindex $PM 1]>900000}
      # save number of slits
      set noms [mos::MOS_SLIT::nos]
      set s_c 0; set sp_rsc 0;
      for {set i 1} {$i <= $noms} { incr i 1} {
          if {[C_mos$i cget -ON]} {
             incr s_c 1
             if {[C_mos$i cget -ref_slit]} { incr sp_rsc  1 }
          }
      }
      puts $fileId [format "INS.SLIT.NUMBER    %d\n" $s_c ]

      catch {SP update}
      puts $fileId [format "INS.RSLIT.NUMBER    %d" $sp_rsc ]

      # -----------------
      # --- slit loop ---
      # -----------------

      set s_c 100;     # science slit counter offset ?
      set r_c 1;       # reference slit counter offset
      if {$noms>0} {
         for {set i 1} {$i <= $noms} { incr i 1} {
             # if slit is specified
             if {[C_mos$i cget -ON]} {
              incr s_c 1

              # -1----------- NAME
              puts $fileId  [format "INS.TARG$s_c.NAME  %19s" [C_mos$i cget -target_name] ]

              # -2----------- Reference slits
              if {[C_mos$i cget -ref_slit]} {
                 puts $fileId [format "INS.SLIT%1d.REF %1d" $r_c $s_c]
                 incr r_c 1
              }

              # -3----------- SLIT DIMENSIONS in Ra/Dec
              set cu_width  [C_mos$i cget -slit_width ]
              set cu_length [C_mos$i cget -slit_length]
              set cu_posang [C_mos$i cget -pos_ang    ]
              set cu_shape  [C_mos$i cget -shape      ]


              # puts stdout  [format "INS.TARG$s_c.SHAPE  %19s"  $cu_shape  ]
              puts $fileId [format "INS.TARG$s_c.SHAPE  %19s"  $cu_shape  ]
              puts $fileId [format "INS.TARG$s_c.WID    %3.1f" $cu_width  ]
              puts $fileId [format "INS.TARG$s_c.LEN    %3.1f" $cu_length ]

              # slit position angle only for STRAIGHT
              if {[string match *STRAIGHT* $cu_shape]} {
                 # puts stdout  [format "INS.TARG$s_c.ROT    %3.1f" $cu_posang ]
                 puts $fileId [format "INS.TARG$s_c.ROT    %3.1f" $cu_posang ]
              }

              # save uncorrected values to .mms file to avoid iterative optical correction when load/save/load/save
              if { ![C_mos$i cget -ref_slit] } {
                 lassign [split [C_mos$i get_RA ] :] a1 a2 a3
                 lassign [split [C_mos$i get_DEC] :] d1 d2 d3
                 if { $debug } {
                    puts "save_mos_TPX: RA:  $a1:$a2:$a3"
                    puts "save_mos_TPX: DEC: $d1:$d2:$d3"
                 }
                 puts $fileId [format "INS.TARG$s_c.ALPHA  %02s%02s%06.3f" $a1 $a2 $a3]
                 puts $fileId [format "INS.TARG$s_c.DELTA  %02s%02s%06.3f" $d1 $d2 $d3]
              }

              #---------------SLIT DIMENSIONS in mm
              set slit [C_mos$i get_slit]
              set xmm [lindex $slit 0]
              set ymm [lindex $slit 1]
              set wmm [lindex $slit 2]
              set lmm [lindex $slit 3]

              puts $fileId [format "INS.TARG$s_c.WIDMM   %6.3f" $wmm]
              puts $fileId [format "INS.TARG$s_c.LENMM   %6.3f" $lmm]
              puts $fileId [format "INS.TARG$s_c.XMM     %7.3f" $xmm]
              puts $fileId [format "INS.TARG$s_c.YMM     %7.3f\n" $ymm]

            }
         }
      }

      puts stdout "[C_ref_targ nort] Reference Objects selected"

      # Reference Objects already in correct coords
      # save reference objects to setup file
      for { set j 1} {$j <= [C_ref_targ nort] } { incr j 1 } {
          set z [expr $j + 29]; # the INS.TARG$z. number
          lassign [split [C_ref_targ get $j a] :] a1 a2 a3
          puts $fileId [format "INS.TARG$z.ALPHA   %02s%02s%06.3f" $a1 $a2 $a3 ]

          lassign [split [C_ref_targ get $j d] :] d1 d2 d3
          puts $fileId [format "INS.TARG$z.DELTA  %02s%02s%06.3f\n" $d1 $d2 $d3]
      }

      #--------------------
      # reference targets end
      #--------------------

      puts stdout "[C_guide_star guid] Guide Stars selected"

      # Reference Objects already in correct coords
      # save reference objects to setup file
      for { set j 1} {$j <= [C_guide_star guid] } { incr j 1 } {
          set z [expr $j + 39]; # the INS.TARG$z. number
          lassign [split [C_guide_star get $j a] :] a1 a2 a3
          puts $fileId [format "INS.TARG$z.ALPHA   %02s%02s%06.3f" $a1 $a2 $a3 ]

          lassign [split [C_guide_star get $j d] :] d1 d2 d3
          puts $fileId [format "INS.TARG$z.DELTA  %02s%02s%06.3f\n" $d1 $d2 $d3]
      }

      #--------------------
      # guide stars end
      #--------------------

      puts $fileId [format "INS.RSTAR.NUMBER %1d\n" [C_ref_targ nort] ]


      #  save also grating, OS filter and camera
      puts $fileId [format "SEQ.PREP.MASK_NA %10s" [lindex $PM 0] ]
      puts $fileId [format "SEQ.PREP.MASK_ID %10s\n" [lindex $PM 1] ]
      puts $fileId [format "SEQ.PREP.LMIN   %8.3f" $user_lmin ]
      puts $fileId [format "SEQ.PREP.LCEN   %8.3f" $user_lcen ]
      puts $fileId [format "SEQ.PREP.LMAX   %8.3f" $user_lmax ]
      puts $fileId [format "SEQ.PREP.GRAT %10s" [$this cget -grating] ]
      puts $fileId [format "SEQ.PREP.FILT   %3s" [$this cget -filter] ]
      puts $fileId "SEQ.PREP.CAM   [$this cget -camera]"
      puts $fileId "SEQ.PREP.GOOD $good"

      close $fileId

      incr exposure_counter 1

      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::save_mos_RS274X { filename } {

      # Same data as in save_mos_RS274X are produced
      # Modified for compatibility with Rofin mask-cutting SW
      # Modified 2009 10 09, R.H.

      EXE begin
      set debug 0
      set THERMAL 1.000; # factor to compensate for thermal contraction:
                        # 1 for LUCIFER images (scale derived from mask pattern, thermal effect included in scale)
                        # 1.002245 for external images/catalogs, calculated value, to be tested!!!!!!!!!!!!!!!!!!
                          # correction will be applied to sci and ref slit positions only!!!!
      set sp [string compare [$m_image fits get INSTRUME] Lucifer]
      if { $sp } { set THERMAL 1.0000 }
      if { $debug } { puts "save_mos_RS274X: sp = $sp, THERMAL = $THERMAL" }
      set MM_X 120.;    # offset in mm of the mmu working table
      set MM_Y 120.;    # offset in mm of the mmu working table

      set string_g ""
      set C "\n"
      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]
      set noms [mos::MOS_SLIT::nos]

      if {$debug} {puts "save_mos_RS274X: writing info header"}
      set a "G04 created by SKYCAT-TOOL -- MMS-plugin V$l_v *"; append string_g $a$C
      set a "G04 orig filename  : $filename *"; append string_g $a$C
      set a "G04 MODS_MOS_162x162_[lindex $PM 1] *"; append string_g $a$C
      append string_g $C

      set a "%FSLAX33Y33*%"; append string_g $a$C
      set a "%MOMM*%"; append string_g $a$C
      set a "%SFA1.0B1.0*%"; append string_g $a$C

      # define slit apertures
      #----------------------
      append string_g $C
      set a "G04 Aperture Definition *"; append string_g $a$C
      set a "%ADD10C,0.0*%"; append string_g $a$C
      for {set i 1} {$i<=$noms} { incr i 1} {
         if { [C_mos$i cget -ON] } {
            if {[string length [C_mos$i get_add_mmu] ] } {
               set a [C_mos$i get_add_mmu]; append string_g $a$C
            }
         }
       }
      # number and centering slit apertures
      set a "%ADD501R,0.150X0.700*%"; append string_g $a$C
      set a "%ADD502R,0.700X0.150*%"; append string_g $a$C
      set a "%ADD521O,3.000X2.050*%"; append string_g $a$C;  # horizontal centering, oval 3x2.05 mm
      set a "%ADD522O,2.050X3.000*%"; append string_g $a$C;  # vertical centering, oval 2.05x3 mm
      append string_g $C

      # slits
      # -------------
      set a "%LNMASK*%"; append string_g $a$C
      set a "%LPD*%"; append string_g $a$C
      set a "G04 Slits *"; append string_g $a$C

      # we ask all slits on their size (width, length) and orientation (posang). 
      # Each rectangular slit with zero pos_angle will get its own aperture definition
      if {$debug} {puts "save_mos_RS274X: writing slits"}


      # y-coordinates in display start at upper left corner, y-coordinates in gerber file start at lower left corner
      # to get slit patterns correct, signs of y-coordinates have to be inverted
      set ad_counter 10
      set noms [mos::MOS_SLIT::nos]
      if {$noms>0} {
        for {set i 1} {$i <= $noms} { incr i 1} {
            # if slit is specified
            if {[C_mos$i cget -ON]} {
               set loc_shape [C_mos$i cget -shape]
               switch -exact -- $loc_shape {

               STRAIGHT {
                   # we have a non-deleted rectangular slit
                   set slit [C_mos$i get_slit]
                   set lw [F2G [lindex $slit 2] ]
                   set ll [F2G [lindex $slit 3] ]
                   set lang [F2G [C_mos$i cget -pos_ang] ]
                   if {[string length [C_mos$i get_add_mmu] ] } {
                      # slit not rotated, use flash command
                      set a "G54D[expr $i+$ad_counter]*"; append string_g $a$C
                      set slx [expr $MM_X + [lindex $slit 0]*$THERMAL]; set a "X[F2G $slx]"
                      set sly [expr $MM_Y - [lindex $slit 1]*$THERMAL]; append a "Y[F2G $sly]D03*"
                      append string_g $a$C
                   } else {
                      # slit rotated to parallelogram, use individual contour
                      set a "G54D10*"; append string_g $a$C
                      set slx [expr $MM_X + [lindex $slit 0]*$THERMAL]; set a "G01X[F2G $slx]"
                      set sly [expr $MM_Y - [lindex $slit 1]*$THERMAL]; append a "Y[F2G $sly]D03*"

                      set slit_dim [C_mos$i get_slit_contour]
                      set slx [expr ($slx + [lindex $slit_dim 0])]; set a "X[F2G $slx]"
                      set sly [expr ($sly - [lindex $slit_dim 1])]; append a "Y[F2G $sly]D02*"
                      append string_g $a$C

                      set slx [expr ($slx + [lindex $slit_dim 2] - [lindex $slit_dim 0])]; set a "X[F2G $slx]"
                      set sly [expr ($sly - [lindex $slit_dim 3] + [lindex $slit_dim 1])]; append a "Y[F2G $sly]D01*"
                      append string_g $a$C

                      set slx [expr ($slx + [lindex $slit_dim 4] - [lindex $slit_dim 2])]; set a "X[F2G $slx]"
                      set sly [expr ($sly - [lindex $slit_dim 5] + [lindex $slit_dim 3])]; append a "Y[F2G $sly]D01*"
                      append string_g $a$C

                      set slx [expr ($slx + [lindex $slit_dim 6] - [lindex $slit_dim 4])]; set a "X[F2G $slx]"
                      set sly [expr ($sly - [lindex $slit_dim 7] + [lindex $slit_dim 5])]; append a "Y[F2G $sly]D01*"
                      append string_g $a$C

                      set slx [expr ($slx + [lindex $slit_dim 0] - [lindex $slit_dim 6])]; set a "X[F2G $slx]"
                      set sly [expr ($sly - [lindex $slit_dim 1] + [lindex $slit_dim 7])]; append a "Y[F2G $sly]D01*"
                      append string_g $a$C

                   }
               }
               CIRCLE {
                   # we have a non-deleted circle aperture
                   set slit [C_mos$i get_slit]
                   set lw [F2G [lindex $slit 3] ]
                   # use flash command
                   set a "G54D[expr $i+$ad_counter]*"; append string_g $a$C
                   set slx [expr $MM_X + [lindex $slit 0]*$THERMAL]; set a "X[F2G $slx]"
                   set sly [expr $MM_Y - [lindex $slit 1]*$THERMAL]; append a "Y[F2G $sly]D03*"
                   append string_g $a$C
               }
               }
            }
         }
      }
      append string_g $C
      set a "G04 Mask ID *"; append string_g $a$C

      #--------------------------------------------------------------------------------------------------
      # mask id
      # -------------

      set maskid [lindex $PM 1]

      if {$noms>1000} { puts stdout "Error: number of apertures collides with maskid" }

      # this is a technical mask, create gerber file with mask id
      if {$debug} {puts "save_mos_RS274X: writing mask ID"}

      # this defines a new layer for the LPKF SW, MASK ID will be cut faster
      set x [expr -105.0+$MM_X]; set y [expr 103.0+$MM_Y]
      set dx 1.5
      set ax 0.5; set bx 1.0
      set ay 0.5; set by 1.5; set cy 1.0; set dy 2.0

      for {set k 0} {$k<=5} {incr k 1} {
         set ziffer [string index $maskid $k ]
         switch -exact -- $ziffer {
           0 {   puts -nonewline stdout  0
                 # ZERO
                 set a "G54D501*";                                          append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$ay]]D03*";                append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "G54D502*";                                          append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
           1 {   puts -nonewline stdout 1
                 # ONE
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$ay]]D03*";                append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set x [expr $x + $dx/2.]
             }
           2 {   puts -nonewline stdout 2
                 # TWO
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$ay]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
           3 {   puts -nonewline stdout 3
                 # THREE
                 set a "G54D501*";                                          append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "G54D502*";                                          append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
           4 {   puts -nonewline stdout 4
                 # FOUR
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set x [expr $x + $dx]
             }
           5 {   puts -nonewline stdout 5
                 # FIVE
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
           6 {   puts -nonewline stdout 6
                 # SIX
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$ay]]D03*";                append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
           7 {   puts -nonewline stdout 7
                 # SEVEN
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set x [expr $x + $dx]
             }
           8 {   puts -nonewline stdout 8
                 # EIGHT
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$ay]]D03*";                append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
           9 {   puts -nonewline stdout 9
                 # NINE
                 set a "G54D501*";                                           append string_g $a$C
                 set a "X[ F2G $x]Y[F2G [expr $y+$by]]D03*";                append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$by]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$bx]]Y[F2G [expr $y+$ay]]D03*";     append string_g $a$C
                 set a "G54D502*";                                           append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$dy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G [expr $y+$cy]]D03*";     append string_g $a$C
                 set a "X[ F2G [expr $x+$ax]]Y[F2G $y]D03*";                append string_g $a$C
                 set x [expr $x + $dx]
             }
          }
      }
      append string_g $C
      set a "G04 Centering Holes *"; append string_g $a$C


      # end of : includer mask id only for science masks

      puts stdout "\n"

      # -------------
      # centering holes and mask contour
      # -------------
      if {$debug} {puts "save_mos_RS274X: writing mask contour"}

      #cut centering holes on x-axis (horizontal)
      set a "G54D521*"; append string_g $a$C
      set a "X[F2G [expr 112.000+$MM_X]]Y[F2G $MM_Y]D03*"; append string_g $a$C
      set a "X[F2G [expr -112.000+$MM_X]]Y[F2G [expr -010.000+$MM_Y]]D03*"; append string_g $a$C
      # cut centering holes on y-axis (vertical)
      set a "G54D522*"; append string_g $a$C
      set a "X[F2G $MM_X]Y[F2G [expr 112.000 + $MM_Y]]D03*"; append string_g $a$C
      set a "X[F2G $MM_X]Y[F2G [expr -112.000 + $MM_Y]]D03*"; append string_g $a$C
      set a "G54D10*"; append string_g $a$C
      append string_g $C
      set a "G04 Mask Countour *"; append string_g $a$C

      set a "G01X[F2G [expr -115.000+$MM_X]]Y[F2G [expr -110.000+$MM_Y]]D02*"; append string_g $a$C
      set a "X[F2G [expr -110.000+$MM_X]]Y[F2G [expr -115.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr 25.000+$MM_X]]Y[F2G [expr -115.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr 25.000+$MM_X]]Y[F2G [expr -112.500+$MM_Y]]D01*"; append string_g $a$C
      set a "G75*"; append string_g $a$C
      set a "G02X[F2G [expr 29.000+$MM_X]]Y[F2G [expr -112.500+$MM_Y]]I2000J0D01*"; append string_g $a$C
      set a "G01X[F2G [expr 29.000+$MM_X]]Y[F2G [expr -115.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr 110.000+$MM_X]]Y[F2G [expr -115.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr 115.000+$MM_X]]Y[F2G [expr -110.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr 115.000+$MM_X]]Y[F2G [expr 110.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr 110.000+$MM_X]]Y[F2G [expr 115.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr -110.000+$MM_X]]Y[F2G [expr 115.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr -115.000+$MM_X]]Y[F2G [expr 110.000+$MM_Y]]D01*"; append string_g $a$C
      set a "X[F2G [expr -115.000+$MM_X]]Y[F2G [expr -110.000+$MM_Y]]D01*"; append string_g $a$C
      # end
      set a "M02*"; append string_g $a$C

      #  SAVE  --- gerber format --- for LPKF-SW
      set fn $filename
      set myfile $set_dir/$fn.gbr
      set fileId [open $myfile w ]
      puts -nonewline $fileId $string_g
      close $fileId
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::save_mos_PS { filename } {

      # Modified 2007 10 09, R.H.,
      # this program originally produced a gerber-file with coordinats offset for
      # conversion into an epsf file. Now we produce the epsf file directly in this
      # program, which is simplier than converting the gerber file.

      EXE begin
      set debug 0
      set THERMAL 1.0000; # correction for thermal mask contraction, applied to
                          # sci and reftarg slits only!
      # set MM_X 125.; set MM_Y 125.
      set MM_X 150.; set MM_Y 150.

      set string_p ""
      set C "\n"
      set PM [ldelete [split [mos::MOS_SLIT::get_MASK_NAID] " "] ""]
      set noms [mos::MOS_SLIT::nos]

      append string_p "%!PS-Adobe-3.0 EPSF-3.0\n"
      append string_p "%%BoundingBox: 0 0 300 300\n"
      append string_p "%%Title: MaskImage for MODS-MOS\n"
      append string_p "%%Filename: \$INS_ROOT/SYSTEM/COMMON/SETUPFILES/$filename.p_ps\n"
      append string_p "%%CreationDate: [exec date -u +%Y-%m-%dT%H:%M:%S]\n"
      append string_p "%%INS.MASK.NA    : [lindex $PM 0]\n"
      append string_p "%%INS.MASK.ID    : [lindex $PM 1]\n"
      append string_p "%%INS.MASK.NAID  : [lindex $PM 0]+[lindex $PM 1]\n"
      append string_p "%%EndComments\n"
      append string_p "1.0 1.0 scale\n"; # 1 default unit in ps is 1/72 inch
      # we ask all slits on their size (width, length) and orientation (posang).
      # Each rectangular slit with zero pos_angle will get its own aperture definition
      set ad_counter 10
      set noms [mos::MOS_SLIT::nos]
      if {$noms>0} {
         for {set i 1} {$i <= $noms} { incr i 1} {
            # if slit is specified
            if {[C_mos$i cget -ON]} {
            set loc_shape [C_mos$i cget -shape]
            switch -exact -- $loc_shape {

              STRAIGHT {
                    # we have a non-deleted rectangular slit
                    set slit [C_mos$i get_slit]

                    set lw [lindex $slit 2]; # lw and ll exchanged to comply with x->x, y->-y transform
                    set ll [lindex $slit 3]; #slit dimensions
                    set lang [C_mos$i cget -pos_ang]
                    if {[string length [C_mos$i get_add_mmu] ] } {
                       # slit not rotated
                       set x [lindex $slit 0]; set x [expr $x*$THERMAL + $MM_X - $lw*0.5]
                       set y [lindex $slit 1]; set y [expr -$y*$THERMAL + $MM_Y - $ll*0.5]
                       append string_p "$x $y moveto\n"
                       append string_p "$lw 0 rlineto 0 $ll rlineto -$lw 0 rlineto closepath\n"
                       if { $debug } { puts "slit not tilted, lower left corner: $x, $y" }
                    } else {
                       # slit tilted to parallelogram, use individual contour
                       set slit_dim [C_mos$i get_slit_contour]
                       set x [lindex $slit 0]; set x [expr $x*$THERMAL + $MM_X]
                       set y [lindex $slit 1]; set y [expr -$y*$THERMAL + $MM_Y]
                       set x1 [lindex $slit_dim 0]
                       set y1 [lindex $slit_dim 1]
                       set x2 [lindex $slit_dim 2]
                       set y2 [lindex $slit_dim 3]
                       set x3 [lindex $slit_dim 4]
                       set y3 [lindex $slit_dim 5]
                       set x4 [lindex $slit_dim 6]
                       set y4 [lindex $slit_dim 7]

                       append string_p "[expr $x - $x1] [expr $y - $y1] moveto\n"
                       append string_p "[expr -$x2 + $x1] [expr -$y2 + $y1] rlineto [expr -$x3 + $x2] [expr -$y3+$y2] \
                                         rlineto [expr -$x4 + $x3] [expr -$y4 + $y3] rlineto closepath\n"
                       if { $debug } {
                           puts "slit tilted, lower left corner: [expr -$x - $x1 + $MM_X], [expr -$y - $y1 + $MM_Y]"
                       }
                   }
            }
            CIRCLE {
                  # we have a non-deleted circle aperture
                  set slit [C_mos$i get_slit]

                  set lw [F2G [lindex $slit 3] ]
                  set x [expr [lindex $slit 0]*$THERMAL + $MM_X]
                  set y [expr -[lindex $slit 1]*$THERMAL + $MM_Y]
                  append string_p "$x $y 360 arc\n"
            }
            }

            }
         }
      }
      # ----------------------------------------------------------------------
      # mask centering holes
      # left
      append string_p "[expr 112.5 + $MM_X] [expr 1.0 + $MM_Y] moveto\n"
      append string_p "-1 0 rlineto [expr 111.5 + $MM_X] $MM_Y 1 90 270 arc 1 0 rlineto [expr 112.5 + $MM_X] $MM_Y 1 270 90 arc\n"
      # right
      append string_p "[expr -111.5 + $MM_X] [expr -9.0 + $MM_Y] moveto\n"
      append string_p "-1 0 rlineto [expr -112.5 + $MM_X] [expr -10.0 + $MM_Y] 1 90 270 arc 1 0 rlineto [expr -111.5 + $MM_X] [expr -10.0 + $MM_Y] 1 270 90 arc\n"
      #upper
      append string_p "[expr -1.0 + $MM_X] [expr 111.5 + $MM_Y] moveto\n"
      append string_p "0 1 rlineto [expr -2.0 + $MM_X] [expr 112.5 + $MM_Y] 1 0 180 arc 0 -1 rlineto \
                       [expr -2.0 + $MM_X] [expr 111.5 + $MM_Y] 1 180 0 arc\n"
      # lower
      append string_p "[expr -3.0 + $MM_X] [expr -111.5 + $MM_Y] moveto\n"
      append string_p "0 -1 rlineto [expr -2.0 + $MM_X] [expr -112.5 + $MM_Y] 1 180 0 arc 0 1 rlineto \
                       [expr -2.0 + $MM_X] [expr -111.5 + $MM_Y] 1 0 180 arc\n"

      append string_p "0 setlinewidth stroke\n"

      # mask contour
      append string_p "[expr -115 + $MM_X] [expr -110 + $MM_Y] moveto\n"
      # append string_p "5 -5 rlineto 148 0 rlineto 0 2.5 rlineto 4 0 rlineto 0 -2.5 rlineto 68 0 rlineto\n"
      append string_p "5 -5 rlineto 135 0 rlineto 0 2.5 rlineto\n"
      append string_p "[expr 27 + $MM_X] [expr -112.5 + $MM_Y] 2 180 0 arcn\n"
      append string_p "0 -2.5 rlineto 81 0 rlineto\n"
      append string_p "5 5 rlineto 0 220 rlineto\n"
      append string_p "-5 5 rlineto -220 0 rlineto\n"
      append string_p "-5 -5 rlineto 0 -220 rlineto\n"
      append string_p "0.2 setlinewidth stroke\n"
      append string_p "%%EOF\n"

      #  SAVE  --- ps file ---------------
      set myfile $set_dir/$filename.epsf
      set fileId [open $myfile w ]
      puts -nonewline $fileId $string_p
      close $fileId

      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::get_cat {} {

      # gets all AstroCat widgets, send the list to select_cat and returns
      # the selected catalog

      EXE begin
      # what does this part? gc is replaced in the second part without being used!
      set gc [itcl::find objects -class ::skycat::SkySearch]
      set gc [split $gc " " ]
      set ll [llength $gc]

      if {$ll>1} { set gc [select_cat $gc] }
      EXE end
      return $gc
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::catalog { a_c } {

      # 1) get the target list from the Astrocat widget
      # 2) compare entries with the list of slit positions just selected
      # 3) delete the selected entries in the target list
      # 4) put reduced target list back to AstroCat widget 
      # use two times the MOS slit width 
      # puts stdout "in catalog with $a_c"

      EXE begin
      set debug 0
      set error_box [expr [$this cget -slit_width] * 2.0 ]
      set error_box [expr $error_box * 2.7777778e-4]
      puts $lfId "CatalogInterface: ErrorBox = [expr $error_box / 2.7777778e-4] ''"
      # puts stdout "----------------------------"
      # if you use more than one catalog

      # 1) get the target list from the AstroCat widget
      # default, the first created AstroCat instance
      # puts stdout [set ac [itcl::find objects -class ::skycat::SkyCat] ]
      # search the current AstroCat instance

      set cur [$a_c info variable current_instance_]
      set hea [$a_c info variable headings_]
      set instance [$a_c info variable instance_idx_]
      if { $debug } { puts "catalog: current instance = $cur, \n headings = $hea, \n instance_idx_ = $instance" }
      set hea [lindex $hea 4]
      if { $debug } { puts "catalog: headings(4)= $hea" }
      set filename [lindex $instance 4]
      set filename [split $filename ","]
      set filename [lindex $filename 0]
      if { $debug } {puts "catalog: reduced filename = $filename" }

      puts $lfId "CatalogInterface: catname  = $a_c"
      puts $lfId "CatalogInterface: filename = $filename"
      set CatFileName $filename 

      set loc_list [$a_c info variable info_] 
      if {$debug} { puts "catalog: loc_list = $loc_list<<" }
      set loc_list [lindex $loc_list 4]
      if {$debug} { puts "catalog: loc_list(4) = $loc_list<<" }

      # scratch those targets in the catalog which are in mos

      # 2) compare the target list with the just selected slit positions
      if {$debug} { puts stdout "CatalogInterface: search in list ... "}
      set found_list ""
      set rest_list $loc_list
      set work_list $loc_list
      set found_counter 0
      set max [mos::MOS_SLIT::nos]

      for {set i 7} {$i <= $max} {incr i 1} {
         set on [C_mos$i cget -ON]
         if {$on} {
             if {$debug} { puts stdout "search for \#$i with $on"}
             set loc_RA  [C_mos$i get_RA]
             set loc_DEC [C_mos$i get_DEC]
             $m_image convert coords $loc_RA  $loc_DEC "wcs $EQX" aa dd "deg $EQX"
             # aa dd are RA DEC of selected slit in deg 
             if {$debug} {puts stdout "\#$i $loc_RA $loc_DEC -> ($aa,$dd)" }
             # now search in the target list for coord coincidence
             set list_counter 0
             set free 1
             foreach star $work_list {
               if {$free} {
                  if {$debug} {
                     puts stdout $star
                     puts stdout "[lindex $star 1] [lindex $star 2]"
                  }
                  $m_image convert coords [lindex $star 1] [lindex $star 2] "wcs $EQX" alp dec "deg $EQX"
                  if {$debug} { puts stdout "a=$alp d=$dec"}
                  # alp dec are RA DEC of current test target, calculate distance between target and cat entry
                  # assume simple linear scale, and constant cos(dec)
                  set dec [expr $dec - $dd]
                  set alp [expr ($alp - $aa)*cos($dd)]
                  if {$debug} { puts stdout "Da= [expr $alp*3600]''  Dd=[expr $dec*3600]''" }
                  set dec [expr $dec*$dec]
                  set alp [expr $alp*$alp]
                  set dec [expr sqrt($dec+$alp)]
                  if {$dec<$error_box } {
                      # coord coincidence !!!!!!!!!!!!
                      puts $lfId "CI: \#$i ($loc_RA,$loc_DEC) ($aa,$dd) with \
                             [lindex $star 0] ([lindex $star 1],[lindex $star 2]) \
                              within [expr $dec*3600] ''"
                      set rest_list [lreplace $work_list $list_counter $list_counter]
                      if {$debug} { puts stdout "[llength $work_list] - 1 = [llength $rest_list]" }
                      #  element $list_c replaced by nothing  -> reduced list
                      # transfer the target name
                      C_mos$i configure -target_name [lindex $star 0]
                      # and add to found list
                      lappend found_list [lindex $work_list $list_counter]
                      incr found_counter 1
                      set free 0
                      # dont assign further names to slit
                  }  ; # end coincidence
                  incr list_counter 1
               } ; # free 
             } ; # list loop (foreach star)

             # update the working list, reduce it by 1
             set work_list $rest_list
             # keep this for later purposes
         }
         puts stdout [ format "CatalogInterface: Slit \#%2d %s" $i [C_mos$i cget -target_name] ]
      }
      puts stdout "CatalogInterface: initial : [llength $loc_list], \
          found-and-purged : [llength $found_list], \
                 remaining : [llength $rest_list]"
      puts $lfId "CatalogInterface: $found_counter objetcs identified"

      # 4) delete, the found_list from the target_list
      set a [$a_c query_done "" $hea $rest_list 0]

      puts stdout "CatalogInterface: end"
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::select_cat { sc } {

      # show the filenames instead of the internal widget names

      EXE begin
      set allnames ""
      foreach w $sc {
          set filename [lindex [$w info variable instance_idx_ ] 4 ]
          set filename [split $filename ","]
          set filename [lindex $filename 0 ]
          if {[string match */* $filename]} {
              set filename [split $filename "/" ]
              set ll [llength $filename]
              set filename [lindex $filename [expr $ll-1] ]
          } else {
              set filename "{$filename}"
          }
          set allnames "$allnames $filename"
      }

      # show the List dialog
      set wid .skycat1.ld
      catch {destroy $wid}
      set ld_flag [ ListDialog $wid \
            -text "Select catalog :" \
            -choice $allnames \
            -modal 0 ]
      #choice should be the tail of the file name

      # and return the internal widget name again
      set s [$ld_flag activate]
      puts stdout "selected : >$s<"
      foreach w $sc {
         set test [lindex [$w info variable instance_idx_ ] 4 ]
         if { [string match *$s* $test ] } { return $w }
      }
      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::select_filename  { } {

      global .waf
      EXE begin

      if [catch {wm deiconify .waf}] {
          EntryForm .waf \
           -title "ProjectName (8 chars)" \
           -labels {ProjectName} \
           -command  "$this configure -file_name" \
           -values  [$this cget -file_name]
      } else {
         .waf configure -values [$this cget -file_name]
      }
      tkwait window .waf

      set last_action "Set ProjectName"
      catch {SP update}
   }


#----------------------------------------------------------------------------------
   ::itcl::body MOS::get_fits_name { } {

      # get the name of the fits file w.o. extension as an initial project name
      EXE begin
      set name [$m_image cget -file]
      if {$name==""} { set name "no_frame" }
      set a [split $name "/" ];                      # split by directory
      set a [lindex $a [expr [llength $a] - 1 ] ];   # get last
      set a [split $a "."];                          # split by dot
      set a [lindex $a 0 ];                          # get first
      EXE end
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::get_ec { mode } {

      # get exposure counter, scan setupfile directory with mode filter
      # set ec to the preceeding value; ls -1 returns the file names only

      EXE begin
      set local_dir "$set_dir/"
      if [ catch { set a [exec ls -1 $local_dir | grep $mode ] } result ] {
         puts "$result\nNo setup files found ; set expo-counter 1"
         set exposure_counter 1
      } else {
         set a [split $a \n ]
         set exposure_counter 0
         for {set i 0} {$i < [llength $a]} {incr i 1} {
             # puts stdout ">[lindex $a $i]<"
             set part [split [lindex $a $i] . ] 
             for {set j 0} { $j < [llength $part]} {incr j 1} {
                 set test [lindex $part $j]
                 if {[scan $test {%d} nr]} {
                   if {$nr>$exposure_counter} { set exposure_counter $nr }
                 }
             }
         }
         incr exposure_counter 1
      }
      EXE end
      return $exposure_counter
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::body MOS::open_log { } {

      # close the log file for the constructor and open 
      # a new log-file for the user commands

      EXE begin
      close $lfId
      set num [string length $instrument]
      set mod [$this cget -modus][string index $instrument [expr $num-1]]
      set log_file $log_dir
      append log_file "/$mod.$exposure_counter.log"
      # puts "open_log: logfile: $log_file"
      set lfId [open $log_file w]
      EXE end
   }





#----------------------------------------------------------------------------------
# Error handling procs

#----------------------------------------------------------------------------------
   ::itcl::body MOS::ERR {string_} {
      if {$_ON(e)} {
         puts "${_INDENT}$_CHARS(e)$_CHARS(e) ERROR: $string_"
      }
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::WARN {string_} {
      if {$_ON(e)} {
         puts "${_INDENT}$_CHARS(w)$_CHARS(w) WARNING: $string_"
      }
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::COMM {string_} {
      if {$_ON(e)} {
         puts "${_INDENT}$_CHARS(c)$_CHARS(c) COMMENT: $string_"
      }
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::SET_FLAGS {flags_ val_} {
      if {$flags_=="all"} {
         foreach type "x e w c" { set _ON($type) $val_ }
      } else {
         foreach type "x e w c" {
            if { [string first $type $flags_] != -1} { set _ON($type) $val_ }
         }
      }
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::EXE {where_} {
      set callingMethod [lindex [info level [expr [info level] -1]] 0]
      set commandName [uplevel [list namespace which $callingMethod]]
      if {$_ON(x)} {
         if { $where_=="begin"} {
            puts "$_INDENT$commandName"
            puts "$_INDENT\{"
            set _INDENT "$_INDENT$_PAD"
         } elseif {$where_== "end"} {
            set _INDENT [string range $_INDENT 3 end]
            puts "$_INDENT\}"
         }
      }
   }

#----------------------------------------------------------------------------------
   ::itcl::body MOS::debg {varname_ index_ ops_} {
      upvar $varname_ localCopy
      set command [info level [expr [info level] - 1]]
      puts "Command:  \"$command\"\n New value for $varname_:\ \"$localCopy\""
   }


# Error handling END --------------------------------------------------------------






# VARIABLE BODIES --------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------------------
   ::itcl::configbody MOS::file_name {

      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::file_name .................."}
      set file_name [string_delete $file_name " " ]
      set file_name [string_delete $file_name "." ]
      set file_name [string_delete $file_name "," ]
      set file_name [string_delete $file_name "*" ]
      set file_name [string_delete $file_name "-" ]
      set file_name [string_delete $file_name "+" ]
      set file_name [string_delete $file_name "_" ]
      set file_name [string_delete $file_name "=" ]
      set file_name [string_delete $file_name ")" ]
      set file_name [string_delete $file_name "(" ]
      set file_name [string_delete $file_name "\[" ]
      set file_name [string_delete $file_name "\]" ]
      set file_name [string range $file_name 0 7]
      puts $lfId "new file name $file_name"

      if {![mos::MOS_SLIT::get_mmff]} { update_mask_na }
      EXE end
   }


#-------------------------------------------------------------------------------------------------
   ::itcl::configbody MOS::camera {

      # Modified R.H. 2007 09 04
      # Modes removed
      # 09 10: renamed from collimat to camera, required changes also in menu, status panel and skycat_plugin

      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::camera .................."}
      if {$mask_initialized} {
         erase
         plot_mask
      } else {
         # mask not initialized = first coll by constructor
      }
      # now independent of mask_initialized or not
      wave_limit
      wave_config_mask "user_lmin user_lcen user_lmax grating"

      # puts stdout "cam: [$this cget -camera]"
      puts $lfId   "cam: [$this cget -camera]"
      set last_action "Select Camera"
      catch {SP update}
      EXE end
   }

#-------------------------------------------------------------------------------------------------
    ::itcl::configbody MOS::modus {

      # Modified R.H. 2007 09 04
      # Modes removed
      # collimator enabled
      # menu re-definition moved to fors1_menu
      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::modus .................."}
      set cam [$this cget -camera]; set new_cam $cam
      # update
      if {[string compare $cam $new_cam]} { $this configure -camera $new_cam }
      set mask mos
      $m_mb.layout entryconfigure 5 -state normal; # enable camera menue
      $m_mb.layout.ls invoke 0;                    # set slit type STRAIGHT
      # why do we only init camera and slit type here, we should also set slit length and width to default value

      puts stdout "modus: [$this cget -modus] with mask $mask"
      puts $lfId   "modus: [$this cget -modus] with mask $mask"
      catch {SP update}
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::configbody MOS::label {

      EXE begin
      set debug 0
      if { $debug } { puts "configbody MOS::label: [$this cget -label]"}
      puts $lfId "label: [$this cget -label]"

      if {$mask_initialized} {
         mos::MOS_SLIT::label $label
         erase
         plot_mask
      }
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::configbody MOS::mos_shape {

      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::mos_shape....................." }
      puts $lfId   "MOS aperture type: [$this cget -mos_shape]"
      set last_action "Select MOS Slit Type"
      catch  {SP update}
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::configbody MOS::pics {

      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::pics................." }
      catch {SP update}
      # the center-slit option calls the
      # pickObject widget
      puts $lfId   "center/slit flag : [$this cget -pics]"
      if {$mask_initialized} { update_and_replot }
      if {$pics==1} {center_slit}
      EXE end
   }

#-------------------------------------------------------------------------------------------------
   ::itcl::configbody MOS::slit_width {

      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::slit_width..............." }
      set noms [mos::MOS_SLIT::nos]
      if { $debug } { puts "slit width changed to [$this cget -slit_width] after slit $noms" }
      # puts stdout "width: [$this cget -slit_width]"
      puts $lfId   "width: [$this cget -slit_width]"
      set last_action "Select Slit Width"
      catch {SP update}
      EXE end
   }

# -----------------------------------------------------------------------------------------
   ::itcl::configbody MOS::slit_length {

      # Modified R.H. 2007 09 05
      # Modes removed, default changed from real to 6.0

      EXE begin
      set debug 0
      if {$debug} { puts "configbody MOS::slit_length............." }
      set noms [mos::MOS_SLIT::nos]
      if { $debug } { puts "slit length changed to [$this cget -slit_length] after slit $noms" }
      set last_action "Select Slit Length"
      catch {SP update}
      EXE end
   }


# -----------------------------------------------------------------------------------------
   ::itcl::configbody MOS::filter {

      # Modified R.H. 2007 09 04
      # Mode switch removed
      # 09 05: user_lmin, user_lmax redefined

      EXE begin
      # search in the dispersion table
      set debug 0
      set good 0
      if {$debug} { puts "Configuring the band filter: \n input: filter= $filter, grating= $grating\n" }

      if { [string match $filter blue] } {
         $m_mb.layout.gr entryconfigure 0 -state normal
         $m_mb.layout.gr entryconfigure 1 -state normal 
         $m_mb.layout.gr entryconfigure 2 -state disabled
         $m_mb.layout.gr entryconfigure 3 -state disabled
         set grating GRATING1
      } elseif { [string match $filter red] } {
         $m_mb.layout.gr entryconfigure 0 -state disabled
         $m_mb.layout.gr entryconfigure 1 -state disabled
         $m_mb.layout.gr entryconfigure 2 -state normal
         $m_mb.layout.gr entryconfigure 3 -state normal
         set grating GRATING3
      } else {
         puts "undefined filter!!!!!!!!!!!\n configuration stopped"
         return
      }
      if {$debug} { puts "default filter/grating combination selected: $filter / $grating" }

      for {set i 1} { $i<=$A_disp(0)} { incr i 1 } {
          if {[string compare $grating $A_disp($i,grating)]==0 && [string compare $filter $A_disp($i,filter)]==0} { set good $i }
#          if {$debug} { puts "i = $i, good = $good, A_disp($i,grating) = $A_disp($i,grating), A_disp($i,filter) = $A_disp($i,filter)" }
      }

      if {$good == 0} {
         set warn ">> Filter/Grating combination not found"
         warn_filtgrat
      } else { set warn ">> filter/grating combination found ok" }
      if {$debug} { puts stdout [format "filter: %s, good: %2d, %s" [$this cget -filter] $good $warn] }
      set i [string length $grating]
      set i [expr $i - 1]
      set i [string index $grating $i]
      set i [expr $i - 1]
      puts "i = $i"
      $m_mb.layout.gr invoke $i; # this command configures the grating!!!!!
      puts "grating submenu $i invoked"

      puts $lfId   "filter: [$this cget -filter]"
      set last_action "Select Filter"
      catch {SP update}
      EXE end
   }


# -----------------------------------------------------------------------------------------
   ::itcl::configbody MOS::grating {

      # Modified R.H. 2007 09 04
      # Mode switch removed
      # Special grisms removed
      # 09 05: user_lmin, user_lmax redefined

      EXE begin
      # search in the dispersion table
      set debug 0
      set good 0


      if {$debug} { puts "grating input: grating = $grating, filter = $filter \n" }
      for {set i 1} { $i<=$A_disp(0)} { incr i 1 } {
           if {[string compare $grating $A_disp($i,grating)]==0 && [string compare $filter $A_disp($i,filter)]==0} { set good $i }
#           if {$debug} { puts "i: = $i, good = $good, A_disp($i,grating) = $A_disp($i,grating), A_disp($i,filter) = $A_disp($i,filter)" }
      }

      if {$good == 0} {
         set warn ">> Grating/Filter combination not accepted"
         warn_filtgrat
      } else { set warn " status ok " }
      if {$debug} { puts stdout [format "grating : %s, good: %2d, %s" [$this cget -grating] $good $warn] }

      # specify the wavelength limits
      set user_lmin $A_disp($good,min)
      set user_lcen $A_disp($good,cen)
      set user_lmax $A_disp($good,max)
      wave_limit
      wave_config_mask "$user_lmin $user_lcen $user_lmax grating"

      puts $lfId   "grating: [$this cget -grating]"
      set last_action "Select Grating"
      catch {SP update}
      EXE end
   }

}
# End namespace mos
